(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    399753,       8317]
NotebookOptionsPosition[    397944,       8280]
NotebookOutlinePosition[    398338,       8296]
CellTagsIndexPosition[    398295,       8293]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "\"\<Global`*\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Id", "=", 
   RowBox[{"IdentityMatrix", "[", "3", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"A", "[", "t_", "]"}], ":=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"A11", "[", "t", "]"}], 
       RowBox[{"A12", "[", "t", "]"}], 
       RowBox[{"A13", "[", "t", "]"}]},
      {
       RowBox[{"A21", "[", "t", "]"}], 
       RowBox[{"A22", "[", "t", "]"}], 
       RowBox[{"A23", "[", "t", "]"}]},
      {
       RowBox[{"A31", "[", "t", "]"}], 
       RowBox[{"A32", "[", "t", "]"}], 
       RowBox[{"A33", "[", "t", "]"}]}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"G", "[", "t_", "]"}], ":=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"A", "[", "t", "]"}], "\[Transpose]"], ".", 
     RowBox[{"A", "[", "t", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"devG", "[", "t_", "]"}], ":=", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"G", "[", "t", "]"}], "-", 
     RowBox[{
      FractionBox["1", "3"], 
      RowBox[{"Tr", "[", 
       RowBox[{"G", "[", "t", "]"}], "]"}], "Id"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"S", " ", "[", "t_", "]"}], ":=", 
   RowBox[{"Simplify", "[", " ", 
    RowBox[{
     FractionBox[
      RowBox[{"-", "3"}], "\[Tau]"], 
     SuperscriptBox[
      RowBox[{"Det", "[", 
       RowBox[{"A", "[", "t", "]"}], "]"}], 
      RowBox[{"5", "/", "3"}]], 
     RowBox[{
      RowBox[{"A", "[", "t", "]"}], ".", 
      RowBox[{"devG", "[", "t", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Tau]", "=", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"X", "[", "t_", "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"A", "[", "t", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"F", "[", "t_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"c", " ", 
      RowBox[{"A11", "[", "t", "]"}]}], ",", "0", ",", "0", ",", 
     RowBox[{"c", " ", 
      RowBox[{"A21", "[", "t", "]"}]}], ",", "0", ",", "0", ",", 
     RowBox[{"c", " ", 
      RowBox[{"A31", "[", "t", "]"}]}], ",", "0"}], "}"}]}], ";", " ", 
  RowBox[{"c", "=", "0.1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Src", "[", "t_", "]"}], ":=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"S", "[", "t", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EQN", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"X", "[", "t", "]"}], ",", "t"}], "]"}], "+", 
      RowBox[{"F", "[", "t", "]"}]}], "==", 
     RowBox[{"Src", "[", "t", "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"IC", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"X", "[", "0", "]"}], "==", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
        "0", ",", "1"}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ODE", "=", 
   RowBox[{"Union", "[", 
    RowBox[{"EQN", ",", "IC"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", "rule", "}"}], "=", 
  RowBox[{"NDSolve", "[", 
   RowBox[{"ODE", ",", 
    RowBox[{"X", "[", "t", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"A12", "[", "t", "]"}], "/.", "rule"}], ",", 
     RowBox[{
      RowBox[{"A21", "[", "t", "]"}], "/.", "rule"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", "\"\<Expressions\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"A11", "[", "t", "]"}], "/.", "rule"}], ",", 
     RowBox[{
      RowBox[{"A22", "[", "t", "]"}], "/.", "rule"}], ",", 
     RowBox[{
      RowBox[{"A33", "[", "t", "]"}], "/.", "rule"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", "\"\<Expressions\>\""}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.8861555993723593`*^9, 3.886155668867002*^9}, {
   3.886155709237698*^9, 3.886155899144112*^9}, {3.8861559303079777`*^9, 
   3.8861559410994473`*^9}, 3.886156024344249*^9, {3.88615605979698*^9, 
   3.8861560759711018`*^9}, {3.886156142957856*^9, 3.886156147389453*^9}, {
   3.886156183110117*^9, 3.886156206444399*^9}, {3.886156238630481*^9, 
   3.886156241203883*^9}, {3.886156326629884*^9, 3.8861563286273813`*^9}, {
   3.886156412696507*^9, 3.8861567025733633`*^9}, {3.886156794701951*^9, 
   3.886156805483914*^9}, {3.886156881124879*^9, 3.886156939588029*^9}, {
   3.886157020222866*^9, 3.8861570577443533`*^9}, 3.8861574864545*^9, {
   3.886157565120078*^9, 3.886157729334002*^9}, {3.886157935544413*^9, 
   3.886157935694285*^9}, {3.886161479226817*^9, 3.8861615005773687`*^9}},
 CellLabel->
  "In[482]:=",ExpressionUUID->"5c1787ea-a192-4337-8cb7-fabde9e82c3f"],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"A11", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj7////////vPzd0wYnD
3cQ/WjhtP7r/7z/SUFjDa77VP29w1VTR/u8/IqE47Akn4D/Dvp4JZP3vP9Wb
k3tZVOU/1yakW3P77z+7wbiC/fHqPz5GEYK9+O8/gEqXStgX8D+7XxFtpPXv
P7tJtw/c7vI/5z2MW6rx7z/ziT6Xnbj1PwbM7XQi7e8/2iBupGZS+D8nQxFU
WejvP1rNgu1ZJPs/9ir9w4zi7z+J0D+8VMb9P8pSX12Q3O8/WwqypoYtAECS
fTDpKNbvPz63Ng34kwFAIxehlJzO7z94j482beICQMIrQ5QBx+8/f/LaffdM
BEDnGT9FJr7vPwX2WabgsAVAr76d5NW07z/iJK2RzfwGQI0RVNCYq+8/jN7y
ms9kCECkpIeP+aDvP43DDGfVtAlAhDf5/X6W7z9bMxlR8CALQOpcb/eGiu8/
p0NZHGqGDEBGlNbRJ37vP0t/barn0w1AP9G+cA9y7z+8RXRWej0PQBoPjPtX
ZO8/wpunYohHEEDUKoO8+FbvP+XkrgoD7RBACNGhRlVJ7z9vc69BiKARQJ6T
EDDyOe8/pRcaWg9IEkDJETtoCCvvP0EBfgGh/RJAyLDbTEQa7z8cu3sZ4q8T
QBVGY7EyCe8/oorjEiVWFEDO8e0tvPjuP4+fRJtyChVA8EHtjUrm7j8oyg8F
wrIVQOUvgVOF1O4/AMV038BXFkA6Yts6lcLuPz4F00jKChdAckvdVoqu7j8o
W5uT1bEXQL5d8I5Mm+4/ePZcbetmGEDSP4L+2YXuP3SniCgDEBlA9Vyj2EVx
7j+vKE5UyrUZQIWOD/GUXO4/Ue8MD5xpGkD84Sn/j0XuP5/LNatvERtAxKWE
EIov7j9T7VfWTccbQPJ7KncWF+4/R98Tctt5HEBgT5mtff7tP+bmOe9qIB1A
2xd2HwXn7T/rM1n7BNUdQDZuV5X/zO0/nJbi6KB9HkDHlJZJK7TtP4zJBUfs
Ih9AWg1M3FOb7T/iQSI0QtYfQM8QK0nRf+0/8mdUAc0+IECJeH73n2XtP6ZR
FDB+mSBAhtTixqpI7T96IyEXh/IgQAIji5yqK+0/JADj7pBFIUCHbvMsHBDt
P4F/IQ6gnyFASzxSv6vx7D+0CRUesPMhQLLGQcK91Ow/mjaFdcVOIkDvqLCJ
1bTsP59LQoUyqCJAuc3oH/GU7D96a7SFoPsiQHXNv1avduw/CC6jzRNWI0Ca
uIbfVVXsP2z7RgaIqiNANqkFma817D8yFFD6//8jQJHC1PUnFew/erPaPw==

                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27509#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, 
                    AxesOrigin -> {0, 0.8775825311077644}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0.8775825311077644}, DisplayFunction :> 
                    Identity, Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {0.8775825311077644, 
                    0.9999999999999999}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj7////////vPzd0wYnD
3cQ/WjhtP7r/7z/SUFjDa77VP29w1VTR/u8/IqE47Akn4D/Dvp4JZP3vP9Wb
k3tZVOU/1yakW3P77z+7wbiC/fHqPz5GEYK9+O8/gEqXStgX8D+7XxFtpPXv
P7tJtw/c7vI/5z2MW6rx7z/ziT6Xnbj1PwbM7XQi7e8/2iBupGZS+D8nQxFU
WejvP1rNgu1ZJPs/9ir9w4zi7z+J0D+8VMb9P8pSX12Q3O8/WwqypoYtAECS
fTDpKNbvPz63Ng34kwFAIxehlJzO7z94j482beICQMIrQ5QBx+8/f/LaffdM
BEDnGT9FJr7vPwX2WabgsAVAr76d5NW07z/iJK2RzfwGQI0RVNCYq+8/jN7y
ms9kCECkpIeP+aDvP43DDGfVtAlAhDf5/X6W7z9bMxlR8CALQOpcb/eGiu8/
p0NZHGqGDEBGlNbRJ37vP0t/barn0w1AP9G+cA9y7z+8RXRWej0PQBoPjPtX
ZO8/wpunYohHEEDUKoO8+FbvP+XkrgoD7RBACNGhRlVJ7z9vc69BiKARQJ6T
EDDyOe8/pRcaWg9IEkDJETtoCCvvP0EBfgGh/RJAyLDbTEQa7z8cu3sZ4q8T
QBVGY7EyCe8/oorjEiVWFEDO8e0tvPjuP4+fRJtyChVA8EHtjUrm7j8oyg8F
wrIVQOUvgVOF1O4/AMV038BXFkA6Yts6lcLuPz4F00jKChdAckvdVoqu7j8o
W5uT1bEXQL5d8I5Mm+4/ePZcbetmGEDSP4L+2YXuP3SniCgDEBlA9Vyj2EVx
7j+vKE5UyrUZQIWOD/GUXO4/Ue8MD5xpGkD84Sn/j0XuP5/LNatvERtAxKWE
EIov7j9T7VfWTccbQPJ7KncWF+4/R98Tctt5HEBgT5mtff7tP+bmOe9qIB1A
2xd2HwXn7T/rM1n7BNUdQDZuV5X/zO0/nJbi6KB9HkDHlJZJK7TtP4zJBUfs
Ih9AWg1M3FOb7T/iQSI0QtYfQM8QK0nRf+0/8mdUAc0+IECJeH73n2XtP6ZR
FDB+mSBAhtTixqpI7T96IyEXh/IgQAIji5yqK+0/JADj7pBFIUCHbvMsHBDt
P4F/IQ6gnyFASzxSv6vx7D+0CRUesPMhQLLGQcK91Ow/mjaFdcVOIkDvqLCJ
1bTsP59LQoUyqCJAuc3oH/GU7D96a7SFoPsiQHXNv1avduw/CC6jzRNWI0Ca
uIbfVVXsP2z7RgaIqiNANqkFma817D8yFFD6//8jQJHC1PUnFew/erPaPw==

                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27509#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, 
                    AxesOrigin -> {0, 0.8775825311077644}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0.8775825311077644}, DisplayFunction :> 
                    Identity, Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {0.8775825311077644, 
                    0.9999999999999999}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 10.}}, {
         5, 7, 1, {75}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
          False}, CompressedData["
1:eJwBaQKW/SFib1JlAgAAAAEAAABLAAAAAAAAAAAAAACliAqltZh8PaWICqW1
mIw9fObHO4hylT2liAqltZicPWeVJodx36E9kDdp8J4FqT3d7NUs5hWwPfI9
d+H8qLM9YDTi9++zyz3kZIS/sMnWPZevF4Npud89pya2SahF/j20MFMZe04K
Pgqn5QYRvRI+e45P89SlMj6a2XLSMk5APvbrPSt7SUc+5CjLqJNGZz5ma2ND
ZF10PlpCYbJ+F30+l7RVQ45oiz4BZL2WriKUPrbtzwsWkZo+1TtxwL5/oD7Q
gPp68rajPsrFgzUm7qY+zAoN8Fklqj7NT5aqjVytPmfKj7LgSbA+txGfq/Eu
wD46Pvb98jjIPl+1Jih6IdA++EntYcAp7D6hnOPXYSH4PkNSSZecJx8/r95M
XHAjLD/H3lug+DdTP9wQl5rBdWE/JhtCyGj5fD/vVpxh+JuIP8iMqDCt6JM/
GO6CMF6Dmz+0py6YB4+hP/fAJZ+K5Kc/O9ocpg06rj+/+YlWyEeyP2TInmAL
qrw/hctZNSeGwz/YMmS6SLfIPzbczqa9A9E/AZ9r8Nar1T/MYQg68FPaP2rS
j61cjuA/7nMbPsHy4z9xFafOJVfnP/W2Ml+Ku+o/7R/LH22l7z9yxDHwp0fy
P+74fVCZvPQ/ai3KsIox9z8mJke+HzX9P3EP4mVanAFAz4ug7CSeBEAtCF9z
758HQIuEHfq5oQpAirFr0SjLD0BE71zUS3oSQMQFBEADDxVAQxyrq7qjF0DC
MlIXcjgaQLNvFBVT+B1AUlZrCRrcIEApq7UEDW4iQAAAAAAAACRArDka1w==

         "], {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 
          56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 
          90, 92, 94, 96, 98, 100, 102, 104, 106, 108, 110, 112, 114, 116, 
          118, 120, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 
          144, 146, 148, 150}, CompressedData["
1:eJztz31MzHEcwPGzKVRDpKaOExHCECmrvuG0HuiuS+kBnVPdFo3UUlnUyPUs
Nz0spTxULjZ2+QOr7yeaCi3ksdaDNK26h291u3Pl7vK7Olts/vC/93+vfT6f
Pz62vJOcyFk0Gq2Q9qsRRPut//5XT1KF96vqJ6cif7Ex1hmsv+JS85nOWG+O
tb/tW2KNwTqDf8yY7yil4/E/rJ5hhbEd7jbYZL/kkJTthO8ZnP9VUGZX44aj
DFbkvQxodmBioXLaki0vgti+4fhO/7SLKoM5y9JP4Oo0zZTjddxFXNcrWKBW
TtnbT6gOr6rAFaF3dHo/u3vgIh89x/HbGBq9P1uGqMfvvsfWaaJ2vWMeToTu
4o3g9YLoDL37Cjhl8w9qcW/vbYmOslt6v2OHkQk4Kzpn650TTDepv2YO0U9N
32sob2kSMeqSLGG5eNBxgrJTgxmdXrAcPMRhTSr9v44+ysDgVfC5LCJ7jPKC
ogZ7myh7sMttMu2lnF2inMsJ3gqRed8lz/Relyq9rHWGRzSVw3XKg/v46e03
ETg1ym56Uq4NqCzf2LwXWrysQ97pCGoDbVdfnS9kFff4MSm/TrSyQR1seJc2
6L5bS1ButXdOyuZAeCVu9zbSEEQfH9pdIAiBEM1EbO4EQUilMErpOQyBnKVP
OtUE3W7ZMFpofRSOFaVUapQErfVMGGp1jwCvPqb1rTGC+LzUR7U8PpScYK9u
kxP0tLgx1uNSNLge439IGSZov8PziihRDERUeJwZ6CaouFCy83HNaZjk3EiM
aSOI8YnBnHc+AW5k9nhY1BHEYrEGgvyTYU8nK7mriiAr8a2aXbbnAJw5C1vy
CLof13nY5XsqIKO3Pq1HCBrN6VrR4XQRwmq/SOPXEGTGZCHLWAEIZcnqN9/k
SGUfl2lRmQVaZX3VaKkchc9NvzD+NheuM0N5w75yFPCawU44mw8uK+cUfGqW
IaaF8JRrnRCOA9fd2FGGgkTbxUljV8F/k4k5FknR4viP5Q8aC0EXWqWwXyJF
aof5VrLsYvgJiDEumA==
          "]}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A12", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj4ADXMxOK9Nvjd0wYnD
3cQ/DTs+D16xgL/SUFjDa77VPwgaLkvrZJG/IqE47Akn4D/WyKHIWdeZv9Wb
k3tZVOU/GZI9p3cPob+7wbiC/fHqP3Puf03CjKW/gEqXStgX8D8C62l1+Lyp
v7tJtw/c7vI/Ayw/2XJGrr/ziT6Xnbj1P3Sa+lsTXbG/2iBupGZS+D+7Xh8d
U3Czv1rNgu1ZJPs/A377TASwtb+J0D+8VMb9P4TLEnoRybe/WwqypoYtAECe
AH2nJ9e5vz63Ng34kwFA/z1sV3kRvL94j482beICQD+T/XUiJb6/f/LaffdM
BEDjyHo+bTLAvwX2WabgsAVAnxVN3rRMwb/iJK2RzfwGQBo5JIWpU8K/jN7y
ms9kCECAE7QshHDDv43DDGfVtAlACFpRtwt6xL9bMxlR8CALQKBfbBhemcW/
p0NZHGqGDECwF0V3CLPGv0t/barn0w1Alrg1uGa5x7+8RXRWej0PQPqm4U1o
1ci/wpunYohHEEApKnWEIN7Jv+XkrgoD7RBAy6WYLjbhyr9vc69BiKARQHBX
WIbF+cu/pRcaWg9IEkC3UxLUF//Mv0EBfgGh/RJAbs/hb8EZzr8cu3sZ4q8T
QBOuqz2rLs+/oorjEiVWFEDDmrkiNBjQv4+fRJtyChVA7GFWJaaj0L8oyg8F
wrIVQLYbnISFJdG/AMV038BXFkDBx6h4jKTRvz4F00jKChdA1fea2Q0u0r8o
W5uT1bEXQCRiZToHrtK/ePZcbetmGECwwqhcZjjTv3SniCgDEBlA2BaYsUK5
07+vKE5UyrUZQBz6JNZCN9S/Ue8MD5xpGkC2ZfDRjL/Uv5/LNatvERtAUENV
XmE+1b9T7VfWTccbQM72xcpox9W/R98Tctt5HEBI7h5lg03Wv+bmOe9qIB1A
MGUDDzjK1r/rM1n7BNUdQFK9uU0AUde/nJbi6KB9HkCUYeQcas7Xv4zJBUfs
Ih9AfliaHPZI2L/iQSI0QtYfQIv0+r51zdi/8mdUAc0+IEC/VGS7qEjZv6ZR
FDB+mSBAasj0DbXN2b96IyEXh/IgQJlMt+vRT9q/JADj7pBFIUB/bKMLtsja
v4F/IQ6gnyFAZ1AxL1BL27+0CRUesPMhQKZDN2u7xNu/mjaFdcVOIkCx35cf
wEfcv59LQoUyqCJAaqfT4NPH3L96a7SFoPsiQM1JRnDPPt2/CC6jzRNWI0Ao
wodhPr/dv2z7RgaIqiNAyidKY6A23r8yFFD6//8jQDRtnGvort6/6J3ZGg==

                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27570#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {-0.4794255305184436, 0.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj4ADXMxOK9Nvjd0wYnD
3cQ/DTs+D16xgL/SUFjDa77VPwgaLkvrZJG/IqE47Akn4D/WyKHIWdeZv9Wb
k3tZVOU/GZI9p3cPob+7wbiC/fHqP3Puf03CjKW/gEqXStgX8D8C62l1+Lyp
v7tJtw/c7vI/Ayw/2XJGrr/ziT6Xnbj1P3Sa+lsTXbG/2iBupGZS+D+7Xh8d
U3Czv1rNgu1ZJPs/A377TASwtb+J0D+8VMb9P4TLEnoRybe/WwqypoYtAECe
AH2nJ9e5vz63Ng34kwFA/z1sV3kRvL94j482beICQD+T/XUiJb6/f/LaffdM
BEDjyHo+bTLAvwX2WabgsAVAnxVN3rRMwb/iJK2RzfwGQBo5JIWpU8K/jN7y
ms9kCECAE7QshHDDv43DDGfVtAlACFpRtwt6xL9bMxlR8CALQKBfbBhemcW/
p0NZHGqGDECwF0V3CLPGv0t/barn0w1Alrg1uGa5x7+8RXRWej0PQPqm4U1o
1ci/wpunYohHEEApKnWEIN7Jv+XkrgoD7RBAy6WYLjbhyr9vc69BiKARQHBX
WIbF+cu/pRcaWg9IEkC3UxLUF//Mv0EBfgGh/RJAbs/hb8EZzr8cu3sZ4q8T
QBOuqz2rLs+/oorjEiVWFEDDmrkiNBjQv4+fRJtyChVA7GFWJaaj0L8oyg8F
wrIVQLYbnISFJdG/AMV038BXFkDBx6h4jKTRvz4F00jKChdA1fea2Q0u0r8o
W5uT1bEXQCRiZToHrtK/ePZcbetmGECwwqhcZjjTv3SniCgDEBlA2BaYsUK5
07+vKE5UyrUZQBz6JNZCN9S/Ue8MD5xpGkC2ZfDRjL/Uv5/LNatvERtAUENV
XmE+1b9T7VfWTccbQM72xcpox9W/R98Tctt5HEBI7h5lg03Wv+bmOe9qIB1A
MGUDDzjK1r/rM1n7BNUdQFK9uU0AUde/nJbi6KB9HkCUYeQcas7Xv4zJBUfs
Ih9AfliaHPZI2L/iQSI0QtYfQIv0+r51zdi/8mdUAc0+IEC/VGS7qEjZv6ZR
FDB+mSBAasj0DbXN2b96IyEXh/IgQJlMt+vRT9q/JADj7pBFIUB/bKMLtsja
v4F/IQ6gnyFAZ1AxL1BL27+0CRUesPMhQKZDN2u7xNu/mjaFdcVOIkCx35cf
wEfcv59LQoUyqCJAaqfT4NPH3L96a7SFoPsiQM1JRnDPPt2/CC6jzRNWI0Ao
wodhPr/dv2z7RgaIqiNAyidKY6A23r8yFFD6//8jQDRtnGvort6/6J3ZGg==

                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27570#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {-0.4794255305184436, 0.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 10.}}, {
         5, 7, 1, {75}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
          False}, CompressedData["
1:eJwBaQKW/SFib1JlAgAAAAEAAABLAAAAAAAAAAAAAACliAqltZh8PaWICqW1
mIw9fObHO4hylT2liAqltZicPWeVJodx36E9kDdp8J4FqT3d7NUs5hWwPfI9
d+H8qLM9YDTi9++zyz3kZIS/sMnWPZevF4Npud89pya2SahF/j20MFMZe04K
Pgqn5QYRvRI+e45P89SlMj6a2XLSMk5APvbrPSt7SUc+5CjLqJNGZz5ma2ND
ZF10PlpCYbJ+F30+l7RVQ45oiz4BZL2WriKUPrbtzwsWkZo+1TtxwL5/oD7Q
gPp68rajPsrFgzUm7qY+zAoN8Fklqj7NT5aqjVytPmfKj7LgSbA+txGfq/Eu
wD46Pvb98jjIPl+1Jih6IdA++EntYcAp7D6hnOPXYSH4PkNSSZecJx8/r95M
XHAjLD/H3lug+DdTP9wQl5rBdWE/JhtCyGj5fD/vVpxh+JuIP8iMqDCt6JM/
GO6CMF6Dmz+0py6YB4+hP/fAJZ+K5Kc/O9ocpg06rj+/+YlWyEeyP2TInmAL
qrw/hctZNSeGwz/YMmS6SLfIPzbczqa9A9E/AZ9r8Nar1T/MYQg68FPaP2rS
j61cjuA/7nMbPsHy4z9xFafOJVfnP/W2Ml+Ku+o/7R/LH22l7z9yxDHwp0fy
P+74fVCZvPQ/ai3KsIox9z8mJke+HzX9P3EP4mVanAFAz4ug7CSeBEAtCF9z
758HQIuEHfq5oQpAirFr0SjLD0BE71zUS3oSQMQFBEADDxVAQxyrq7qjF0DC
MlIXcjgaQLNvFBVT+B1AUlZrCRrcIEApq7UEDW4iQAAAAAAAACRArDka1w==

         "], {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 
          56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 
          90, 92, 94, 96, 98, 100, 102, 104, 106, 108, 110, 112, 114, 116, 
          118, 120, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 
          144, 146, 148, 150}, CompressedData["
1:eJxF0ns01GkYB3DjGI5slDotktilpCjRRaajhFZiVmbGvUWYyaXJvYuaMEQK
E8a4VJKYH0k7QlN+7yMd2kkXG4umkuy63yIVy9p9/bXf/z7nOec557kYBHCP
BFEUFBSECv+nIH8pUnDx0adc6nUgL/+uHyrAbso/5JnSyyIXz0toadjnnmtR
A4z9SQO2o3oC9kLjLVVebzD5La3/wynsk8yDewpEYWT8YMqvJ7HRjY+ng5Wi
yStH3jD8sBPXdJrFN5wmk8KtZ+nYpBGVlhHNIylRkkIb7AnK+RN6m4TkS9Uu
xSKRFMpsfWaP7ikhVzZviJzNk4KBm/5yih9BqpvcHGZge/X2GJRY/EbKLK8w
P2dJYd0PhnQO9Q9ycc79U84lKQhGAmZbJt6Tlj0/PrDiS+GmcWHkYOk/5Iuh
F4Eseyk0eGfwP7aqIntz5uoKFSmkcwrcGExNpJme1mLW+gACc4c1WCnmKFXz
TteYuA68rkHtKHsv6pmoFU0N3ofSt3PDtjvs0Ar755ZOcTXgblG80obuilyU
wg2mA+5BOcfDqFrgjnQWTPRz+VWwJToqxIPli3oq32fu7auE21NzZ7lh/uic
7vTyiOkK0D74t8phnUDkqL2vX9uvAvx+Pk690BCM1r9aq8tZVgGIYVw9634c
cWK8RvXkBCRYW90vnQxF5aXv22SIgLBqkrMh+QSKaV1MVq4mwDQq0YZrGI86
jTS4mbEEnDF06M7h8dG49hMd3wwCOHMMu5TxS6jRlVU/IiLA95kuM+BVGSrs
cioS5hNgUic7JYmoQcuo/Mv52IeUlMe4X7qRM1+Qv2Ql9tYiq4sDyFmxOm/J
JxcuXNR8rA6+Rg9FS65fjWo2floL381MWl7FZvBdaSvMdkGJhvDsUn1ozYKi
2r0DsDtyu1iEPRXjYUrK6fD5mXKUAHtbXIQqqciC4IGY8Vrs2X0F7d9r+UDy
2Lb0bGzP/utH9687BqEZzK852PvTvjXFmHEggflckoUteym6S9iEw4ShQ1sm
dl10QmrIRCzUqOXReNivd7NEczQe3P3TNIS9NJ96ocnj5iSIDZMHMbBbk51U
53enA+2qGp2KHRL81V+dJYDEmelVBN5XpcBlfZZGLkhaAm7vxCati42vxRdA
xaLSdk4eAcJ/v2w4M3wDqk7MF4cICRhgz29SryyB5qfWM3tzCXg4Imul+d+G
wqKPpn3ZBOzqVj7McyHg7dW2YaGAAIuBBoqfdRVMUX17h/C9qqxM+gez78HO
zR663ekEdNA74EOaBOh33ogDUwlwuCN3DGLWA80rdtr1PO6X2Nb4Uq8BGO8c
LaciCGgfHCzvjGyEBa49+8AxArxkFHNZRxM0GpydczxCQMn1kE6VHc1gwz0e
qWxDgJPELiPTTgabgurCb2nh//rlpzFv5xfQcdr7UdaoGG5UbO7bUt4GxZVG
R+X1YvhLPrxofes1hI3b6macE0PyzJNJt4IO0M9cxXtEE4NnpW6eU2gXeJMU
uWZ7OawFN2etrXIIenqdQvUphyS1tndF0e+AY8suM58oA84jUdTQ3R5ov7Zx
o1tcGfwH0ieJ9w==
          "]}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A13", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQ7XUxznL9/jY7BigwLznYefjuEXsY/1JAxOHsfVfh
fKWFFm841R/A+VdnT66ODHkK5+8+uKPp78dXcH6D13SvG+IfEPKe2/nvvPsE
53/utJs+d8dXOP+WQt6StKAfcH7U2aa3kSq/4fzOC/Z7Qo79hfOjuTYta9Nl
cIDx7bab8f6YzAjnV/T3m+U+YoLz6z/dqv3uwwLns36LXPZgAyuc/0hl7cSz
f9jg/J57n2adT+GA83sP86Rf3cIJ50cbSwZ+UOCG85c7R8pktfHA+d71uaue
X+aF8/e4loRV2fLD+YdmL0/qcBeA858+WcfF/BbBzy9e79ixQBDOXyouFcXv
IQTnOzLWMS78i+DL7K6WfLReGM5f1PVYSDVMBM7vn+8yu4hLFM7XOMXPemgT
gs9wtOT+gXAxON+O9bLHKS5xhPro2ZOvbkTwK77F5L5Ok4DzS5Z3aDALSML5
6zX8Qk5tRfAD3/Pwz8mUgvPnnzZdnS8oDecHvw2/5nscwXe/L1x0u1IGzn/2
zPJ9loIsnP/aOPI3y1UEf860Ry8W1MrB+T0nWd3fKMnD+Y8clUycriH4n9JD
GM/aKcD5ywJFDOpmIvhVyori7Z8QfBWGx+8muCrC+Y31inwL5iP4WzhF5TZ8
RvBnmbWWHvVTQvjX26nVaAWCX5W9pXXBbwSfQ2/xWeEwZTg/57cbW8cqBN9I
JODX//8IPgBiFdIt
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27631#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 10.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQ7XUxznL9/jY7BigwLznYefjuEXsY/1JAxOHsfVfh
fKWFFm841R/A+VdnT66ODHkK5+8+uKPp78dXcH6D13SvG+IfEPKe2/nvvPsE
53/utJs+d8dXOP+WQt6StKAfcH7U2aa3kSq/4fzOC/Z7Qo79hfOjuTYta9Nl
cIDx7bab8f6YzAjnV/T3m+U+YoLz6z/dqv3uwwLns36LXPZgAyuc/0hl7cSz
f9jg/J57n2adT+GA83sP86Rf3cIJ50cbSwZ+UOCG85c7R8pktfHA+d71uaue
X+aF8/e4loRV2fLD+YdmL0/qcBeA858+WcfF/BbBzy9e79ixQBDOXyouFcXv
IQTnOzLWMS78i+DL7K6WfLReGM5f1PVYSDVMBM7vn+8yu4hLFM7XOMXPemgT
gs9wtOT+gXAxON+O9bLHKS5xhPro2ZOvbkTwK77F5L5Ok4DzS5Z3aDALSML5
6zX8Qk5tRfAD3/Pwz8mUgvPnnzZdnS8oDecHvw2/5nscwXe/L1x0u1IGzn/2
zPJ9loIsnP/aOPI3y1UEf860Ry8W1MrB+T0nWd3fKMnD+Y8clUycriH4n9JD
GM/aKcD5ywJFDOpmIvhVyori7Z8QfBWGx+8muCrC+Y31inwL5iP4WzhF5TZ8
RvBnmbWWHvVTQvjX26nVaAWCX5W9pXXBbwSfQ2/xWeEwZTg/57cbW8cqBN9I
JODX//8IPgBiFdIt
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27631#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 10.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 10.}}, {
         5, 7, 1, {75}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
          False}, CompressedData["
1:eJwBaQKW/SFib1JlAgAAAAEAAABLAAAAAAAAAAAAAACliAqltZh8PaWICqW1
mIw9fObHO4hylT2liAqltZicPWeVJodx36E9kDdp8J4FqT3d7NUs5hWwPfI9
d+H8qLM9YDTi9++zyz3kZIS/sMnWPZevF4Npud89pya2SahF/j20MFMZe04K
Pgqn5QYRvRI+e45P89SlMj6a2XLSMk5APvbrPSt7SUc+5CjLqJNGZz5ma2ND
ZF10PlpCYbJ+F30+l7RVQ45oiz4BZL2WriKUPrbtzwsWkZo+1TtxwL5/oD7Q
gPp68rajPsrFgzUm7qY+zAoN8Fklqj7NT5aqjVytPmfKj7LgSbA+txGfq/Eu
wD46Pvb98jjIPl+1Jih6IdA++EntYcAp7D6hnOPXYSH4PkNSSZecJx8/r95M
XHAjLD/H3lug+DdTP9wQl5rBdWE/JhtCyGj5fD/vVpxh+JuIP8iMqDCt6JM/
GO6CMF6Dmz+0py6YB4+hP/fAJZ+K5Kc/O9ocpg06rj+/+YlWyEeyP2TInmAL
qrw/hctZNSeGwz/YMmS6SLfIPzbczqa9A9E/AZ9r8Nar1T/MYQg68FPaP2rS
j61cjuA/7nMbPsHy4z9xFafOJVfnP/W2Ml+Ku+o/7R/LH22l7z9yxDHwp0fy
P+74fVCZvPQ/ai3KsIox9z8mJke+HzX9P3EP4mVanAFAz4ug7CSeBEAtCF9z
758HQIuEHfq5oQpAirFr0SjLD0BE71zUS3oSQMQFBEADDxVAQxyrq7qjF0DC
MlIXcjgaQLNvFBVT+B1AUlZrCRrcIEApq7UEDW4iQAAAAAAAACRArDka1w==

         "], {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 
          56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 
          90, 92, 94, 96, 98, 100, 102, 104, 106, 108, 110, 112, 114, 116, 
          118, 120, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 
          144, 146, 148, 150}, CompressedData["
1:eJxTTMoPSmVkYGCYxjAKRsEoGAVDBwAApX4CQQ==
          "]}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A21", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj4GoZLcs9oqPjd0wYnD
3cQ/UYOZ0luxgD/SUFjDa77VP0Ti4yzqZJE/IqE47Akn4D+qVWSqWNeZP9Wb
k3tZVOU/oYYnGHcPoT+7wbiC/fHqPz0Ddr7BjKU/gEqXStgX8D8E3G3m97yp
P7tJtw/c7vI/0udUSnJGrj/ziT6Xnbj1PwmbjxQTXbE/2iBupGZS+D/oE7/V
UnCzP1rNgu1ZJPs/JCyoBQSwtT+J0D+8VMb9P6LdzDIRybc/WwqypoYtAEAo
ZkVgJ9e5Pz63Ng34kwFACYZFEHkRvD94j482beICQJre5y4iJb4/f/LaffdM
BEB+1vkabTLAPwX2WabgsAVAGI7WurRMwT/iJK2RzfwGQNwGuGGpU8I/jN7y
ms9kCECywlMJhHDDP43DDGfVtAlAn8H8kwt6xD9bMxlR8CALQEMqJfVdmcU/
p0NZHGqGDEC6uAtUCLPGP0t/barn0w1A4uAJlWa5xz+8RXRWej0PQMomxSpo
1cg/wpunYohHEEDQnmdhIN7JP+XkrgoD7RBAlluaCzbhyj9vc69BiKARQAtD
a2PF+cs/pRcaWg9IEkBy7TWxF//MP0EBfgGh/RJAzCkYTcEZzj8cu3sZ4q8T
QMYf9RqrLs8/oorjEiVWFECLiGcRNBjQP4+fRJtyChVAO6AOFKaj0D8oyg8F
wrIVQCNKXnOFJdE/AMV038BXFkBE/nRnjKTRPz4F00jKChdAv2NyyA0u0j8o
W5uT1bEXQMCQRykHrtI/ePZcbetmGEDX75ZLZjjTP3SniCgDEBlAKMaRoEK5
0z+vKE5UyrUZQKw7KsVCN9Q/Ue8MD5xpGkDahgLBjL/UP5/LNatvERtAbLVz
TWE+1T9T7VfWTccbQIkV8rlox9U/R98Tctt5HEBuzlhUg03WP+bmOe9qIB1A
kWVK/jfK1j/rM1n7BNUdQBhLDz0AUdc/nJbi6KB9HkAM0kcMas7XP4zJBUfs
Ih9Aaa0LDPZI2D/iQSI0QtYfQPWre651zdg/8mdUAc0+IEAMsvOqqEjZP6ZR
FDB+mSBAeleU/bTN2T96IyEXh/IgQJATZ9vRT9o/JADj7pBFIUCXnGL7tcja
P4F/IQ6gnyFAVoYBH1BL2z+0CRUesPMhQE+nF1u7xNs/mjaFdcVOIkBXG4oP
wEfcP59LQoUyqCJA7LjX0NPH3D96a7SFoPsiQBBHW2DPPt0/CC6jzRNWI0Dr
Za9RPr/dP2z7RgaIqiNArX6DU6A23j8yFFD6//8jQEH151vort4/emi7lQ==

                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27692#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {0., 0.4794255158920642}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAStFeOa+/hj4GoZLcs9oqPjd0wYnD
3cQ/UYOZ0luxgD/SUFjDa77VP0Ti4yzqZJE/IqE47Akn4D+qVWSqWNeZP9Wb
k3tZVOU/oYYnGHcPoT+7wbiC/fHqPz0Ddr7BjKU/gEqXStgX8D8E3G3m97yp
P7tJtw/c7vI/0udUSnJGrj/ziT6Xnbj1PwmbjxQTXbE/2iBupGZS+D/oE7/V
UnCzP1rNgu1ZJPs/JCyoBQSwtT+J0D+8VMb9P6LdzDIRybc/WwqypoYtAEAo
ZkVgJ9e5Pz63Ng34kwFACYZFEHkRvD94j482beICQJre5y4iJb4/f/LaffdM
BEB+1vkabTLAPwX2WabgsAVAGI7WurRMwT/iJK2RzfwGQNwGuGGpU8I/jN7y
ms9kCECywlMJhHDDP43DDGfVtAlAn8H8kwt6xD9bMxlR8CALQEMqJfVdmcU/
p0NZHGqGDEC6uAtUCLPGP0t/barn0w1A4uAJlWa5xz+8RXRWej0PQMomxSpo
1cg/wpunYohHEEDQnmdhIN7JP+XkrgoD7RBAlluaCzbhyj9vc69BiKARQAtD
a2PF+cs/pRcaWg9IEkBy7TWxF//MP0EBfgGh/RJAzCkYTcEZzj8cu3sZ4q8T
QMYf9RqrLs8/oorjEiVWFECLiGcRNBjQP4+fRJtyChVAO6AOFKaj0D8oyg8F
wrIVQCNKXnOFJdE/AMV038BXFkBE/nRnjKTRPz4F00jKChdAv2NyyA0u0j8o
W5uT1bEXQMCQRykHrtI/ePZcbetmGEDX75ZLZjjTP3SniCgDEBlAKMaRoEK5
0z+vKE5UyrUZQKw7KsVCN9Q/Ue8MD5xpGkDahgLBjL/UP5/LNatvERtAbLVz
TWE+1T9T7VfWTccbQIkV8rlox9U/R98Tctt5HEBuzlhUg03WP+bmOe9qIB1A
kWVK/jfK1j/rM1n7BNUdQBhLDz0AUdc/nJbi6KB9HkAM0kcMas7XP4zJBUfs
Ih9Aaa0LDPZI2D/iQSI0QtYfQPWre651zdg/8mdUAc0+IEAMsvOqqEjZP6ZR
FDB+mSBAeleU/bTN2T96IyEXh/IgQJATZ9vRT9o/JADj7pBFIUCXnGL7tcja
P4F/IQ6gnyFAVoYBH1BL2z+0CRUesPMhQE+nF1u7xNs/mjaFdcVOIkBXG4oP
wEfcP59LQoUyqCJA7LjX0NPH3D96a7SFoPsiQBBHW2DPPt0/CC6jzRNWI0Dr
Za9RPr/dP2z7RgaIqiNArX6DU6A23j8yFFD6//8jQEH151vort4/emi7lQ==

                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27692#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {0., 0.4794255158920642}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 10.}}, {
         5, 7, 1, {75}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
          False}, CompressedData["
1:eJwBaQKW/SFib1JlAgAAAAEAAABLAAAAAAAAAAAAAACliAqltZh8PaWICqW1
mIw9fObHO4hylT2liAqltZicPWeVJodx36E9kDdp8J4FqT3d7NUs5hWwPfI9
d+H8qLM9YDTi9++zyz3kZIS/sMnWPZevF4Npud89pya2SahF/j20MFMZe04K
Pgqn5QYRvRI+e45P89SlMj6a2XLSMk5APvbrPSt7SUc+5CjLqJNGZz5ma2ND
ZF10PlpCYbJ+F30+l7RVQ45oiz4BZL2WriKUPrbtzwsWkZo+1TtxwL5/oD7Q
gPp68rajPsrFgzUm7qY+zAoN8Fklqj7NT5aqjVytPmfKj7LgSbA+txGfq/Eu
wD46Pvb98jjIPl+1Jih6IdA++EntYcAp7D6hnOPXYSH4PkNSSZecJx8/r95M
XHAjLD/H3lug+DdTP9wQl5rBdWE/JhtCyGj5fD/vVpxh+JuIP8iMqDCt6JM/
GO6CMF6Dmz+0py6YB4+hP/fAJZ+K5Kc/O9ocpg06rj+/+YlWyEeyP2TInmAL
qrw/hctZNSeGwz/YMmS6SLfIPzbczqa9A9E/AZ9r8Nar1T/MYQg68FPaP2rS
j61cjuA/7nMbPsHy4z9xFafOJVfnP/W2Ml+Ku+o/7R/LH22l7z9yxDHwp0fy
P+74fVCZvPQ/ai3KsIox9z8mJke+HzX9P3EP4mVanAFAz4ug7CSeBEAtCF9z
758HQIuEHfq5oQpAirFr0SjLD0BE71zUS3oSQMQFBEADDxVAQxyrq7qjF0DC
MlIXcjgaQLNvFBVT+B1AUlZrCRrcIEApq7UEDW4iQAAAAAAAACRArDka1w==

         "], {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 
          56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 
          90, 92, 94, 96, 98, 100, 102, 104, 106, 108, 110, 112, 114, 116, 
          118, 120, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 
          144, 146, 148, 150}, CompressedData["
1:eJxl0n00lHkUB3BsZKxhizLl/aVO660MsyzP/C5HmdpCFJuaaswQoaYXjPc5
FTVF3k3MUhhm5lHRam21ZC3psF4OiqyjQqGsMdlp1I49dh9/7/3vc+4599zz
vdeazQ2O1NTQ0BBq/L+0p4D3DDlhJKVp/iKzEnmpfvbeoNiFtV8v3zzLvIei
3KnIQBGCbe9Pou7PfojOf7JOdmGwMebRwbVjzDY0Lndz7YiJxTKHDcJI8U+Q
laupcvROEva1+LItq7oXzZ3hTutLLmE0LZ3s76OHkO3rDdr53TkYAkl3Mn8E
pWbcsP1Y0ox51vwdNNqoQCIH1U8XREPYH5LdTrz1apSVUtIh0JrC3rHSOvhb
tGBzA6vn92NWdJ/KbopgnzU8jDKaSGnyoJd5wKVgkjOIqAab/jLYQ9eIak6Y
PE6D07t4h0gVAnqq6zy176sQeBqgFOc0VdMf6V2XfaCzwULmnNO21EjvHdBk
H+47CQsXVGejBIv0Ao84wxNZV0BPurxRP46E5HW5X1Q+LYSGFe2wiSwK2hZM
K/r2ailkxRfYr/CoSGgf9iHgVDVQhv1cKvb6IGN3XaOb9bVw0Zc/1xX6HQq6
EiJW7ZdCR0IiyVwZhH7c6LOl3VsGy2QnI/FkKJrepPTf9EwGeUjHM2X2CCJH
mJj0bMMhq8VyTUQ6C7U+HmUYh+FwlDeX90KPgzJyQ9gn43HQr/WJSxBForoo
t7uOmTisOc7g/1PDQ8ZkuyfiFhwyR30XFT4XUSXlDGWkBgeOyWFu3z0BYk2M
p+4W4UATO0y6e0tQp/+ssLwMh0d8XYa5/X3Ua1gvKSN8efjmrWtvRhHLpqJs
1acHl1V+GTNoUqfhxqqn1cqXw60GUK/7S+mqZ/I/HSMpTGFErnArJLxSbCnt
cnKHlqKS1NV+kxnHY7bBF2gxVFkpYROHNnbZWCDM2JLOFxAeHNpid1srFPKZ
SfImwhsZgQvaFCZYr3PLLiJ8yE4d62HOgYXnYUvFhKseHxiIc44GRutgYz5h
tctScyWcgqmGfQN5hHdMUA1PLCQCJaAK4xOeLfzSUoXxgfvSKyaKsIb/Z3lr
5yWoN5+PPEhY801972ePbFDJbQO1Cf9gdseXHFoAD9XrjPFSHNoYJM08wxLY
wRPUfkNYscTRK08TwbZIN2r0DRym+p/oJr+/BcXX3KpihDgYhL8XkW9Xw6vS
jI/0Ehx60n7FsPBasLJxdp4qwuEKIj3OCMCBv9VhTliAg82e/nPHve4CXdI5
8S6XyD+9uWK26B7kjPSbjWYT+3lyk15fbYTXrGN4hAAHs98KtCJDHgCXTXxV
Bg5i17rkfosWOLjViLZ4FgfkdzJz5FwbcOZ3RPtyiDzfiMjdz9uB1CxQ7wnG
wVZqcX8trRPI+mXndYCYf8I5Nm9nN9TaWXHFFOLeJme7j/j3AXt5pSX/TxnI
Hd8OOEoHYJGvxRp7IANNix65l3gICosPWeSmy8BCMPTqgOg5vE0Nv9CMySDY
NOHy3tgX4OBfOb7+mRTqov/FKNvHYO/FnDXaTCmYpnb1lsePg1pHiLssSCDR
9y3nXf0rUDoK7Q/wJPAfFN4npA==
          "]}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A22", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwdjQ0w23ccxkOlh7GotxShSejY5druFK2r5vul3muuJGiw7q5VtZbaNNsZ
xfQuSpaNjrUqNumqbHEV0+z0UCtGN62papyiaxf1cmv+/x9xOl2E2Z675577
3PPcPbzjuYknLRkMRsim/8vY0WPBmp/LhBv/i8A+aW9F/9NfQKNIhc5NfnTk
aP+ZHh18eLFVPLpOgH9tv8HG9zkULWbYZJgJ6JTVhRLxLPDHUtLOmQh09d6+
YF76C9qm20rvrBL4LPZK7AR7EfYEf5vduLLZx3SwpmkjmIes0tRLBJYrhFe+
ub0CgrOJUj5FYJJ7tjEzcRV6RSdEkgUCqcMXKImPCd7jHOhX6AlUPIRu8aAZ
Oovl6VXTBNJs25vKdjFQEBmz4DdOQNgRZL9abYF1izeq638nkF9ZGZSjt8T1
3MBqi3sESoyTRX/HWWG70DP8rR4CzFeSpudtTNT7Zs3otAT0PjcvDa9tRdN2
u5HaFgKKP4x1IxnWmNUn+PK1isAX/XandFobzBuQrxVf3vzf65awyH0DmTrD
SpmcQPMhCed0mR0OpuFD32ICh0ty1PNj9ng+1DWXlUegO0KaXHCQhU8aR16n
ZBDoUzYfL49ywAOg7VxNJjD7otV2C+WA5Ne74UkxBHLPaULLVdvwFu2x2xhM
4AbbPZUV7YgpfgGZ1gICoRbFFtfMjvjCqjc23J0Ap6vQTa9xwuvCQI2/DYHv
5DOOO5OdcXn2pqB7lYbKhnBlnq0Lendc/Tx2jga/IRazr90FB897JMge08AY
kD67m+KKKsOJ/V/30SBkjkUP2bIxqT5RLG/d3Kcpq3U/sjF0SKSIU9KQ/yo9
52XmdhwVPTI9kdEgbS732+LghpPZf+oiPqJB4xcvHvrJDVsZIXRNOg0JxI5V
/4E77oo8tFYZQUPD/cCW3G0eKItX2Mv30CCiUsbfveeBB9e8pK5sGqKeOeVN
fcrBeVahumidgrm5YHKa64nmrEgOc56Cl3slJiudJ8bNO3+18YCC+sv6BVWR
F+6UhUUKtBQofmNGGfg7sHZqbkKkpEAfyg8IG9+BPUdvRYyWUGA8JbYYFnJx
o2xlueEkBU0Jzu8UX+WiZUxUvzqaggJvHvuikYs1mU9r1QIKfBgzdFUED0Pu
B7zNcaCgtIT3pqqBh5eSS7talgygtXHxalvm4b7593vuPDZAXZDs44F4Pnrl
d8t0WgM0HA6T+X/Pxwmt3mOpxgAFZ7QylYmPVo4/JGo+MYD17uvDTsnemGp9
bCopyQDZpsit5WpvdI5+UKMJNIC/85F/Nja8MbNKvuTrYoB/AejZ1no=
                    
                    "]]}, Annotation[#, 
                    "Charting`Private`Tag$27753#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, 
                    AxesOrigin -> {0, 0.8775825231173371}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0.8775825231173371}, DisplayFunction :> 
                    Identity, Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {0.8775825231173371, 
                    0.9999999999999999}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwdjQ0w23ccxkOlh7GotxShSejY5druFK2r5vul3muuJGiw7q5VtZbaNNsZ
xfQuSpaNjrUqNumqbHEV0+z0UCtGN62papyiaxf1cmv+/x9xOl2E2Z675577
3PPcPbzjuYknLRkMRsim/8vY0WPBmp/LhBv/i8A+aW9F/9NfQKNIhc5NfnTk
aP+ZHh18eLFVPLpOgH9tv8HG9zkULWbYZJgJ6JTVhRLxLPDHUtLOmQh09d6+
YF76C9qm20rvrBL4LPZK7AR7EfYEf5vduLLZx3SwpmkjmIes0tRLBJYrhFe+
ub0CgrOJUj5FYJJ7tjEzcRV6RSdEkgUCqcMXKImPCd7jHOhX6AlUPIRu8aAZ
Oovl6VXTBNJs25vKdjFQEBmz4DdOQNgRZL9abYF1izeq638nkF9ZGZSjt8T1
3MBqi3sESoyTRX/HWWG70DP8rR4CzFeSpudtTNT7Zs3otAT0PjcvDa9tRdN2
u5HaFgKKP4x1IxnWmNUn+PK1isAX/XandFobzBuQrxVf3vzf65awyH0DmTrD
SpmcQPMhCed0mR0OpuFD32ICh0ty1PNj9ng+1DWXlUegO0KaXHCQhU8aR16n
ZBDoUzYfL49ywAOg7VxNJjD7otV2C+WA5Ne74UkxBHLPaULLVdvwFu2x2xhM
4AbbPZUV7YgpfgGZ1gICoRbFFtfMjvjCqjc23J0Ap6vQTa9xwuvCQI2/DYHv
5DOOO5OdcXn2pqB7lYbKhnBlnq0Lendc/Tx2jga/IRazr90FB897JMge08AY
kD67m+KKKsOJ/V/30SBkjkUP2bIxqT5RLG/d3Kcpq3U/sjF0SKSIU9KQ/yo9
52XmdhwVPTI9kdEgbS732+LghpPZf+oiPqJB4xcvHvrJDVsZIXRNOg0JxI5V
/4E77oo8tFYZQUPD/cCW3G0eKItX2Mv30CCiUsbfveeBB9e8pK5sGqKeOeVN
fcrBeVahumidgrm5YHKa64nmrEgOc56Cl3slJiudJ8bNO3+18YCC+sv6BVWR
F+6UhUUKtBQofmNGGfg7sHZqbkKkpEAfyg8IG9+BPUdvRYyWUGA8JbYYFnJx
o2xlueEkBU0Jzu8UX+WiZUxUvzqaggJvHvuikYs1mU9r1QIKfBgzdFUED0Pu
B7zNcaCgtIT3pqqBh5eSS7talgygtXHxalvm4b7593vuPDZAXZDs44F4Pnrl
d8t0WgM0HA6T+X/Pxwmt3mOpxgAFZ7QylYmPVo4/JGo+MYD17uvDTsnemGp9
bCopyQDZpsit5WpvdI5+UKMJNIC/85F/Nja8MbNKvuTrYoB/AejZ1no=
                    
                    "]]}, Annotation[#, 
                    "Charting`Private`Tag$27753#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, 
                    AxesOrigin -> {0, 0.8775825231173371}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0.8775825231173371}, DisplayFunction :> 
                    Identity, Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {0.8775825231173371, 
                    0.9999999999999999}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 10.}}, {
         5, 7, 1, {75}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
          False}, CompressedData["
1:eJwBaQKW/SFib1JlAgAAAAEAAABLAAAAAAAAAAAAAACliAqltZh8PaWICqW1
mIw9fObHO4hylT2liAqltZicPWeVJodx36E9kDdp8J4FqT3d7NUs5hWwPfI9
d+H8qLM9YDTi9++zyz3kZIS/sMnWPZevF4Npud89pya2SahF/j20MFMZe04K
Pgqn5QYRvRI+e45P89SlMj6a2XLSMk5APvbrPSt7SUc+5CjLqJNGZz5ma2ND
ZF10PlpCYbJ+F30+l7RVQ45oiz4BZL2WriKUPrbtzwsWkZo+1TtxwL5/oD7Q
gPp68rajPsrFgzUm7qY+zAoN8Fklqj7NT5aqjVytPmfKj7LgSbA+txGfq/Eu
wD46Pvb98jjIPl+1Jih6IdA++EntYcAp7D6hnOPXYSH4PkNSSZecJx8/r95M
XHAjLD/H3lug+DdTP9wQl5rBdWE/JhtCyGj5fD/vVpxh+JuIP8iMqDCt6JM/
GO6CMF6Dmz+0py6YB4+hP/fAJZ+K5Kc/O9ocpg06rj+/+YlWyEeyP2TInmAL
qrw/hctZNSeGwz/YMmS6SLfIPzbczqa9A9E/AZ9r8Nar1T/MYQg68FPaP2rS
j61cjuA/7nMbPsHy4z9xFafOJVfnP/W2Ml+Ku+o/7R/LH22l7z9yxDHwp0fy
P+74fVCZvPQ/ai3KsIox9z8mJke+HzX9P3EP4mVanAFAz4ug7CSeBEAtCF9z
758HQIuEHfq5oQpAirFr0SjLD0BE71zUS3oSQMQFBEADDxVAQxyrq7qjF0DC
MlIXcjgaQLNvFBVT+B1AUlZrCRrcIEApq7UEDW4iQAAAAAAAACRArDka1w==

         "], {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 
          56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 
          90, 92, 94, 96, 98, 100, 102, 104, 106, 108, 110, 112, 114, 116, 
          118, 120, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 
          144, 146, 148, 150}, CompressedData["
1:eJxl0G9UU2UAx/F50jZxEsiaQKEOhMFKxAYJtPa4AAs1gRRB/ogNlAO5A0Qi
QixRQ09TCNNBKRwlFlCskFCYjOehWYkCQ7YFSuIsCHOwXZwNEcfogpd7Tqfv
u8+b34sfS5jx3p4FFApFSplvHFD+0/8t3fH9wtQ9VOW86a4jubV8N9KLO1dV
j0VxSJ/pnvIsyfUnrWU4fBXRFkL696fCitaMCNKUqcaUHdQY0pEr1dDiUET6
emgpI1ZVQfrlC+uT0tX1pGkGsUP0qwbSPwawmkuuPNc271sDgZtcrU6k7R8d
DlFkbCP9cbebZ1KoiDTXoVekERaQbjzd4VosbyHdow5O6zlxk3TC0dXjmqaJ
tpm5MKDZRd3d+SkN2gjTgovuNyZS4TRhsN/ZZy3dCVoJr98v1Z9oYcKnhOUV
P3tLl7LgE8IJqu3LPljGgo8JB6h6MsvsPKCFsFMOTXjd7AXNhDMVnGp/tidU
E7YUx4UExXFh+fxeZoNAtAXALYT5/eVH/GRh0M/yzPn00Bqj825o+/OZL4Oe
8guT+6Cv2Dpn91gd7/KmUsg3W+ZMaTfsk8jPQ35grW3W/1DhuXWCX+CkZYV1
1h7KfCd9vQ5eulirmfXfaarKPOE4HPBKOz7r0b72P96OmYZaWdWoDfepOM8+
yyI7lKXvXzhr4Q3H+M6zjui+lqqz4j7eBTNvHGSiezuHuFO4BRdXiThnVqBw
bPuvE7iPJF91S4z1QN6ZCRIz7k7Gm5Hue9nI94piiR63j86/Ijr2NbSGOTKq
wj1zp/XQF9OBSDCkf6USd0TieZe+KoCKI3uqNuLudlSmrb0WhmiFj2K1Ngxg
fPuaIeVmpMv/YWsobrH8JcqG25FoUCDnvzWNgW2FG7PEftFoJkISvsiKASbv
Llt6bCcKOlCTdXIKA2XKQUPB3UQk/k6hGJjEQN7es8llru+j5Ul0mdWCgQXq
gfhufgriuahcvjZjYJ3+FqdJmIo6mMrVahP+97v2wxuK0tG9wp90BQYMPPyS
4pRaJ0Jx/Rk5I4MYyO4yZyu+/RCxL8kOiNQY4CQvKVj8SQ5qXdMCGEoMxBhd
VsZE5SHTgC33zjf4P9HvDAlYYpTd1GffUYyB6ODleUGPDyHtb/Twrl0Y8E0x
8W6/fhSFR+kMH3lh4I0G33hm1jFUMuw1cfMvE2hvc5YxZJ8h3bB79cNzJtCQ
/qDySe9JZDeYm2TYbAIsJE/Myf8cBZjaS/uvGYGPabiApzyFQqTNwc9zjQAz
hqGD5tOot/mFpbBuDDzYWlffcFWKNN4JGPvFMcCVVHoYJeXoXx1ZaBk=
          "]}, {
         Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A23", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQ7XUxznL9/jY7BigwLznYefjuEXsY/1JAxOHsfVfh
fKWFFm841R/A+VdnT66ODHkK5+8+uKPp78dXcH6D13SvG+IfEPKe2/nvvPsE
53/utJs+d8dXOP+WQt6StKAfcH7U2aa3kSq/4fzOC/Z7Qo79hfOjuTYta9Nl
cIDx7bab8f6YzAjnV/T3m+U+YoLz6z/dqv3uwwLns36LXPZgAyuc/0hl7cSz
f9jg/J57n2adT+GA83sP86Rf3cIJ50cbSwZ+UOCG85c7R8pktfHA+d71uaue
X+aF8/e4loRV2fLD+YdmL0/qcBeA858+WcfF/BbBzy9e79ixQBDOXyouFcXv
IQTnOzLWMS78i+DL7K6WfLReGM5f1PVYSDVMBM7vn+8yu4hLFM7XOMXPemgT
gs9wtOT+gXAxON+O9bLHKS5xhPro2ZOvbkTwK77F5L5Ok4DzS5Z3aDALSML5
6zX8Qk5tRfAD3/Pwz8mUgvPnnzZdnS8oDecHvw2/5nscwXe/L1x0u1IGzn/2
zPJ9loIsnP/aOPI3y1UEf860Ry8W1MrB+T0nWd3fKMnD+Y8clUycriH4n9JD
GM/aKcD5ywJFDOpmIvhVyori7Z8QfBWGx+8muCrC+Y31inwL5iP4WzhF5TZ8
RvBnmbWWHvVTQvjX26nVaAWCX5W9pXXBbwSfQ2/xWeEwZTg/57cbW8cqBN9I
JODX//8IPgBiFdIt
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27814#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 10.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQ7XUxznL9/jY7BigwLznYefjuEXsY/1JAxOHsfVfh
fKWFFm841R/A+VdnT66ODHkK5+8+uKPp78dXcH6D13SvG+IfEPKe2/nvvPsE
53/utJs+d8dXOP+WQt6StKAfcH7U2aa3kSq/4fzOC/Z7Qo79hfOjuTYta9Nl
cIDx7bab8f6YzAjnV/T3m+U+YoLz6z/dqv3uwwLns36LXPZgAyuc/0hl7cSz
f9jg/J57n2adT+GA83sP86Rf3cIJ50cbSwZ+UOCG85c7R8pktfHA+d71uaue
X+aF8/e4loRV2fLD+YdmL0/qcBeA858+WcfF/BbBzy9e79ixQBDOXyouFcXv
IQTnOzLWMS78i+DL7K6WfLReGM5f1PVYSDVMBM7vn+8yu4hLFM7XOMXPemgT
gs9wtOT+gXAxON+O9bLHKS5xhPro2ZOvbkTwK77F5L5Ok4DzS5Z3aDALSML5
6zX8Qk5tRfAD3/Pwz8mUgvPnnzZdnS8oDecHvw2/5nscwXe/L1x0u1IGzn/2
zPJ9loIsnP/aOPI3y1UEf860Ry8W1MrB+T0nWd3fKMnD+Y8clUycriH4n9JD
GM/aKcD5ywJFDOpmIvhVyori7Z8QfBWGx+8muCrC+Y31inwL5iP4WzhF5TZ8
RvBnmbWWHvVTQvjX26nVaAWCX5W9pXXBbwSfQ2/xWeEwZTg/57cbW8cqBN9I
JODX//8IPgBiFdIt
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27814#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 10.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 10.}}, {
         5, 7, 1, {75}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
          False}, CompressedData["
1:eJwBaQKW/SFib1JlAgAAAAEAAABLAAAAAAAAAAAAAACliAqltZh8PaWICqW1
mIw9fObHO4hylT2liAqltZicPWeVJodx36E9kDdp8J4FqT3d7NUs5hWwPfI9
d+H8qLM9YDTi9++zyz3kZIS/sMnWPZevF4Npud89pya2SahF/j20MFMZe04K
Pgqn5QYRvRI+e45P89SlMj6a2XLSMk5APvbrPSt7SUc+5CjLqJNGZz5ma2ND
ZF10PlpCYbJ+F30+l7RVQ45oiz4BZL2WriKUPrbtzwsWkZo+1TtxwL5/oD7Q
gPp68rajPsrFgzUm7qY+zAoN8Fklqj7NT5aqjVytPmfKj7LgSbA+txGfq/Eu
wD46Pvb98jjIPl+1Jih6IdA++EntYcAp7D6hnOPXYSH4PkNSSZecJx8/r95M
XHAjLD/H3lug+DdTP9wQl5rBdWE/JhtCyGj5fD/vVpxh+JuIP8iMqDCt6JM/
GO6CMF6Dmz+0py6YB4+hP/fAJZ+K5Kc/O9ocpg06rj+/+YlWyEeyP2TInmAL
qrw/hctZNSeGwz/YMmS6SLfIPzbczqa9A9E/AZ9r8Nar1T/MYQg68FPaP2rS
j61cjuA/7nMbPsHy4z9xFafOJVfnP/W2Ml+Ku+o/7R/LH22l7z9yxDHwp0fy
P+74fVCZvPQ/ai3KsIox9z8mJke+HzX9P3EP4mVanAFAz4ug7CSeBEAtCF9z
758HQIuEHfq5oQpAirFr0SjLD0BE71zUS3oSQMQFBEADDxVAQxyrq7qjF0DC
MlIXcjgaQLNvFBVT+B1AUlZrCRrcIEApq7UEDW4iQAAAAAAAACRArDka1w==

         "], {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 
          56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 
          90, 92, 94, 96, 98, 100, 102, 104, 106, 108, 110, 112, 114, 116, 
          118, 120, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 
          144, 146, 148, 150}, CompressedData["
1:eJxTTMoPSmVkYGCYxjAKRsEoGAVDBwAApX4CQQ==
          "]}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A31", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQ7XUxznL9/jY7BigwLznYefjuEXsY/1JAxOHsfVfh
fKWFFm841R/A+VdnT66ODHkK5+8+uKPp78dXcH6D13SvG+IfEPKe2/nvvPsE
53/utJs+d8dXOP+WQt6StKAfcH7U2aa3kSq/4fzOC/Z7Qo79hfOjuTYta9Nl
cIDx7bab8f6YzAjnV/T3m+U+YoLz6z/dqv3uwwLns36LXPZgAyuc/0hl7cSz
f9jg/J57n2adT+GA83sP86Rf3cIJ50cbSwZ+UOCG85c7R8pktfHA+d71uaue
X+aF8/e4loRV2fLD+YdmL0/qcBeA858+WcfF/BbBzy9e79ixQBDOXyouFcXv
IQTnOzLWMS78i+DL7K6WfLReGM5f1PVYSDVMBM7vn+8yu4hLFM7XOMXPemgT
gs9wtOT+gXAxON+O9bLHKS5xhPro2ZOvbkTwK77F5L5Ok4DzS5Z3aDALSML5
6zX8Qk5tRfAD3/Pwz8mUgvPnnzZdnS8oDecHvw2/5nscwXe/L1x0u1IGzn/2
zPJ9loIsnP/aOPI3y1UEf860Ry8W1MrB+T0nWd3fKMnD+Y8clUycriH4n9JD
GM/aKcD5ywJFDOpmIvhVyori7Z8QfBWGx+8muCrC+Y31inwL5iP4WzhF5TZ8
RvBnmbWWHvVTQvjX26nVaAWCX5W9pXXBbwSfQ2/xWeEwZTg/57cbW8cqBN9I
JODX//8IPgBiFdIt
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27875#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 10.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQ7XUxznL9/jY7BigwLznYefjuEXsY/1JAxOHsfVfh
fKWFFm841R/A+VdnT66ODHkK5+8+uKPp78dXcH6D13SvG+IfEPKe2/nvvPsE
53/utJs+d8dXOP+WQt6StKAfcH7U2aa3kSq/4fzOC/Z7Qo79hfOjuTYta9Nl
cIDx7bab8f6YzAjnV/T3m+U+YoLz6z/dqv3uwwLns36LXPZgAyuc/0hl7cSz
f9jg/J57n2adT+GA83sP86Rf3cIJ50cbSwZ+UOCG85c7R8pktfHA+d71uaue
X+aF8/e4loRV2fLD+YdmL0/qcBeA858+WcfF/BbBzy9e79ixQBDOXyouFcXv
IQTnOzLWMS78i+DL7K6WfLReGM5f1PVYSDVMBM7vn+8yu4hLFM7XOMXPemgT
gs9wtOT+gXAxON+O9bLHKS5xhPro2ZOvbkTwK77F5L5Ok4DzS5Z3aDALSML5
6zX8Qk5tRfAD3/Pwz8mUgvPnnzZdnS8oDecHvw2/5nscwXe/L1x0u1IGzn/2
zPJ9loIsnP/aOPI3y1UEf860Ry8W1MrB+T0nWd3fKMnD+Y8clUycriH4n9JD
GM/aKcD5ywJFDOpmIvhVyori7Z8QfBWGx+8muCrC+Y31inwL5iP4WzhF5TZ8
RvBnmbWWHvVTQvjX26nVaAWCX5W9pXXBbwSfQ2/xWeEwZTg/57cbW8cqBN9I
JODX//8IPgBiFdIt
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27875#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 10.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 10.}}, {
         5, 7, 1, {75}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
          False}, CompressedData["
1:eJwBaQKW/SFib1JlAgAAAAEAAABLAAAAAAAAAAAAAACliAqltZh8PaWICqW1
mIw9fObHO4hylT2liAqltZicPWeVJodx36E9kDdp8J4FqT3d7NUs5hWwPfI9
d+H8qLM9YDTi9++zyz3kZIS/sMnWPZevF4Npud89pya2SahF/j20MFMZe04K
Pgqn5QYRvRI+e45P89SlMj6a2XLSMk5APvbrPSt7SUc+5CjLqJNGZz5ma2ND
ZF10PlpCYbJ+F30+l7RVQ45oiz4BZL2WriKUPrbtzwsWkZo+1TtxwL5/oD7Q
gPp68rajPsrFgzUm7qY+zAoN8Fklqj7NT5aqjVytPmfKj7LgSbA+txGfq/Eu
wD46Pvb98jjIPl+1Jih6IdA++EntYcAp7D6hnOPXYSH4PkNSSZecJx8/r95M
XHAjLD/H3lug+DdTP9wQl5rBdWE/JhtCyGj5fD/vVpxh+JuIP8iMqDCt6JM/
GO6CMF6Dmz+0py6YB4+hP/fAJZ+K5Kc/O9ocpg06rj+/+YlWyEeyP2TInmAL
qrw/hctZNSeGwz/YMmS6SLfIPzbczqa9A9E/AZ9r8Nar1T/MYQg68FPaP2rS
j61cjuA/7nMbPsHy4z9xFafOJVfnP/W2Ml+Ku+o/7R/LH22l7z9yxDHwp0fy
P+74fVCZvPQ/ai3KsIox9z8mJke+HzX9P3EP4mVanAFAz4ug7CSeBEAtCF9z
758HQIuEHfq5oQpAirFr0SjLD0BE71zUS3oSQMQFBEADDxVAQxyrq7qjF0DC
MlIXcjgaQLNvFBVT+B1AUlZrCRrcIEApq7UEDW4iQAAAAAAAACRArDka1w==

         "], {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 
          56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 
          90, 92, 94, 96, 98, 100, 102, 104, 106, 108, 110, 112, 114, 116, 
          118, 120, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 
          144, 146, 148, 150}, CompressedData["
1:eJxTTMoPSmVkYGCYxjAKRsEoGAVDBwAApX4CQQ==
          "]}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A32", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQ7XUxznL9/jY7BigwLznYefjuEXsY/1JAxOHsfVfh
fKWFFm841R/A+VdnT66ODHkK5+8+uKPp78dXcH6D13SvG+IfEPKe2/nvvPsE
53/utJs+d8dXOP+WQt6StKAfcH7U2aa3kSq/4fzOC/Z7Qo79hfOjuTYta9Nl
cIDx7bab8f6YzAjnV/T3m+U+YoLz6z/dqv3uwwLns36LXPZgAyuc/0hl7cSz
f9jg/J57n2adT+GA83sP86Rf3cIJ50cbSwZ+UOCG85c7R8pktfHA+d71uaue
X+aF8/e4loRV2fLD+YdmL0/qcBeA858+WcfF/BbBzy9e79ixQBDOXyouFcXv
IQTnOzLWMS78i+DL7K6WfLReGM5f1PVYSDVMBM7vn+8yu4hLFM7XOMXPemgT
gs9wtOT+gXAxON+O9bLHKS5xhPro2ZOvbkTwK77F5L5Ok4DzS5Z3aDALSML5
6zX8Qk5tRfAD3/Pwz8mUgvPnnzZdnS8oDecHvw2/5nscwXe/L1x0u1IGzn/2
zPJ9loIsnP/aOPI3y1UEf860Ry8W1MrB+T0nWd3fKMnD+Y8clUycriH4n9JD
GM/aKcD5ywJFDOpmIvhVyori7Z8QfBWGx+8muCrC+Y31inwL5iP4WzhF5TZ8
RvBnmbWWHvVTQvjX26nVaAWCX5W9pXXBbwSfQ2/xWeEwZTg/57cbW8cqBN9I
JODX//8IPgBiFdIt
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27936#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 10.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQ7XUxznL9/jY7BigwLznYefjuEXsY/1JAxOHsfVfh
fKWFFm841R/A+VdnT66ODHkK5+8+uKPp78dXcH6D13SvG+IfEPKe2/nvvPsE
53/utJs+d8dXOP+WQt6StKAfcH7U2aa3kSq/4fzOC/Z7Qo79hfOjuTYta9Nl
cIDx7bab8f6YzAjnV/T3m+U+YoLz6z/dqv3uwwLns36LXPZgAyuc/0hl7cSz
f9jg/J57n2adT+GA83sP86Rf3cIJ50cbSwZ+UOCG85c7R8pktfHA+d71uaue
X+aF8/e4loRV2fLD+YdmL0/qcBeA858+WcfF/BbBzy9e79ixQBDOXyouFcXv
IQTnOzLWMS78i+DL7K6WfLReGM5f1PVYSDVMBM7vn+8yu4hLFM7XOMXPemgT
gs9wtOT+gXAxON+O9bLHKS5xhPro2ZOvbkTwK77F5L5Ok4DzS5Z3aDALSML5
6zX8Qk5tRfAD3/Pwz8mUgvPnnzZdnS8oDecHvw2/5nscwXe/L1x0u1IGzn/2
zPJ9loIsnP/aOPI3y1UEf860Ry8W1MrB+T0nWd3fKMnD+Y8clUycriH4n9JD
GM/aKcD5ywJFDOpmIvhVyori7Z8QfBWGx+8muCrC+Y31inwL5iP4WzhF5TZ8
RvBnmbWWHvVTQvjX26nVaAWCX5W9pXXBbwSfQ2/xWeEwZTg/57cbW8cqBN9I
JODX//8IPgBiFdIt
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$27936#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 10.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 10.}}, {
         5, 7, 1, {75}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
          False}, CompressedData["
1:eJwBaQKW/SFib1JlAgAAAAEAAABLAAAAAAAAAAAAAACliAqltZh8PaWICqW1
mIw9fObHO4hylT2liAqltZicPWeVJodx36E9kDdp8J4FqT3d7NUs5hWwPfI9
d+H8qLM9YDTi9++zyz3kZIS/sMnWPZevF4Npud89pya2SahF/j20MFMZe04K
Pgqn5QYRvRI+e45P89SlMj6a2XLSMk5APvbrPSt7SUc+5CjLqJNGZz5ma2ND
ZF10PlpCYbJ+F30+l7RVQ45oiz4BZL2WriKUPrbtzwsWkZo+1TtxwL5/oD7Q
gPp68rajPsrFgzUm7qY+zAoN8Fklqj7NT5aqjVytPmfKj7LgSbA+txGfq/Eu
wD46Pvb98jjIPl+1Jih6IdA++EntYcAp7D6hnOPXYSH4PkNSSZecJx8/r95M
XHAjLD/H3lug+DdTP9wQl5rBdWE/JhtCyGj5fD/vVpxh+JuIP8iMqDCt6JM/
GO6CMF6Dmz+0py6YB4+hP/fAJZ+K5Kc/O9ocpg06rj+/+YlWyEeyP2TInmAL
qrw/hctZNSeGwz/YMmS6SLfIPzbczqa9A9E/AZ9r8Nar1T/MYQg68FPaP2rS
j61cjuA/7nMbPsHy4z9xFafOJVfnP/W2Ml+Ku+o/7R/LH22l7z9yxDHwp0fy
P+74fVCZvPQ/ai3KsIox9z8mJke+HzX9P3EP4mVanAFAz4ug7CSeBEAtCF9z
758HQIuEHfq5oQpAirFr0SjLD0BE71zUS3oSQMQFBEADDxVAQxyrq7qjF0DC
MlIXcjgaQLNvFBVT+B1AUlZrCRrcIEApq7UEDW4iQAAAAAAAACRArDka1w==

         "], {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 
          56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 
          90, 92, 94, 96, 98, 100, 102, 104, 106, 108, 110, 112, 114, 116, 
          118, 120, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 
          144, 146, 148, 150}, CompressedData["
1:eJxTTMoPSmVkYGCYxjAKRsEoGAVDBwAApX4CQQ==
          "]}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A33", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwl0mdM01EQAPACljBtmRVZHSD4QYOA4MD+DxwgKBEoo2AkKkNBJFZMFGXY
yFJMNTUSKbJkKIoglhWGDMEINhKxSFCBlKEyBIsgQ1Lt9cPLyy937+Xd3WOc
ivePVCeRSG7/l3I3qeZ9StJoJtRXuucVijnCNaE9q/Pra6KU7/9D6Q/HQjpj
W6VEbYovmlm0a0bbbpRwWlBZKhJe5XImiLq7F9FN7Q389V9ThKl7LjrVO8d7
kDZPFDC+qOKH6ylffsqJnSLHKaUXstg5DxsWCebeW+gh+vmSKP9loil/Eh0q
4c9ybdaIfsPKaaWz+ohmTvc6sSdgaEbpMJ2asvRtJAh0hlml2fUu+stCNejb
xMH4ZYHAJU6mDoeuBeD5FPlQ0p8jG6BSsoL3k5e4ZaPVZIg8kY+W2VTelfzV
BJ5wCzp7WJ77PkILtD7qom936kVLxdrQK1/CesKczPzm6bpg1/obXb6faxGT
rgcX+ATm+6TEVXzr1wcPrxJ088GEoMR9FDAmLaI7ROWnMj2pkGNNxfdNjD/X
0ZilQmrwaXT8xSr3zEIDKJFL0aW0zaEUL0P41WWN9bmrJasVrRvCSd5utEXT
VTNZlRFUhEegi2+OGdoGGcMdUwFaUHBAxNMxgUHOM7R9D4XcUWMCGTvEaFJX
wkhbsCmEjNeh2eR+rx4dGtiyG1X5YSKh9AUNXG+8UvV36XjcdNQmiBO0oxPK
M+01qGYQmNeMrrL35fTUmsG9yAa035weJe/sZhgZbEIX9O58Gm9gDsLYDnTA
bPDA0TfmsMTuQXuOGPE+X7GANod+9OTk7rkYuiU0bvmKnnbirm2QWkIvMYXO
uy/7XphkBQq3VXT2W7LnDNMa6lp08X/I3JnOHgPW8PINDS2P5qhJ2HTYOm2E
LvMzdkh+QIfG4kU8n8hi0DLkdKgiq/phQxr7eecgAzjUVPT1FMbGwgIGhIRz
0WJtE6vqBQawYjzQuS5pl7p8mSBp2aGq18cjzfExE7rlqvklxorTCteYIDij
gdba/khiFMSCd/HDOO9za4c0MytYwJ9rQTsaH1tVKFjwpKQM/Q+llSQY
                    
                    "]]}, Annotation[#, 
                    "Charting`Private`Tag$27997#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, 
                    AxesOrigin -> {0, 0.9999999577303159}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0.9999999577303159}, DisplayFunction :> 
                    Identity, Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {0.9999999577303159, 
                    0.9999999716453944}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJwl0mdM01EQAPACljBtmRVZHSD4QYOA4MD+DxwgKBEoo2AkKkNBJFZMFGXY
yFJMNTUSKbJkKIoglhWGDMEINhKxSFCBlKEyBIsgQ1Lt9cPLyy937+Xd3WOc
ivePVCeRSG7/l3I3qeZ9StJoJtRXuucVijnCNaE9q/Pra6KU7/9D6Q/HQjpj
W6VEbYovmlm0a0bbbpRwWlBZKhJe5XImiLq7F9FN7Q389V9ThKl7LjrVO8d7
kDZPFDC+qOKH6ylffsqJnSLHKaUXstg5DxsWCebeW+gh+vmSKP9loil/Eh0q
4c9ybdaIfsPKaaWz+ohmTvc6sSdgaEbpMJ2asvRtJAh0hlml2fUu+stCNejb
xMH4ZYHAJU6mDoeuBeD5FPlQ0p8jG6BSsoL3k5e4ZaPVZIg8kY+W2VTelfzV
BJ5wCzp7WJ77PkILtD7qom936kVLxdrQK1/CesKczPzm6bpg1/obXb6faxGT
rgcX+ATm+6TEVXzr1wcPrxJ088GEoMR9FDAmLaI7ROWnMj2pkGNNxfdNjD/X
0ZilQmrwaXT8xSr3zEIDKJFL0aW0zaEUL0P41WWN9bmrJasVrRvCSd5utEXT
VTNZlRFUhEegi2+OGdoGGcMdUwFaUHBAxNMxgUHOM7R9D4XcUWMCGTvEaFJX
wkhbsCmEjNeh2eR+rx4dGtiyG1X5YSKh9AUNXG+8UvV36XjcdNQmiBO0oxPK
M+01qGYQmNeMrrL35fTUmsG9yAa035weJe/sZhgZbEIX9O58Gm9gDsLYDnTA
bPDA0TfmsMTuQXuOGPE+X7GANod+9OTk7rkYuiU0bvmKnnbirm2QWkIvMYXO
uy/7XphkBQq3VXT2W7LnDNMa6lp08X/I3JnOHgPW8PINDS2P5qhJ2HTYOm2E
LvMzdkh+QIfG4kU8n8hi0DLkdKgiq/phQxr7eecgAzjUVPT1FMbGwgIGhIRz
0WJtE6vqBQawYjzQuS5pl7p8mSBp2aGq18cjzfExE7rlqvklxorTCteYIDij
gdba/khiFMSCd/HDOO9za4c0MytYwJ9rQTsaH1tVKFjwpKQM/Q+llSQY
                    
                    "]]}, Annotation[#, 
                    "Charting`Private`Tag$27997#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, 
                    AxesOrigin -> {0, 0.9999999577303159}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0.9999999577303159}, DisplayFunction :> 
                    Identity, Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
                    PlotRange -> {{0., 10.}, {0.9999999577303159, 
                    0.9999999716453944}}, PlotRangeClipping -> True, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "10.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 10.}}, {
         5, 7, 1, {75}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
          False}, CompressedData["
1:eJwBaQKW/SFib1JlAgAAAAEAAABLAAAAAAAAAAAAAACliAqltZh8PaWICqW1
mIw9fObHO4hylT2liAqltZicPWeVJodx36E9kDdp8J4FqT3d7NUs5hWwPfI9
d+H8qLM9YDTi9++zyz3kZIS/sMnWPZevF4Npud89pya2SahF/j20MFMZe04K
Pgqn5QYRvRI+e45P89SlMj6a2XLSMk5APvbrPSt7SUc+5CjLqJNGZz5ma2ND
ZF10PlpCYbJ+F30+l7RVQ45oiz4BZL2WriKUPrbtzwsWkZo+1TtxwL5/oD7Q
gPp68rajPsrFgzUm7qY+zAoN8Fklqj7NT5aqjVytPmfKj7LgSbA+txGfq/Eu
wD46Pvb98jjIPl+1Jih6IdA++EntYcAp7D6hnOPXYSH4PkNSSZecJx8/r95M
XHAjLD/H3lug+DdTP9wQl5rBdWE/JhtCyGj5fD/vVpxh+JuIP8iMqDCt6JM/
GO6CMF6Dmz+0py6YB4+hP/fAJZ+K5Kc/O9ocpg06rj+/+YlWyEeyP2TInmAL
qrw/hctZNSeGwz/YMmS6SLfIPzbczqa9A9E/AZ9r8Nar1T/MYQg68FPaP2rS
j61cjuA/7nMbPsHy4z9xFafOJVfnP/W2Ml+Ku+o/7R/LH22l7z9yxDHwp0fy
P+74fVCZvPQ/ai3KsIox9z8mJke+HzX9P3EP4mVanAFAz4ug7CSeBEAtCF9z
758HQIuEHfq5oQpAirFr0SjLD0BE71zUS3oSQMQFBEADDxVAQxyrq7qjF0DC
MlIXcjgaQLNvFBVT+B1AUlZrCRrcIEApq7UEDW4iQAAAAAAAACRArDka1w==

         "], {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 
          56, 58, 60, 62, 64, 66, 68, 70, 72, 74, 76, 78, 80, 82, 84, 86, 88, 
          90, 92, 94, 96, 98, 100, 102, 104, 106, 108, 110, 112, 114, 116, 
          118, 120, 122, 124, 126, 128, 130, 132, 134, 136, 138, 140, 142, 
          144, 146, 148, 150}, CompressedData["
1:eJxTTMoPSmVkYGCYxgADH+wZUMAon1L+v////9e3vNuLi/8XjU8r9/wHg/f2
MS95PrkyPYDbd9xE8oia521bGH/xIcnpObk39ib9hahXC7uY17vSYd+GXxC+
QO60N7vUHfddePsPzGfnmmOwI710H+vDv2D+/Yobq2TSSvft3zwFzPctquKO
Ob1qH1O7NpjvzCypaAnkh5+0/QLi9xg/uBXvdnFf1k//lyC+/LPt22uA/Gds
AWB+6JeI6RPdDtoZC0PkX+pu3jerSmLfFO5AMF8x+dBNgYc6dj/4IeovzeWJ
1/YS36duB+GfydbxKD3zzzZYD8L3CqrQ2zP57t6pvhB+ZNaTLev6D+xdZBYE
5kddq1Vi9mS0M5wGkXeXNbbQesuy78Z9CP/mrYVbdKMv2ir1+YH5h96oBn19
8mOvzAUvMJ+39kSFwex/e8svQ9S7CXOYiLwWtlOanA7m+31oUfCZoWxnJ9QE
5reoiU6Ni5SxS2SYCfH/ZvmOffxidtxLLoP5SS52ZTIsBnYvFsq+AvFLLkdM
2sBtYHf6YzaYvy+SV5bXSd8uUW8XmH/wi93M1db6dlPNp78B8ZeWlKyTWBJg
5zPbC8zX3MIksMgtaN/k8+/A6o8/Ud/wZLHiPo2PAmD+0pnJ1XeWHrPVC30H
tr+9yt7qzLXre3eW/QPL793a8FE24IatWYs62Dz5OyecOdwZ7URWrgHz3/fv
++N+gNGu4tQ+MF/hmpDwbu0/tlU/doL5vVyFcp+bP9veVnoL5k/eazzJOIrV
TsXtBJjPlJhuKe2qvc/vmg6Yz8koEz3jNfO+FUuWvQbx7T+4rbrwgn0fAKRV
0o8=
          "]}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}]}], "}"}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.8861565026131573`*^9, {3.886156554316338*^9, 3.8861565600449677`*^9}, 
   3.886156590103726*^9, {3.886156670208988*^9, 3.886156704092814*^9}, 
   3.886156810240736*^9, {3.8861568964998283`*^9, 3.88615694288693*^9}, {
   3.886157022479546*^9, 3.886157059233892*^9}, {3.886157570041936*^9, 
   3.88615773103743*^9}, {3.886161485286202*^9, 3.886161502332156*^9}},
 CellLabel->
  "Out[495]=",ExpressionUUID->"027a1e9a-c09a-4030-a051-9dcef5603278"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
    GraphicsBox[{{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           RGBColor[0.368417, 0.506779, 0.709798], 
           AbsoluteThickness[1.6]], 
          LineBox[CompressedData["
1:eJwB4QQe+yFib1JlAgAAAE0AAAACAAAAnX5iBjFkez6f6mh1jSpDvsTTIExX
IFk/RMtuxG0aFL//xr6DICBpP+llxTT4GSS/ncCNHwUgeT8BtkNjwBk0v2w9
dW33H4k/HQl21KMZRL/T+2iU8B+ZP1an13mWGVS/B9viJ+0fqT8yBWcDkBlk
v6HKn3HrH7k/NKnp6oYZdL+ur4nbbC7KP47qR3na8YS/Zz/Rmexy0z+XTAkB
+B2Pv27lKeO0rtk/qt6wsGeLlL8KIYQn3zjgPyPcPdDf85m/jhDLKqFg4z81
dmJ0yf+ev2LbVL8DzOY/yJJlN9I7or9xxYRibyfqP8Bv4LDa6qS/sXAMUxhJ
7T/WaHyFlGunv6F7a+owV/A/srGVvjEiqr+Cn/xR9OzxP6Rlog18qqy/ANPg
QLx68z+OMPzH2CWvvyZ0ZnhUKvU/dDUcq4DrsL/k9ZdWC732P1WVPX3qLLK/
SuVqfZJx+D+dNwp4MImzv07kkCseHvo/uI4qxfTetL/qw2KAyK37P3FG2ymP
Hba/LhHWHUNf/T+nE9YP93a3vwo/9WHc8/4/ercS+jS5uL9H7Vr3IlUAQKFz
WYA0Frq/2MJkAVosAUAYcMSyqWy7v7WIxF4g9QFALlch6/ervL9mBXXgzs4C
QEEw5Gb2Bb6/Y3J7tQyaA0AKNj0Yz0i/vy9nK85MYQRAT5jz449CwL/PEiwL
dTkFQAztuTMH7sC/u66CmywDBkBBi45K7o3Bv3sBKlDM3QZAL+dSyxw7wr8K
3HpIbrQHQABNStQA5cK/5aYhlJ98CEBpWxsrWIPDv5QoGQS5VQlAUjIlRewu
xL+QmmbHYSAKQNA3Jkz1zsS/WpRdzgznCkAFLfkVt2vFv/hEpfmfvgtAfIXw
jqoVxr/j5UJ4wocMQMaR+JUXtMa/oj0xG81hDUANW5YprV/Hv62FdRFnLQ5A
j+9Fib7/x7+HVWNLA/UOQKLEfuuGnMi/NdyhqYfND0DOqrZ5a0bJv5gpm63N
SxBA24nlp9Hkyb9/wI2YS7kQQDpszdBJkMq/TRtVpcokEUAufXGJcTjLv0Fu
x1sRiRFAeHc5pSHVy7+fHGIkzPURQC26fs7Vfsy/JMOnlk5bEkDpXzieFR3N
v5AtwirSvhJAdHgrggu4zb9m8wTRySoTQCSgJzL3X86/YrHyIImPE0AmtMpP
dvzOv2yCU/xKkRNAY/u7qjD/zr91U7TXDJMTQI0w2QHrAc+/iPV1jpCWE0D6
CpakXwfPv645+fuXnRNAQgwQvEgSz7/5wf/WpqsTQNGguTIaKM+/kNIMjcTH
E0CHFIY8ulPPv5qjbWiGyRNAz6VNHHRWz7+jdM5DSMsTQFlXNvgtWc+/thaQ
+svOE0CHwWmkoV7Pv9xaE2jT1RNASD5Pzohpz78n4xlD4uMTQLQ5yWdWf8+/
MLR6HqTlE0D6S3oJEILPvzqF2/ll5xNAsRdHp8mEz79MJ52w6eoTQLGBMtc8
is+/cmsgHvHxE0AYLEcII5XPv3w8gfmy8xNA35XMityXz7+FDeLUdPUTQKcF
awmWms+/mK+ji/j4E0CQnfH6CKDPv6KABGe6+hNA1hjZbcKiz7+rUWVCfPwT
QGhA2Nx7pc+/tCLGHT7+E0Dcve5HNajPv77zJvn//xNAxDocr+6qz7+bc21c

           "]]}, Annotation[#, "Charting`Private`Tag$28059#1"]& ], 
        TagBox[{
          Directive[
           Opacity[1.], 
           RGBColor[0.880722, 0.611041, 0.142051], 
           AbsoluteThickness[1.6]], 
          LineBox[CompressedData["
1:eJwVy38803kcwPH5XSibbzpLs3FKLcLjco9cP96fUpdS3ZUfXfohi1ETER2m
0pqQsKsVhjSSskO0FDqtJT/G9n2wJsf68cD0uFUuaVjUrvvj9Xj+9XJixO6O
MCYQCDu+9b8lpxnmXuHs9YGqmWGB3m59q5K2fQ9tLzRvuRX7C3kBGNpaztFo
R2DAnmF5hOwCJZIcqhktGSTPSYok8iqIXpd4bIqaBUSbF3PTyJtAORPF/0At
hJ392XwuORAsBodc31Nvw9FYKTGDHA5CWWncW2ojOJgK4jjkBKipzRqMXimD
3q8Va/vHuRAJPYXv4pUQUXa8VUfJgxjN8mFxzd9w/tnRS8xsPlg6cV1frX4N
14oJ9S8nCiGX2EUXHhqGCF+P4A7DNWAMBj4y6R4FRfTuWz1ryiDuKZcR66qF
1PJnTgPaG1B33DrAfut7CDyUNHmZVQlCNkvruecD+NgWeXg5VwGndHbXp3fj
4H2q7jS76k8gKF+jhykTEFBt59O/pBaWJjCTAuk6iFlQezjt7R0Y0eUHW/01
CVRhn7fWrR62aY6euhQ3DaKEKk/PrLuwc4S3wtHxM/D395769FIM2ieMtI7q
GRi9cmEol9IAK0l9FN/QL2BjltsxefI+WIIuTD3xFYrclfWrGh/AlvchU85B
BLSl4nufVQuboF8abhTiZoTe1BWwbkc3w73M1oM0nRE6dNxQPiV6CEyzxNcK
hTHKOyGnTpq1wOF49j1rgQmq3O/Vo/B7BB6RKxTbw0xRts8JSd5GCeC2blaJ
PmaIpgSixZgEmms4RW4m5uhg+iLXsZzHwDai/9r9whyF39dULl4jBUt1il+M
2ALdxUbuEDRS0Nx04pemzkH2A80Wv517AvxlZNPGoLlItVru9G5lK/AEzPYw
miW6maZaplO0Qgj/gML6jSW6JKv92MB6CtObKvSlLVbILKiWVWXXBsOajUnS
DGuUgh7Ffydug7J1Xg7ysHnIqyfCvDq0HarTE0mR7vORv5LCbDG0Q0bQYX8T
3Xz0r3Nox/niDvBWC29nyG3Q7uTrwayfO6FgeVG13J+IosL6uT0jnXBGklPg
30hEv++QVW/lyWCHQ1CFzIWEsOQkZtzqLtgQ076PlEVCP5K3cZxUXVC6mOHS
rSOhLzYCkep0N7g8qby6c58tMh87wLajyIHnLqX3ttii0Q37Qq0eyIE5YdrT
ScfQfgnDZipUAYy6j7SsPAy5lBHdT84qIJoTMLvtDww5LDLO9DQoIDFA/Nz6
MoZM06ivtEY4ZOoSc3lXMfSlWX021AKHGh/9TH4JhnLT9hT62eKgf2zouynC
0JliY+KiZTjweq1zWtsx5OHcS24KwEFQfizqfCeGmkcK9SeCcShPUPj6dX37
2zkq9704NCzkfe5SYGgvv+Gs8CAO6hAsSqnCUFZfsSjzCA6uw2TfoWEMXT9g
vzn4DA6e4hTHGxoMxQo7R204OPyUPqiPeIOhu9eucju5OGx3LbnzjxZDAyyO
eO0FHOJZNMfxcQxJ1fka5ys4pK49q6+fwNAPSZQodT4O6fOGniXoMCQiPxy9
IsChoLY8e3oaQwQ73/4513EoSzONbPqMISMp3V9ahoNoV8TG1FkMBTrQm9gV
OIid2yjrv2Loogwt8b6FQ8vEUr3BgKF1yTEXx6pw+A8QBkUO
           "]]}, 
         Annotation[#, "Charting`Private`Tag$28059#2"]& ]}}, {}}, {
     DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
      AxesOrigin -> {0, 0}, 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      GridLines -> {None, None}, DisplayFunction -> Identity, 
      PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}}, PlotRangeClipping -> True, ImagePadding -> All, 
      DisplayFunction -> Identity, AspectRatio -> 
      NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
      AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
      Identity, Frame -> {{False, False}, {False, False}}, 
      FrameLabel -> {{None, None}, {None, None}}, 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], 
      Method -> {
       "DefaultBoundaryStyle" -> Automatic, 
        "DefaultGraphicsInteraction" -> {
         "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
          "Effects" -> {
           "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
            "Droplines" -> {
             "freeformCursorMode" -> True, 
              "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
        "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> 
        None, "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}}, 
      PlotRange -> {{0, 5}, {-0.24740394163423762`, 0.2474039254856936}}, 
      PlotRangeClipping -> True, PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.02]}}, Ticks -> {Automatic, Automatic}}], 
    FormBox[
     FormBox[
      TemplateBox[{
        RowBox[{
          RowBox[{"A12", "(", 
            TagBox["t", HoldForm], ")"}], "/.", "\[VeryThinSpace]", "rule"}], 
        
        RowBox[{
          RowBox[{"A21", "(", 
            TagBox["t", HoldForm], ")"}], "/.", "\[VeryThinSpace]", "rule"}]},
        "LineLegend", DisplayFunction -> (FormBox[
         StyleBox[
          StyleBox[
           PaneBox[
            TagBox[
             GridBox[{{
                TagBox[
                 GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                  AutoDelete -> False, 
                  GridBoxDividers -> {
                   "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                  GridBoxItemSize -> {
                   "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
              GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
              AutoDelete -> False, 
              GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
             "Grid"], Alignment -> Left, AppearanceElements -> None, 
            ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
            "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
          False], TraditionalForm]& ), 
       InterpretationFunction :> (RowBox[{"LineLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.368417`", ",", "0.506779`", ",", "0.709798`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.880722`", ",", "0.611041`", ",", "0.142051`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], 
                  "]"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                TagBox[#, HoldForm], ",", 
                TagBox[#2, HoldForm]}], "}"}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"{", "}"}]}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
       Editable -> True], TraditionalForm], TraditionalForm]},
   "Legended",
   DisplayFunction->(FormBox[
     GridBox[{{
        TagBox[
         ItemBox[
          PaneBox[
           TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
           BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
         "SkipImageSizeLevel"], 
        ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
      GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
      AutoDelete -> False, GridBoxItemSize -> Automatic, 
      BaselinePosition -> {1, 1}], TraditionalForm]& ),
   Editable->True,
   InterpretationFunction->(FormBox[
     RowBox[{"Legended", "(", 
       RowBox[{#, ",", 
         RowBox[{"Placed", "[", 
           RowBox[{#2, ",", "After"}], "]"}]}], ")"}], TraditionalForm]& )], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.8861565026131573`*^9, {3.886156554316338*^9, 3.8861565600449677`*^9}, 
   3.886156590103726*^9, {3.886156670208988*^9, 3.886156704092814*^9}, 
   3.886156810240736*^9, {3.8861568964998283`*^9, 3.88615694288693*^9}, {
   3.886157022479546*^9, 3.886157059233892*^9}, {3.886157570041936*^9, 
   3.88615773103743*^9}, {3.886161485286202*^9, 3.8861615026892147`*^9}},
 CellLabel->
  "Out[496]=",ExpressionUUID->"4ad1ef1f-8f7e-43a4-9c6f-39a393b2e5bf"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
    GraphicsBox[{{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           RGBColor[0.368417, 0.506779, 0.709798], 
           AbsoluteThickness[1.6]], 
          LineBox[CompressedData["
1:eJwd1Xk8VekfB3BclCVzOfNrtdVUQou2KSa+T13GEC3WwhDFTYsmv5ClZEsN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           "]]}, 
         Annotation[#, "Charting`Private`Tag$28146#1"]& ], 
        TagBox[{
          Directive[
           Opacity[1.], 
           RGBColor[0.880722, 0.611041, 0.142051], 
           AbsoluteThickness[1.6]], 
          LineBox[CompressedData["
1:eJwd1Qk4VfkbB3B7uAhnxlCyNJXQXtNi4v2VkQmZGUsaFUNy02LGnS6FpNLI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           "]]}, 
         Annotation[#, "Charting`Private`Tag$28146#2"]& ], 
        TagBox[{
          Directive[
           Opacity[1.], 
           RGBColor[0.560181, 0.691569, 0.194885], 
           AbsoluteThickness[1.6]], 
          LineBox[CompressedData["
1:eJwl0ws0FFgYAGBjEDODmSE9aMyUwniU3UrtnvbeilN5rZTVatvMECVDOk3r
3UbCLiWpJJrKkR5SNrVJ3jRMBjUt2lJ5TA+Nxmu8zezOP/ece+75zrn3/+/j
vyxuhM8+bS0trdD/u3rMT+DqOQXF/qAFbQg1SJgefsyfEYPFU6lUcqR6WpXE
ZB5AnvxvlGobZT28R+o6jDjytmm182syLHWZ0Sii8ey42vbyoFOqkGMo/e7g
iNrdRpeVs52JiJefJlfb6rrB2umZZNSWulymdtgGPm/CMg0FCJo+qe0iPrN8
vDML5e9aCZbM7M8esryI9Cq7P6sdVUwuH+m8hspqtoPnve61HrS8iSwbfgTT
85q0hzv/QputvcFXRYLIL5blqBFpfExk7+a0tx6lsnzAJXfTXoc5ilDyZ816
AflZEs21HZGKNPND0POLssMSNOiocWhWfFV7ZgcKfOcJDpfa9pWVvELL9ruD
a00WXVxP7UbTXDcwiXXC+t2694ixURO/JcfatqalB5074Ac+RX3GvhrQh4IC
ueBJhTHfx0yKvi2KBHNf76wmtnxAt1GCJn+7LLM8+hNirP8DHNl4ghthPYB6
8s6BaZea/t386AuaNLsCLj1E2bFw2yB6PL8UPH1/2KRy5iuKW9OsuZ/YgwOr
/IZQTHEfOFEwu31MNozSUukDamtJ3uMnMaNIwXABrzgSHLWTrUAj/Ghwv+LC
T+TKcZT6z23wBR5hwOvCBDrwSAh2k4bGZ0VOolN/ysAt/fE7u7ZMoeIE8y9q
e/Vn2jEY00h+3xds8XLKd1Q6jZ4JzoMH6rm/N92ZQRLXXnB6qEVb8slZZD6F
oX4caR1LNu+dQ84Hi8EWN6TVp22VyL9ACSYhBefNqBJFOzsNQv50XxtamwpF
xbqCtwz6Tyz11cLXTJ3B1K69cVU1WrjgqD64qy6I4G9PwEnSxxDvaaHpqspM
ApaX+YEfpDb8ylQQsLJEDvszEuYJJjjaOH5xLjhYl/++tVUb90T8Au7/flLE
W03Eiy1WgwMPxz6g5BKx866F4OYwSW3xHBGzj+qCV4bYtXpwdLDMYALuT/Xk
tixArINZtz6A2+j2ZP56XWxW1AxuDPCTeF/WxXbZheCKksRL9kQ9XJIYDzbf
1cGPO6SHPaQ+4FgC27ulWw8T2h3BdeE+Hku2zcPt3AVg0puYreFl8/DKQSo4
aqPX15ML9TFvzggsvc7KFsTpY0keCfwkZImH/Wd9XM/SAWfbLNIp9zXA+4Zn
ob6yeqr3GVYY4LFz4+DM3GAhh0nCFceHwfwFvW5/J5Hw5etfwf7Ze1opH0l4
K2MIfDOMENThQ8azomnNf3EpnBJUkbFdsiHkC58/ts5pGQV7l1qB+6SboupS
KFjYjzTnoz1uFo5RcMOmAPC1DU7mYo4hTug4Dr7B2WGWKzTE3926Ar6TzKeF
OBjhsiOV4FxemOOaM0Z4qUsHOMU30J2oMMIOWwbAb3MSY1w5xviWbBK85s3V
myliY6wdqwS/Iq+t3bqIimc/EuF9c2wv3RG7U3HwaRqYwjctSE+k4naFNfhY
TUaOezkVv/zNBfyBN8wgy6nYMy8I7GnuWyiyomGxeQp4Y7hwNy2NhksqheBD
jaY14dU0zC/4CBZYcK1aFDR8lkCE+u2Vn9iTYUPHxW/NwFb1Ree9dtNxb8Uy
sP9kWQA1g46NlTbgTIc69osqOqaJHMGxmX1z4jE6Ztc6g4NHdZ43s03w3eFN
4KAXM1G2e0ywe68XmFs6wkw7bYLviXZr4r2gZDQITbBDYyi4anTFlEplgh8+
igb/B98v1r8=
           "]]}, 
         Annotation[#, "Charting`Private`Tag$28146#3"]& ]}}, {}}, {
     DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
      AxesOrigin -> {0, 0.9689123859506251}, 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      GridLines -> {None, None}, DisplayFunction -> Identity, 
      PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}}, PlotRangeClipping -> True, ImagePadding -> All, 
      DisplayFunction -> Identity, AspectRatio -> 
      NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
      AxesLabel -> {None, None}, AxesOrigin -> {0, 0.9689123859506251}, 
      DisplayFunction :> Identity, Frame -> {{False, False}, {False, False}}, 
      FrameLabel -> {{None, None}, {None, None}}, 
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
      GridLines -> {None, None}, GridLinesStyle -> Directive[
        GrayLevel[0.5, 0.4]], 
      Method -> {
       "DefaultBoundaryStyle" -> Automatic, 
        "DefaultGraphicsInteraction" -> {
         "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
          "Effects" -> {
           "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
            "Droplines" -> {
             "freeformCursorMode" -> True, 
              "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
        "DefaultMeshStyle" -> AbsolutePointSize[6], "ScalingFunctions" -> 
        None, "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}}, 
      PlotRange -> {{0, 5}, {0.9689123859506251, 1.}}, PlotRangeClipping -> 
      True, PlotRangePadding -> {{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.02], 
         Scaled[0.02]}}, Ticks -> {Automatic, Automatic}}], 
    FormBox[
     FormBox[
      TemplateBox[{
        RowBox[{
          RowBox[{"A11", "(", 
            TagBox["t", HoldForm], ")"}], "/.", "\[VeryThinSpace]", "rule"}], 
        
        RowBox[{
          RowBox[{"A22", "(", 
            TagBox["t", HoldForm], ")"}], "/.", "\[VeryThinSpace]", "rule"}], 
        
        RowBox[{
          RowBox[{"A33", "(", 
            TagBox["t", HoldForm], ")"}], "/.", "\[VeryThinSpace]", "rule"}]},
        "LineLegend", DisplayFunction -> (FormBox[
         StyleBox[
          StyleBox[
           PaneBox[
            TagBox[
             GridBox[{{
                TagBox[
                 GridBox[{{
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}, {
                    GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.5], 
                    Opacity[1.], 
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #3}}, 
                  GridBoxAlignment -> {
                   "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                  AutoDelete -> False, 
                  GridBoxDividers -> {
                   "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                  GridBoxItemSize -> {
                   "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
              GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
              AutoDelete -> False, 
              GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
             "Grid"], Alignment -> Left, AppearanceElements -> None, 
            ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
            "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
          FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
          False], TraditionalForm]& ), 
       InterpretationFunction :> (RowBox[{"LineLegend", "[", 
          RowBox[{
            RowBox[{"{", 
              RowBox[{
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.368417`", ",", "0.506779`", ",", "0.709798`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.880722`", ",", "0.611041`", ",", "0.142051`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
                ",", 
                RowBox[{"Directive", "[", 
                  RowBox[{
                    RowBox[{"Opacity", "[", "1.`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.560181, 0.691569, 0.194885], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.37345400000000006`, 0.461046, 0.12992333333333334`], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.560181`", ",", "0.691569`", ",", "0.194885`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.560181, 0.691569, 0.194885]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.560181, 0.691569, 0.194885], Editable -> False,
                     Selectable -> False], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], 
                  "]"}]}], "}"}], ",", 
            RowBox[{"{", 
              RowBox[{
                TagBox[#, HoldForm], ",", 
                TagBox[#2, HoldForm], ",", 
                TagBox[#3, HoldForm]}], "}"}], ",", 
            RowBox[{"LegendMarkers", "\[Rule]", "None"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"{", "}"}]}], ",", 
            RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
       Editable -> True], TraditionalForm], TraditionalForm]},
   "Legended",
   DisplayFunction->(FormBox[
     GridBox[{{
        TagBox[
         ItemBox[
          PaneBox[
           TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
           BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
         "SkipImageSizeLevel"], 
        ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
      GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
      AutoDelete -> False, GridBoxItemSize -> Automatic, 
      BaselinePosition -> {1, 1}], TraditionalForm]& ),
   Editable->True,
   InterpretationFunction->(FormBox[
     RowBox[{"Legended", "(", 
       RowBox[{#, ",", 
         RowBox[{"Placed", "[", 
           RowBox[{#2, ",", "After"}], "]"}]}], ")"}], TraditionalForm]& )], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.8861565026131573`*^9, {3.886156554316338*^9, 3.8861565600449677`*^9}, 
   3.886156590103726*^9, {3.886156670208988*^9, 3.886156704092814*^9}, 
   3.886156810240736*^9, {3.8861568964998283`*^9, 3.88615694288693*^9}, {
   3.886157022479546*^9, 3.886157059233892*^9}, {3.886157570041936*^9, 
   3.88615773103743*^9}, {3.886161485286202*^9, 3.886161502812726*^9}},
 CellLabel->
  "Out[497]=",ExpressionUUID->"e8e969cd-4c72-49db-a69d-a93e976b14bf"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.886156011565024*^9, 
  3.886156020242503*^9}},ExpressionUUID->"eeae57ef-c552-4fe4-9a12-\
73f8ab8412a8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NDSolve", "[", 
  RowBox[{"ODE", ",", 
   RowBox[{"X", "[", "t", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.886156029539525*^9, 3.886156029842453*^9}, {
  3.88615611242969*^9, 3.886156156667238*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"d7fda014-1e7d-4362-bd6a-c4e6198677ed"],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"A11", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$7712#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$7712#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 1.}}, {
         5, 7, 1, {13}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
         0.00010264848819015053`, 0.00020529697638030107`, 0.1002052969763803,
          0.2002052969763803, 0.30020529697638026`, 0.4002052969763803, 
         0.5002052969763803, 0.6002052969763803, 0.7002052969763803, 
         0.8002052969763803, 0.9001026484881901, 1.}}, {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26}, {0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 
          0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A12", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$7864#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$7864#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 1.}}, {
         5, 7, 1, {13}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
         0.00010264848819015053`, 0.00020529697638030107`, 0.1002052969763803,
          0.2002052969763803, 0.30020529697638026`, 0.4002052969763803, 
         0.5002052969763803, 0.6002052969763803, 0.7002052969763803, 
         0.8002052969763803, 0.9001026484881901, 1.}}, {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26}, {0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 
          0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A13", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$7925#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$7925#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 1.}}, {
         5, 7, 1, {13}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
         0.00010264848819015053`, 0.00020529697638030107`, 0.1002052969763803,
          0.2002052969763803, 0.30020529697638026`, 0.4002052969763803, 
         0.5002052969763803, 0.6002052969763803, 0.7002052969763803, 
         0.8002052969763803, 0.9001026484881901, 1.}}, {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26}, {0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 
          0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A21", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$7986#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$7986#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 1.}}, {
         5, 7, 1, {13}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
         0.00010264848819015053`, 0.00020529697638030107`, 0.1002052969763803,
          0.2002052969763803, 0.30020529697638026`, 0.4002052969763803, 
         0.5002052969763803, 0.6002052969763803, 0.7002052969763803, 
         0.8002052969763803, 0.9001026484881901, 1.}}, {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26}, {0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 
          0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A22", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8047#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8047#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 1.}}, {
         5, 7, 1, {13}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
         0.00010264848819015053`, 0.00020529697638030107`, 0.1002052969763803,
          0.2002052969763803, 0.30020529697638026`, 0.4002052969763803, 
         0.5002052969763803, 0.6002052969763803, 0.7002052969763803, 
         0.8002052969763803, 0.9001026484881901, 1.}}, {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26}, {0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 
          0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A23", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8108#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8108#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 1.}}, {
         5, 7, 1, {13}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
         0.00010264848819015053`, 0.00020529697638030107`, 0.1002052969763803,
          0.2002052969763803, 0.30020529697638026`, 0.4002052969763803, 
         0.5002052969763803, 0.6002052969763803, 0.7002052969763803, 
         0.8002052969763803, 0.9001026484881901, 1.}}, {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26}, {0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 
          0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A31", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8169#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8169#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 1.}}, {
         5, 7, 1, {13}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
         0.00010264848819015053`, 0.00020529697638030107`, 0.1002052969763803,
          0.2002052969763803, 0.30020529697638026`, 0.4002052969763803, 
         0.5002052969763803, 0.6002052969763803, 0.7002052969763803, 
         0.8002052969763803, 0.9001026484881901, 1.}}, {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26}, {0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 
          0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A32", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8230#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8230#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 1.}}, {
         5, 7, 1, {13}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
         0.00010264848819015053`, 0.00020529697638030107`, 0.1002052969763803,
          0.2002052969763803, 0.30020529697638026`, 0.4002052969763803, 
         0.5002052969763803, 0.6002052969763803, 0.7002052969763803, 
         0.8002052969763803, 0.9001026484881901, 1.}}, {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26}, {0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 
          0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}], ",", 
     RowBox[{
      RowBox[{"A33", "(", "t", ")"}], "\[Rule]", 
      RowBox[{
       InterpretationBox[
        RowBox[{
         TagBox["InterpolatingFunction",
          "SummaryHead"], "[", 
         DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = 
          "Ready"}, 
          TemplateBox[{
            PaneSelectorBox[{False -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxOpener"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8291#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}], True -> GridBox[{{
                  PaneBox[
                   ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SummaryBoxCloser"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                    "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                   Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                  GraphicsBox[{{{{}, {}, 
                    TagBox[{
                    Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                    LineBox[CompressedData["
1:eJxTTMoPSmViYGCwAWIQveiW95RPRkF2DFBwTJPROnPjBHsYv5R3LZNy6kI4
P2t21AP+Gyvh/Hvr+ae5C2yE8/XPTc5I6dsK5xuVR5Qf2L8Tzo+9s2/TT699
cH503gyhuoSDcP7DzR9fypUehvOrr88OX7ftKJyf55CWfPficTj/R9k2rsJH
J+H86d3hHp/lz8D5fU8lVETNz8H5Z/tET0+yvQDnz5v4MNA36iKcL7N97/Lr
yZfg/CXehzxuNl+G828wXd+xasIVOF9MU6Tk8+arcL6CmUjtu4vX4PzrqSqh
O+9ch/NnsMRW/P57A85nPbY0i5fnFpxvl7dx1UWR23B+Y+tTU16TO3B+wX7N
CRIOd+H8zIxpprOT7sH5ej+Oalyovw/n+19tKn3l8gDO53lmVqNxFcGX5yjO
Ohf9EOG+uRPqz95H8KdlOVlx5D+C81951NxZ9QXBPxLnpdLZ+hjO/9K6IPg8
zxM4v0vhxsq8iQj+0k+Ll3oqPkWE37XvHT3LEXyej/cFuS2fwfkZ9SsPPjqO
4EvJ/45Q8n0O5wd+ezB17l0E/949v10NKS/g/ItW81j3vkDwPc81fjOpeAnn
ixe/PSfyD8HP8n/rY9D/Cs5Xnn/u4xLZ14j0zGBR17gIwT82w3TDTKM3cP5G
p90nJXci+IoqVzuuer2F879VXMh7dRPBV7ofbJMe/w7Ov1yTvV7+A4J/S5ub
y6H8PZy/re3Zt///EXwAlir5SA==
                    "]]}, 
                    Annotation[#, "Charting`Private`Tag$8291#1"]& ]}}, {}}, {
                   DisplayFunction -> Identity, 
                    Ticks -> {Automatic, Automatic}, AxesOrigin -> {0, 0}, 
                    FrameTicks -> {{{}, {}}, {{}, {}}}, 
                    GridLines -> {None, None}, DisplayFunction -> Identity, 
                    PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
                    All, DisplayFunction -> Identity, AspectRatio -> 1, 
                    Axes -> {False, False}, AxesLabel -> {None, None}, 
                    AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
                    Frame -> {{True, True}, {True, True}}, 
                    FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
                    Directive[
                    Opacity[0.5], 
                    Thickness[Tiny], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    FrameTicks -> {{None, None}, {None, None}}, 
                    GridLines -> {None, None}, GridLinesStyle -> Directive[
                    GrayLevel[0.5, 0.4]], ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}], 
                    Method -> {
                    "DefaultBoundaryStyle" -> Automatic, 
                    "DefaultGraphicsInteraction" -> {
                    "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                    "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                    "DefaultMeshStyle" -> AbsolutePointSize[6], 
                    "ScalingFunctions" -> None, 
                    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, PlotRange -> {{0., 1.}, {-1., 1.}}, 
                    PlotRangeClipping -> True, PlotRangePadding -> {{
                    Scaled[0.1], 
                    Scaled[0.1]}, {
                    Scaled[0.1], 
                    Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
                  GridBox[{{
                    RowBox[{
                    TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"(", "\[NoBreak]", 
                    
                    GridBox[{{"0.`", "1.`"}}, RowSpacings -> 1, 
                    ColumnSpacings -> 1, RowAlignments -> Baseline, 
                    ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"scalar\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["3", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["False", "SummaryItem"]}]}}, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                   AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {1, 1}]}, 
             Dynamic[Typeset`open$$], ImageSize -> Automatic]},
           "SummaryPanel"],
          DynamicModuleValues:>{}], "]"}],
        InterpolatingFunction[{{0., 1.}}, {
         5, 7, 1, {13}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
         0.00010264848819015053`, 0.00020529697638030107`, 0.1002052969763803,
          0.2002052969763803, 0.30020529697638026`, 0.4002052969763803, 
         0.5002052969763803, 0.6002052969763803, 0.7002052969763803, 
         0.8002052969763803, 0.9001026484881901, 1.}}, {
         Developer`PackedArrayForm, {0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 
          22, 24, 26}, {0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 
          0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0.}}, {Automatic}],
        Editable->False,
        SelectWithContents->True,
        Selectable->False], "\[InvisibleApplication]", 
       RowBox[{"(", "t", ")"}]}]}]}], "}"}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.886156030390349*^9, {3.8861561230741863`*^9, 3.8861561352694807`*^9}, 
   3.886156218873785*^9, 3.8861562562484713`*^9, 3.8861564680145073`*^9},
 CellLabel->"Out[27]=",ExpressionUUID->"0ffaa2cc-e403-477e-a42f-695818daf380"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"EQN", "\[IndentingNewLine]", "IC"}], "Input",
 CellChangeTimes->{{3.8861562768442307`*^9, 3.886156282554852*^9}, {
  3.8861563748849773`*^9, 3.886156375794957*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"2b2ee4df-f4bb-47c6-b8dc-ba0911dba37d"],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"1", ",", "1"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"1", ",", "2"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"1", ",", "3"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"2", ",", "1"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"2", ",", "2"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"2", ",", "3"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"3", ",", "1"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"3", ",", "2"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"3", ",", "3"}], ")"}]}]}], "}"}], "\[LongEqual]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"a", "(", "t", ")"}], "\[InvisibleApplication]", 
        RowBox[{"(", 
         RowBox[{"1", ",", "1"}], ")"}]}]}], ",", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"a", "(", "t", ")"}], "\[InvisibleApplication]", 
        RowBox[{"(", 
         RowBox[{"1", ",", "2"}], ")"}]}]}], ",", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"a", "(", "t", ")"}], "\[InvisibleApplication]", 
        RowBox[{"(", 
         RowBox[{"1", ",", "3"}], ")"}]}]}], ",", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"a", "(", "t", ")"}], "\[InvisibleApplication]", 
        RowBox[{"(", 
         RowBox[{"2", ",", "1"}], ")"}]}]}], ",", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"a", "(", "t", ")"}], "\[InvisibleApplication]", 
        RowBox[{"(", 
         RowBox[{"2", ",", "2"}], ")"}]}]}], ",", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"a", "(", "t", ")"}], "\[InvisibleApplication]", 
        RowBox[{"(", 
         RowBox[{"2", ",", "3"}], ")"}]}]}], ",", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"a", "(", "t", ")"}], "\[InvisibleApplication]", 
        RowBox[{"(", 
         RowBox[{"3", ",", "1"}], ")"}]}]}], ",", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"a", "(", "t", ")"}], "\[InvisibleApplication]", 
        RowBox[{"(", 
         RowBox[{"3", ",", "2"}], ")"}]}]}], ",", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"a", "(", "t", ")"}], "\[InvisibleApplication]", 
        RowBox[{"(", 
         RowBox[{"3", ",", "3"}], ")"}]}]}]}], "}"}]}], "}"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{
  3.8861562830887413`*^9, {3.886156359024543*^9, 3.886156376694668*^9}},
 CellLabel->"Out[14]=",ExpressionUUID->"b89048d9-df1e-4985-a08e-15deb036e8b1"],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "(", "0", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"1", ",", "1"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"a", "(", "0", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"1", ",", "2"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"a", "(", "0", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"1", ",", "3"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"a", "(", "0", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"2", ",", "1"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"a", "(", "0", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"2", ",", "2"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"a", "(", "0", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"2", ",", "3"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"a", "(", "0", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"3", ",", "1"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"a", "(", "0", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"3", ",", "2"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"a", "(", "0", ")"}], "\[InvisibleApplication]", 
       RowBox[{"(", 
        RowBox[{"3", ",", "3"}], ")"}]}]}], "}"}], "\[LongEqual]", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "0", ",", "0"}], "}"}]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{
  3.8861562830887413`*^9, {3.886156359024543*^9, 3.886156376699171*^9}},
 CellLabel->"Out[15]=",ExpressionUUID->"840de793-f6c4-49ca-9dcf-cc88f406a489"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["ODE"], "Input",
 CellChangeTimes->{{3.886156716397564*^9, 3.886156716939477*^9}},
 CellLabel->
  "In[148]:=",ExpressionUUID->"c892da2a-aa57-4168-bdfb-458592b4b9ce"],

Cell[BoxData[
 FormBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"A11", "(", "0", ")"}], ",", 
       RowBox[{"A12", "(", "0", ")"}], ",", 
       RowBox[{"A13", "(", "0", ")"}], ",", 
       RowBox[{"A21", "(", "0", ")"}], ",", 
       RowBox[{"A22", "(", "0", ")"}], ",", 
       RowBox[{"A23", "(", "0", ")"}], ",", 
       RowBox[{"A31", "(", "0", ")"}], ",", 
       RowBox[{"A32", "(", "0", ")"}], ",", 
       RowBox[{"A33", "(", "0", ")"}]}], "}"}], "\[LongEqual]", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "0", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["A11", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], ",", 
       RowBox[{
        RowBox[{"0.1`", " ", 
         RowBox[{"A11", "(", "t", ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["A12", "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}]}], ",", 
       RowBox[{
        SuperscriptBox["A13", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], ",", 
       RowBox[{
        SuperscriptBox["A21", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], ",", 
       RowBox[{
        RowBox[{"0.1`", " ", 
         RowBox[{"A21", "(", "t", ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["A22", "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}]}], ",", 
       RowBox[{
        SuperscriptBox["A23", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], ",", 
       RowBox[{
        SuperscriptBox["A31", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}], ",", 
       RowBox[{
        RowBox[{"0.1`", " ", 
         RowBox[{"A31", "(", "t", ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["A32", "\[Prime]",
          MultilineFunction->None], "(", "t", ")"}]}], ",", 
       RowBox[{
        SuperscriptBox["A33", "\[Prime]",
         MultilineFunction->None], "(", "t", ")"}]}], "}"}], "\[LongEqual]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", "\[Tau]"], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"A11", "(", "t", ")"}], "3"]}], "3"], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A12", "(", "t", ")"}], "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A21", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A31", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}], " ", 
             RowBox[{"A11", "(", "t", ")"}]}], "+", 
            RowBox[{
             RowBox[{"A12", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A13", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}]}], ")"}]}]}]}], 
       ",", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", "\[Tau]"], 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"A12", "(", "t", ")"}], "3"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"A11", "(", "t", ")"}], "2"], " ", 
             RowBox[{"A12", "(", "t", ")"}]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A22", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A32", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}], " ", 
             RowBox[{"A12", "(", "t", ")"}]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"A11", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"A13", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}]}], ")"}]}]}]}], 
       ",", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", "\[Tau]"], 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"A13", "(", "t", ")"}], " ", 
             SuperscriptBox[
              RowBox[{"A11", "(", "t", ")"}], "2"]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}], " ", 
             RowBox[{"A11", "(", "t", ")"}]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"A12", "(", "t", ")"}], "2"], " ", 
             RowBox[{"A13", "(", "t", ")"}]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"A12", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A13", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A23", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A33", "(", "t", ")"}], "2"]}]}], ")"}]}]}], 
           ")"}]}]}]}], ",", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", "\[Tau]"], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A22", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A12", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A23", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A21", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A12", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A13", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A21", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A31", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}]}]}], 
           ")"}]}]}]}], ",", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", "\[Tau]"], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A21", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A12", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A23", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A12", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A22", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A12", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A13", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A22", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A32", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}]}]}], 
           ")"}]}]}]}], ",", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", "\[Tau]"], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A21", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A22", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A12", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A23", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A12", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A23", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A33", "(", "t", ")"}], "2"]}]}], ")"}]}]}], 
           ")"}]}]}]}], ",", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", "\[Tau]"], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A32", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A12", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A33", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A31", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A12", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A13", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A21", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A31", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}]}]}], 
           ")"}]}]}]}], ",", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", "\[Tau]"], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A31", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A12", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A33", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A12", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A32", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A12", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A13", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A22", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A32", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}]}]}], 
           ")"}]}]}]}], ",", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", "\[Tau]"], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A31", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A32", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A12", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A33", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A12", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A23", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A33", "(", "t", ")"}], "2"]}]}], ")"}]}]}], 
           ")"}]}]}]}]}], "}"}]}]}], "}"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.886156717667061*^9},
 CellLabel->
  "Out[148]=",ExpressionUUID->"acf477d5-4c2b-4939-af35-1d3205989b40"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DSolve", "[", 
  RowBox[{"ODE", ",", 
   RowBox[{"X", "[", "t", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.886157443532251*^9, 3.8861574459725523`*^9}},
 CellLabel->
  "In[283]:=",ExpressionUUID->"24e64015-ee9c-4906-890f-8aa3724f83e9"],

Cell[BoxData[
 FormBox[
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"A11", "(", "0", ")"}], ",", 
         RowBox[{"A12", "(", "0", ")"}], ",", 
         RowBox[{"A13", "(", "0", ")"}], ",", 
         RowBox[{"A21", "(", "0", ")"}], ",", 
         RowBox[{"A22", "(", "0", ")"}], ",", 
         RowBox[{"A23", "(", "0", ")"}], ",", 
         RowBox[{"A31", "(", "0", ")"}], ",", 
         RowBox[{"A32", "(", "0", ")"}], ",", 
         RowBox[{"A33", "(", "0", ")"}]}], "}"}], "\[LongEqual]", 
       RowBox[{"{", 
        RowBox[{
        "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
         "0", ",", "1"}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          SuperscriptBox["A11", "\[Prime]",
           MultilineFunction->None], "(", "t", ")"}], ",", 
         RowBox[{
          RowBox[{"0.1`", " ", 
           RowBox[{"A11", "(", "t", ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["A12", "\[Prime]",
            MultilineFunction->None], "(", "t", ")"}]}], ",", 
         RowBox[{
          SuperscriptBox["A13", "\[Prime]",
           MultilineFunction->None], "(", "t", ")"}], ",", 
         RowBox[{
          SuperscriptBox["A21", "\[Prime]",
           MultilineFunction->None], "(", "t", ")"}], ",", 
         RowBox[{
          RowBox[{"0.1`", " ", 
           RowBox[{"A21", "(", "t", ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["A22", "\[Prime]",
            MultilineFunction->None], "(", "t", ")"}]}], ",", 
         RowBox[{
          SuperscriptBox["A23", "\[Prime]",
           MultilineFunction->None], "(", "t", ")"}], ",", 
         RowBox[{
          SuperscriptBox["A31", "\[Prime]",
           MultilineFunction->None], "(", "t", ")"}], ",", 
         RowBox[{
          RowBox[{"0.1`", " ", 
           RowBox[{"A31", "(", "t", ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["A32", "\[Prime]",
            MultilineFunction->None], "(", "t", ")"}]}], ",", 
         RowBox[{
          SuperscriptBox["A33", "\[Prime]",
           MultilineFunction->None], "(", "t", ")"}]}], "}"}], "\[LongEqual]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "3000000"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"A11", "(", "t", ")"}], "3"]}], "3"], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A12", "(", "t", ")"}], "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A21", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A31", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}], " ", 
             RowBox[{"A11", "(", "t", ")"}]}], "+", 
            RowBox[{
             RowBox[{"A12", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A13", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"-", "1000000"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"A12", "(", "t", ")"}], "3"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"A11", "(", "t", ")"}], "2"], " ", 
             RowBox[{"A12", "(", "t", ")"}]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A22", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A32", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}], " ", 
             RowBox[{"A12", "(", "t", ")"}]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"A11", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"A13", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"-", "1000000"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"A13", "(", "t", ")"}], " ", 
             SuperscriptBox[
              RowBox[{"A11", "(", "t", ")"}], "2"]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}], " ", 
             RowBox[{"A11", "(", "t", ")"}]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"A12", "(", "t", ")"}], "2"], " ", 
             RowBox[{"A13", "(", "t", ")"}]}], "+", 
            RowBox[{"3", " ", 
             RowBox[{"A12", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A13", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A23", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A33", "(", "t", ")"}], "2"]}]}], ")"}]}]}], ")"}]}],
          ",", 
         RowBox[{
          RowBox[{"-", "3000000"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A22", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A12", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A23", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A21", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A12", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A13", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A21", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A31", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}]}]}], ")"}]}], 
         ",", 
         RowBox[{
          RowBox[{"-", "3000000"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A21", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A12", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A23", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A12", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A22", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A12", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A13", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A22", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A32", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}]}]}], ")"}]}], 
         ",", 
         RowBox[{
          RowBox[{"-", "3000000"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A21", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A22", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A12", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A23", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A12", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A23", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A33", "(", "t", ")"}], "2"]}]}], ")"}]}]}], ")"}]}],
          ",", 
         RowBox[{
          RowBox[{"-", "3000000"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A32", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A12", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A33", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A31", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A12", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A13", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A21", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A31", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}]}]}], ")"}]}], 
         ",", 
         RowBox[{
          RowBox[{"-", "3000000"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A31", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A12", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A22", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A33", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A12", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A32", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A12", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A13", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A22", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A23", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A32", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A33", "(", "t", ")"}], "2"]}], ")"}]}]}], ")"}]}], 
         ",", 
         RowBox[{
          RowBox[{"-", "3000000"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"A13", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A12", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A31", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A21", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
             RowBox[{
              RowBox[{"A11", "(", "t", ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"A22", "(", "t", ")"}], " ", 
                 RowBox[{"A33", "(", "t", ")"}]}], "-", 
                RowBox[{
                 RowBox[{"A23", "(", "t", ")"}], " ", 
                 RowBox[{"A32", "(", "t", ")"}]}]}], ")"}]}]}], ")"}], 
           RowBox[{"5", "/", "3"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"A31", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A11", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A21", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A31", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"A32", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"A12", "(", "t", ")"}], " ", 
                RowBox[{"A13", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A22", "(", "t", ")"}], " ", 
                RowBox[{"A23", "(", "t", ")"}]}], "+", 
               RowBox[{
                RowBox[{"A32", "(", "t", ")"}], " ", 
                RowBox[{"A33", "(", "t", ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             FractionBox["1", "3"], " ", 
             RowBox[{"A33", "(", "t", ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox[
                 RowBox[{"A11", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A12", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A13", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A21", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A22", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A23", "(", "t", ")"}], "2"]}], "-", 
               SuperscriptBox[
                RowBox[{"A31", "(", "t", ")"}], "2"], "-", 
               SuperscriptBox[
                RowBox[{"A32", "(", "t", ")"}], "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox[
                 RowBox[{"A33", "(", "t", ")"}], "2"]}]}], ")"}]}]}], 
           ")"}]}]}], "}"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"A11", "(", "t", ")"}], ",", 
      RowBox[{"A12", "(", "t", ")"}], ",", 
      RowBox[{"A13", "(", "t", ")"}], ",", 
      RowBox[{"A21", "(", "t", ")"}], ",", 
      RowBox[{"A22", "(", "t", ")"}], ",", 
      RowBox[{"A23", "(", "t", ")"}], ",", 
      RowBox[{"A31", "(", "t", ")"}], ",", 
      RowBox[{"A32", "(", "t", ")"}], ",", 
      RowBox[{"A33", "(", "t", ")"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "10"}], "}"}]}], "]"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.886157447183085*^9},
 CellLabel->
  "Out[283]=",ExpressionUUID->"a60e4773-cc52-418b-996d-12e354673471"]
}, Open  ]]
},
WindowSize->{2818, 1546},
WindowMargins->{{Automatic, 2670}, {300, Automatic}},
FrontEndVersion->"12.3 for Linux x86 (64-bit) (July 9, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"be02413f-f730-472b-8d94-f1ae26900d29"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 5537, 161, 1132, "Input",ExpressionUUID->"5c1787ea-a192-4337-8cb7-fabde9e82c3f"],
Cell[6120, 185, 146334, 2815, 358, "Output",ExpressionUUID->"027a1e9a-c09a-4030-a051-9dcef5603278"],
Cell[152457, 3002, 16627, 340, 490, "Output",ExpressionUUID->"4ad1ef1f-8f7e-43a4-9c6f-39a393b2e5bf"],
Cell[169087, 3344, 25370, 504, 495, "Output",ExpressionUUID->"e8e969cd-4c72-49db-a69d-a93e976b14bf"]
}, Open  ]],
Cell[194472, 3851, 152, 3, 60, "Input",ExpressionUUID->"eeae57ef-c552-4fe4-9a12-73f8ab8412a8"],
Cell[CellGroupData[{
Cell[194649, 3858, 376, 8, 60, "Input",ExpressionUUID->"d7fda014-1e7d-4362-bd6a-c4e6198677ed"],
Cell[195028, 3868, 125558, 2430, 358, "Output",ExpressionUUID->"0ffaa2cc-e403-477e-a42f-695818daf380"]
}, Open  ]],
Cell[CellGroupData[{
Cell[320623, 6303, 258, 3, 104, "Input",ExpressionUUID->"2b2ee4df-f4bb-47c6-b8dc-ba0911dba37d"],
Cell[320884, 6308, 3906, 110, 93, "Output",ExpressionUUID->"b89048d9-df1e-4985-a08e-15deb036e8b1"],
Cell[324793, 6420, 1792, 48, 93, "Output",ExpressionUUID->"840de793-f6c4-49ca-9dcf-cc88f406a489"]
}, Open  ]],
Cell[CellGroupData[{
Cell[326622, 6473, 178, 3, 88, "Input",ExpressionUUID->"c892da2a-aa57-4168-bdfb-458592b4b9ce"],
Cell[326803, 6478, 35257, 894, 1397, "Output",ExpressionUUID->"acf477d5-4c2b-4939-af35-1d3205989b40"]
}, Open  ]],
Cell[CellGroupData[{
Cell[362097, 7377, 334, 8, 88, "Input",ExpressionUUID->"24e64015-ee9c-4906-890f-8aa3724f83e9"],
Cell[362434, 7387, 35494, 890, 1292, "Output",ExpressionUUID->"a60e4773-cc52-418b-996d-12e354673471"]
}, Open  ]]
}
]
*)

