(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10628,        276]
NotebookOptionsPosition[     10256,        261]
NotebookOutlinePosition[     10673,        278]
CellTagsIndexPosition[     10630,        275]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Definitions", " ", "of", " ", "the", " ", "Identity", " ", "matrix", " ", 
    "in", " ", "index", " ", "notation", " ", "and", " ", "with", " ", 
    SubscriptBox["Id", "n"], " ", "shortcut"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"\[Delta]", "[", 
      RowBox[{"m_", ",", "n_"}], "]"}], "=", 
     RowBox[{"KroneckerDelta", "[", 
      RowBox[{"m", ",", "n"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Delta]", 
      RowBox[{"m_", ",", "n_"}]], "=", 
     RowBox[{"KroneckerDelta", "[", 
      RowBox[{"m", ",", "n"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     SubscriptBox["Id", "n_"], "=", 
     RowBox[{"IdentityMatrix", "[", "n", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Spacedimemsion", " ", "and", " ", "Space", " ", "coordinates", " ", 
     "vector"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"spacedim", "=", "3"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"X", "=", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dims", "=", 
     RowBox[{
      RowBox[{"(", GridBox[{
         {"1"},
         {"3"}
        }], ")"}], "/.", "unbracket"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "dimensions", " ", "of", " ", "the", " ", "corresponding", " ", 
      "variables", " ", "in", " ", "V", " ", "or", " ", "Q"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"V1", "=", 
     RowBox[{"(", GridBox[{
        {"\[Rho]"},
        {
         SubscriptBox["u", "i"]}
       }], ")"}]}], ";", " ", 
    RowBox[{"Q1", "=", 
     RowBox[{"(", GridBox[{
        {"\[Rho]"},
        {
         RowBox[{"\[Rho]", " ", 
          SubscriptBox["u", "i"]}]}
       }], ")"}]}], ";", 
    RowBox[{"F1", "=", 
     RowBox[{"(", GridBox[{
        {
         RowBox[{"\[Rho]", " ", 
          SubscriptBox["u", "k"]}]},
        {
         RowBox[{
          RowBox[{"\[Rho]", " ", 
           SubscriptBox["u", "i"], 
           SubscriptBox["u", "k"]}], "+", 
          RowBox[{"P", " ", 
           SubscriptBox["\[Delta]", 
            RowBox[{"i", ",", "k"}]]}]}]}
       }], ")"}]}], ";", 
    RowBox[{"B1", "=", 
     RowBox[{"(", GridBox[{
        {"0"},
        {"0"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Vbasis", " ", "=", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       SubscriptBox["u", "1"], ",", 
       SubscriptBox["u", "2"], ",", 
       SubscriptBox["u", "3"]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"===", "===", "===", "===", 
     RowBox[{"==", " ", 
      RowBox[{"DO", " ", "NOT", " ", "TOUCH"}]}], "===", "===", "===", "===", 
     "===", "===", "===", "===", "===", "===", "===", "==="}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
      RowBox[{"==", "=="}], "==="}], "=", 
     RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Number", " ", "of", " ", "Conservation", " ", "laws"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Neq", "=", 
     RowBox[{"Length", "[", "dims", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Total", " ", "Number", " ", "of", " ", "scalar", " ", "equations"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Ncl", "=", 
     RowBox[{"Total", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"listProduct", ",", "dims"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"ExFortFlux", "[", 
    RowBox[{"FortranFile", ",", "EQNnumber", ",", "ModelDescription"}], "]"}],
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Store", " ", "Here", " ", "the", " ", "PDE", " ", "in", " ", "its", " ", 
     "unevaluated", " ", "Form", " ", "for", " ", "a", " ", "more", " ", 
     "compressed", " ", "output", " ", "of", " ", "the", " ", "system"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Vprint", "[", "ii", "]"}], "=", 
       RowBox[{
        RowBox[{"HoldForm", "[", 
         RowBox[{"Evaluate", "[", 
          RowBox[{
           RowBox[{"V1", "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}],
         "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
      RowBox[{
       RowBox[{"Qprint", "[", "ii", "]"}], "=", 
       RowBox[{
        RowBox[{"HoldForm", "[", 
         RowBox[{"Evaluate", "[", 
          RowBox[{
           RowBox[{"Q1", "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}],
         "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
      RowBox[{
       RowBox[{"Fprint", "[", "ii", "]"}], "=", 
       RowBox[{
        RowBox[{"HoldForm", "[", 
         RowBox[{"Evaluate", "[", 
          RowBox[{
           RowBox[{"F1", "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}],
         "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
      RowBox[{
       RowBox[{"Bprint", "[", "ii", "]"}], "=", 
       RowBox[{
        RowBox[{"HoldForm", "[", 
         RowBox[{"Evaluate", "[", 
          RowBox[{
           RowBox[{"B1", "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}],
         "/.", "unbracket"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "1", ",", 
       RowBox[{
        RowBox[{"Dimensions", "[", "V1", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
      RowBox[{"==", 
       RowBox[{"==", "==="}]}]}], "=", 
     RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
      RowBox[{"==", "=="}], "==="}], "=", 
     RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Define", " ", "Here", " ", "auxiliary", " ", "Parameters"}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"P", " ", "=", " ", 
     RowBox[{"p", "[", "\[Rho]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[ScriptCapitalE]", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], "\[Rho]", " ", 
         SubscriptBox["u", "l"], 
         SubscriptBox["u", "l"]}], "+", 
        RowBox[{
         FractionBox[
          SuperscriptBox["\[Rho]", "\[Gamma]"], 
          RowBox[{"\[Gamma]", "-", "1"}]], 
         RowBox[{"Exp", "[", 
          FractionBox["S", "cv"], "]"}]}]}], "/.", 
       RowBox[{"Einstein", "[", "3", "]"}]}], "//", "Esthetic"}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.883309450416586*^9, 3.8833094542303257`*^9}, {
   3.883315862139411*^9, 3.883315863389764*^9}, {3.883386161206704*^9, 
   3.883386162008535*^9}, {3.8833871781798887`*^9, 3.883387178685625*^9}, {
   3.883387394815304*^9, 3.8833873966458797`*^9}, {3.883387480860487*^9, 
   3.883387482969985*^9}, {3.88345425622582*^9, 3.8834542641795387`*^9}, {
   3.883455131991022*^9, 3.883455163561852*^9}, {3.883455201151412*^9, 
   3.883455221429077*^9}, 3.883455912273836*^9, {3.883462469879867*^9, 
   3.883462500240234*^9}, {3.883462541649537*^9, 3.883462587477997*^9}, {
   3.883462672636397*^9, 3.883462741298012*^9}, {3.883462799275103*^9, 
   3.88346282573549*^9}, {3.8834628739797907`*^9, 3.8834628981286497`*^9}, {
   3.8834629938203773`*^9, 3.883462996686228*^9}, {3.883463050194509*^9, 
   3.8834630661753893`*^9}, {3.883463099888364*^9, 3.883463169936715*^9}, {
   3.883476177662264*^9, 3.88347619571194*^9}, {3.883476455583027*^9, 
   3.8834764559476633`*^9}, 3.88347649016092*^9, 3.883537843001994*^9, 
   3.883537897636313*^9, {3.8835512454343452`*^9, 3.88355125775187*^9}, {
   3.883583993255147*^9, 3.8835839939247293`*^9}, 3.883584061304842*^9, {
   3.883584139674806*^9, 3.883584139962237*^9}, {3.883584577193437*^9, 
   3.883584590321558*^9}, {3.8835846435474653`*^9, 3.883584645142524*^9}, {
   3.8835847352325287`*^9, 3.8835847517224092`*^9}, 3.8835848332086983`*^9, 
   3.883585251328164*^9, {3.883585400974671*^9, 3.883585519862219*^9}, {
   3.883585781932383*^9, 3.883585884990089*^9}, {3.883585917517017*^9, 
   3.883585966411292*^9}, {3.88358599812764*^9, 3.8835860065873327`*^9}, {
   3.8835860691646843`*^9, 3.883586094008565*^9}, {3.8835861470603724`*^9, 
   3.883586176494595*^9}, {3.883586239269854*^9, 3.883586243902503*^9}, {
   3.883586282477906*^9, 3.8835863425450172`*^9}, {3.883586798606513*^9, 
   3.883586813546867*^9}, {3.883741501712129*^9, 3.8837415430073643`*^9}, 
   3.883741656721099*^9, {3.884074702088943*^9, 3.884074739017906*^9}, 
   3.88407523765261*^9, {3.884429616184928*^9, 3.884429622415312*^9}, {
   3.884429660824535*^9, 
   3.884429736040628*^9}},ExpressionUUID->"072bc278-3806-48b6-acfb-\
1b4644fc6cc6"]
},
WindowSize->{1879, 2086},
WindowMargins->{{-1879, Automatic}, {-240, Automatic}},
Magnification:>1.75,
FrontEndVersion->"12.3 for Linux x86 (64-bit) (July 9, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"1ddcd40d-6af7-46e8-9a18-5bbb543660a2"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 9694, 239, 1516, "Input",ExpressionUUID->"072bc278-3806-48b6-acfb-1b4644fc6cc6"]
}
]
*)

