(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     33894,        893]
NotebookOptionsPosition[     32430,        865]
NotebookOutlinePosition[     32843,        882]
CellTagsIndexPosition[     32800,        879]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"Parameters", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AuxVars", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"DefineAux", ",", "HoldAll"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"DefinePar", ",", "HoldAll"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineAux", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"AppendTo", "[", 
     RowBox[{"AuxVars", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"HoldForm", "[", "a", "]"}], ",", 
        RowBox[{"HoldForm", "[", "b", "]"}]}], "}"}]}], "]"}], ";", " ", 
    RowBox[{"a", "=", "b"}], " ", ";"}], " ", ")"}]}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"DefinePar", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"AppendTo", "[", 
      RowBox[{"Parameters", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"HoldForm", "[", "a", "]"}], ",", 
         RowBox[{"HoldForm", "[", "b", "]"}]}], "}"}]}], "]"}], ";", " ", 
     RowBox[{"a", "=", "b"}], " ", ";"}], " ", ")"}]}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Definitions", " ", "of", " ", "the", " ", "Identity", " ", "matrix", " ", 
    "in", " ", "index", " ", "notation", " ", "and", " ", "with", " ", 
    SubscriptBox["Id", "n"], " ", "shortcut"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Delta]", "[", 
    RowBox[{"m_", ",", "n_"}], "]"}], "=", 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Delta]", 
    RowBox[{"m_", ",", "n_"}]], "=", 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Id", "n_"], "=", 
   RowBox[{"IdentityMatrix", "[", "n", "]"}]}], ";"}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"\[ScriptCapitalE]", " ", "=", " ", "0"}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", " ", 
      RowBox[{"USER", " ", "INPUT"}]}], " ", "===", "===", "===", "===", "===",
      "===", "===", "===", "===", "===", "===", "===", "===", "===", "==="}], 
    "="}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
      "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", 
      RowBox[{"==", 
       RowBox[{"===", 
        RowBox[{"==", 
         RowBox[{
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
           "==="}]}]}]}]}]}], "="}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Spacedimemsion", " ", "and", " ", "Space", " ", "coordinates", " ", 
    "vector"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"spacedim", "=", "d"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], ";"}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"dims", "=", 
    RowBox[{
     RowBox[{"(", GridBox[{
        {"1"},
        {"d"},
        {"3"},
        {"3"},
        {"3"}
       }], ")"}], "/.", "unbracket"}]}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{
   "dimensions", " ", "of", " ", "the", " ", "corresponding", " ", 
    "variables", " ", "in", " ", "V", " ", "or", " ", "Q"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V1", "=", 
   RowBox[{"(", GridBox[{
      {"\[Rho]"},
      {
       SubscriptBox["u", "i"]},
      {
       SubscriptBox["A1", "i"]},
      {
       SubscriptBox["A2", "i"]},
      {
       SubscriptBox["A3", "i"]}
     }], ")"}]}], ";", " ", 
  RowBox[{"Q1", "=", 
   RowBox[{"(", GridBox[{
      {"\[Rho]"},
      {
       RowBox[{"\[Rho]", " ", 
        SubscriptBox["u", "i"]}]},
      {
       SubscriptBox["A1", "i"]},
      {
       SubscriptBox["A2", "i"]},
      {
       SubscriptBox["A3", "i"]}
     }], ")"}]}], ";", 
  RowBox[{"F1", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"\[Rho]", " ", 
        SubscriptBox["u", "k"]}]},
      {
       RowBox[{
        RowBox[{"\[Rho]", " ", 
         SubscriptBox["u", "i"], 
         SubscriptBox["u", "k"]}], "+", 
        RowBox[{"P", " ", 
         SubscriptBox["\[Delta]", 
          RowBox[{"i", ",", "k"}]]}], "+", 
        SubscriptBox["\[Sigma]", 
         RowBox[{"i", ",", "k"}]]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["A1", "m"], 
         SubscriptBox["u", "m"], 
         SubscriptBox["\[Delta]", 
          RowBox[{"j", ",", "k"}]]}], "/.", 
        RowBox[{"Einstein", "[", "d", "]"}]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["A2", "m"], 
         SubscriptBox["u", "m"], 
         SubscriptBox["\[Delta]", 
          RowBox[{"j", ",", "k"}]]}], "/.", 
        RowBox[{"Einstein", "[", "d", "]"}]}]},
      {
       RowBox[{
        RowBox[{
         SubscriptBox["A3", "m"], 
         SubscriptBox["u", "m"], 
         SubscriptBox["\[Delta]", 
          RowBox[{"j", ",", "k"}]]}], "/.", 
        RowBox[{"Einstein", "[", "d", "]"}]}]}
     }], ")"}]}], ";", 
  RowBox[{"B1", "=", 
   RowBox[{"(", GridBox[{
      {"0"},
      {"0"},
      {
       RowBox[{
        UnderoverscriptBox["\[Sum]", 
         RowBox[{"m", "=", "1"}], "3"], 
        RowBox[{
         SubscriptBox["u", "m"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"pd", "[", 
            RowBox[{
             SubscriptBox["A1", "i"], ",", 
             SubscriptBox["x", "m"]}], "]"}], "-", 
           RowBox[{"pd", "[", 
            RowBox[{
             SubscriptBox["A1", "m"], ",", 
             SubscriptBox["x", "j"]}], "]"}]}], ")"}]}]}]},
      {
       RowBox[{
        UnderoverscriptBox["\[Sum]", 
         RowBox[{"m", "=", "1"}], "3"], 
        RowBox[{
         SubscriptBox["u", "m"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"pd", "[", 
            RowBox[{
             SubscriptBox["A2", "i"], ",", 
             SubscriptBox["x", "m"]}], "]"}], "-", 
           RowBox[{"pd", "[", 
            RowBox[{
             SubscriptBox["A2", "m"], ",", 
             SubscriptBox["x", "j"]}], "]"}]}], ")"}]}]}]},
      {
       RowBox[{
        UnderoverscriptBox["\[Sum]", 
         RowBox[{"m", "=", "1"}], "3"], 
        RowBox[{
         SubscriptBox["u", "m"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"pd", "[", 
            RowBox[{
             SubscriptBox["A3", "i"], ",", 
             SubscriptBox["x", "m"]}], "]"}], "-", 
           RowBox[{"pd", "[", 
            RowBox[{
             SubscriptBox["A3", "m"], ",", 
             SubscriptBox["x", "j"]}], "]"}]}], ")"}]}]}]}
     }], ")"}]}], ";", 
  RowBox[{"S1", "=", 
   RowBox[{"(", GridBox[{
      {"0"},
      {"0"},
      {"0"}
     }], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Vbasis", " ", "=", 
    RowBox[{"{", 
     RowBox[{"\[Rho]", ",", 
      SubscriptBox["u", "1"], ",", 
      SubscriptBox["u", "2"], ",", 
      SubscriptBox["u", "3"], ",", 
      SubscriptBox["A", 
       RowBox[{"1", ",", "1"}]], ",", 
      SubscriptBox["A", 
       RowBox[{"1", ",", "2"}]], ",", 
      SubscriptBox["A", 
       RowBox[{"1", ",", "3"}]], ",", 
      SubscriptBox["A", 
       RowBox[{"2", ",", "1"}]], ",", 
      SubscriptBox["A", 
       RowBox[{"2", ",", "2"}]], ",", 
      SubscriptBox["A", 
       RowBox[{"2", ",", "3"}]], ",", 
      SubscriptBox["A", 
       RowBox[{"3", ",", "1"}]], ",", 
      SubscriptBox["A", 
       RowBox[{"3", ",", "2"}]], ",", 
      SubscriptBox["A", 
       RowBox[{"3", ",", "3"}]]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"===", "===", "===", "===", 
    RowBox[{"==", " ", 
     RowBox[{"DO", " ", "NOT", " ", "TOUCH"}]}], "===", "===", "===", "===", "===",
     "===", "===", "===", "===", "===", "===", "==="}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", "=="}], "==="}], "=", 
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Number", " ", "of", " ", "Conservation", " ", "laws"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Neq", "=", 
    RowBox[{"Length", "[", "dims", "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Total", " ", "Number", " ", "of", " ", "scalar", " ", "equations"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ncl", "=", 
    RowBox[{"Total", "[", 
     RowBox[{"Map", "[", 
      RowBox[{"listProduct", ",", "dims"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ExFortFlux", "[", 
   RowBox[{"FortranFile", ",", "EQNnumber", ",", "ModelDescription"}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Store", " ", "Here", " ", "the", " ", "PDE", " ", "in", " ", "its", " ", 
    "unevaluated", " ", "Form", " ", "for", " ", "a", " ", "more", " ", 
    "compressed", " ", "output", " ", "of", " ", "the", " ", "system"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Vprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"V1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"Qprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"Q1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"Fprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"F1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"Bprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"B1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"ii", ",", "1", ",", 
      RowBox[{
       RowBox[{"Dimensions", "[", "V1", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", 
      RowBox[{"==", "==="}]}]}], "=", 
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", "=="}], "==="}], "=", 
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Define", " ", "Here", " ", "auxiliary", " ", "Parameters"}], " ", 
   "*)"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"P", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "\[Rho]", "]"}], "-", 
       RowBox[{
        FractionBox["\[Kappa]", "\[Rho]"], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SubscriptBox["A1", "m"], 
           SubscriptBox["A1", "m"]}], "+", 
          RowBox[{
           SubscriptBox["A2", "m"], 
           SubscriptBox["A2", "m"]}], "+", 
          RowBox[{
           SubscriptBox["A2", "m"], 
           SubscriptBox["A2", "m"]}]}], ")"}]}]}], "/.", 
      RowBox[{"Einstein", "[", "d", "]"}]}], ")"}], " ", 
    SubscriptBox["\[Delta]", 
     RowBox[{"i", ",", "k"}]]}], " ", "+", "  ", 
   RowBox[{
    FractionBox["\[Kappa]", "\[Rho]"], " ", 
    SubscriptBox["q", "i"], 
    SubscriptBox["q", "k"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "\[Rho]_", "]"}], ":=", 
   FractionBox[
    SuperscriptBox["\[Kappa]", "2"], "\[Rho]"]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"DefineAux", "[", 
  RowBox[{"AA", ",", 
   RowBox[{"Array", "[", 
    RowBox[{"A", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefineAux", "[", 
  RowBox[{"JJ", ",", 
   RowBox[{"Array", "[", 
    RowBox[{"J", ",", "3"}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefineAux", "[", 
  RowBox[{"G", ",", 
   RowBox[{
    SuperscriptBox["AA", "\[Transpose]"], ".", "AA"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefineAux", "[", " ", 
  RowBox[{"devG", ",", 
   RowBox[{"G", "-", 
    RowBox[{
     FractionBox["1", "3"], 
     RowBox[{"Tr", "[", "G", "]"}], 
     SubscriptBox["Id", "3"]}]}]}], " ", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefineAux", "[", 
  RowBox[{"\[Sigma]", " ", ",", 
   RowBox[{"\[Rho]", " ", 
    SuperscriptBox["cs", "2"], " ", 
    RowBox[{"G", ".", "devG"}]}]}], " ", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefineAux", "[", 
  RowBox[{"\[CapitalOmega]", " ", ",", 
   RowBox[{
    RowBox[{"a", "[", "\[Rho]", "]"}], 
    RowBox[{"JJ", "\[TensorProduct]", "JJ"}]}]}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefineAux", "[", 
  RowBox[{"\[Nu]t", ",", 
   RowBox[{
    FractionBox["1", "2"], 
    FractionBox[
     SuperscriptBox["q", "2"], "\[Omega]"]}]}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DefineAux", "[", 
  RowBox[{"\[Sigma]t", ",", 
   RowBox[{
    FractionBox["\[Nu]t", "\[Nu]m"], "\[Sigma]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineAux", "[", 
   RowBox[{"k", ",", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["q", "2"]}]}], "]"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"DefineAux", "[", 
    RowBox[{"\[Nu]m", ",", 
     RowBox[{
      FractionBox["1", "6"], 
      SuperscriptBox["cs", "2"], "\[Tau]1"}]}], "]"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Psi]", "[", "i_", "]"}], ":=", " ", 
   RowBox[{
    SuperscriptBox["cm", "2"], " ", 
    RowBox[{"M", "[", "i", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Phi]", "[", "i_", "]"}], ":=", 
   RowBox[{
    SuperscriptBox["cd", "2"], 
    RowBox[{"H", "[", "i", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Beta]", "[", "i_", "]"}], ":=", 
   RowBox[{
    RowBox[{"a", "[", "\[Rho]", "]"}], " ", 
    RowBox[{"J", "[", "i", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]", "[", 
   RowBox[{"i_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"D", "[", 
   RowBox[{"\[ScriptCapitalE]", ",", 
    RowBox[{"A", "[", 
     RowBox[{"i", ",", "k"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Xi]", "=", " ", "\[Omega]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Entropy", " ", "production", " ", "terms"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pi", "[", "1", "]"}], "=", " ", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Alpha]", "[", 
       RowBox[{"i", ",", "k"}], "]"}], 
      RowBox[{"\[Alpha]", "[", 
       RowBox[{"i", ",", "k"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "3"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pi", "[", "2", "]"}], "=", " ", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Beta]", "[", "i", "]"}], 
      RowBox[{"\[Beta]", "[", "i", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "d"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pi", "[", "3", "]"}], "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]", "[", "i", "]"}], 
      RowBox[{"\[Phi]", "[", "i", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "d"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pi", "[", "4", "]"}], "=", 
   RowBox[{
    FractionBox[
     RowBox[{"\[Rho]", " ", "\[Omega]"}], 
     RowBox[{"T", "[", 
      RowBox[{"\[Rho]", ",", "S"}], "]"}]], "C\[Mu]", " ", 
    SuperscriptBox["q", "2"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pi", "[", "5", "]"}], "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Psi]", "[", "i", "]"}], 
      RowBox[{"\[Psi]", "[", "i", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "d"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pi", "[", "6", "]"}], "=", 
   RowBox[{"\[Rho]", " ", "C2\[Omega]", " ", "\[Tau]d", " ", 
    SuperscriptBox["cw", "2"], 
    SuperscriptBox["\[Omega]", "2"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPi]", "=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"pi", "[", "k", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]}], "Input",
 CellChangeTimes->{{3.883309450416586*^9, 3.8833094542303257`*^9}, {
   3.883315862139411*^9, 3.883315863389764*^9}, {3.883386161206704*^9, 
   3.883386162008535*^9}, {3.8833871781798887`*^9, 3.883387178685625*^9}, {
   3.883387394815304*^9, 3.8833873966458797`*^9}, {3.883387480860487*^9, 
   3.883387482969985*^9}, {3.88345425622582*^9, 3.8834542641795387`*^9}, {
   3.883455131991022*^9, 3.883455163561852*^9}, {3.883455201151412*^9, 
   3.883455221429077*^9}, 3.883455912273836*^9, {3.883462469879867*^9, 
   3.883462500240234*^9}, {3.883462541649537*^9, 3.883462587477997*^9}, {
   3.883462672636397*^9, 3.883462741298012*^9}, {3.883462799275103*^9, 
   3.88346282573549*^9}, {3.8834628739797907`*^9, 3.8834628981286497`*^9}, {
   3.8834629938203773`*^9, 3.883462996686228*^9}, {3.883463050194509*^9, 
   3.8834630661753893`*^9}, {3.883463099888364*^9, 3.883463169936715*^9}, {
   3.883476177662264*^9, 3.88347619571194*^9}, {3.883476455583027*^9, 
   3.8834764559476633`*^9}, 3.88347649016092*^9, 3.883537843001994*^9, 
   3.883537897636313*^9, {3.8835512454343452`*^9, 3.88355125775187*^9}, {
   3.883583993255147*^9, 3.8835839939247293`*^9}, 3.883584061304842*^9, {
   3.883584139674806*^9, 3.883584139962237*^9}, {3.883584577193437*^9, 
   3.883584590321558*^9}, {3.8835846435474653`*^9, 3.883584645142524*^9}, {
   3.8835847352325287`*^9, 3.8835847517224092`*^9}, 3.8835848332086983`*^9, 
   3.883585251328164*^9, {3.883585400974671*^9, 3.883585519862219*^9}, {
   3.883585781932383*^9, 3.883585884990089*^9}, {3.883585917517017*^9, 
   3.883585966411292*^9}, {3.88358599812764*^9, 3.8835860065873327`*^9}, {
   3.8835860691646843`*^9, 3.883586094008565*^9}, {3.8835861470603724`*^9, 
   3.883586176494595*^9}, {3.883586239269854*^9, 3.883586243902503*^9}, {
   3.883586282477906*^9, 3.8835863425450172`*^9}, {3.883586798606513*^9, 
   3.883586813546867*^9}, {3.883741501712129*^9, 3.8837415430073643`*^9}, 
   3.883741656721099*^9, 3.884075226224948*^9, {3.884075942802906*^9, 
   3.884075979281261*^9}, {3.884076054193276*^9, 3.8840760566787977`*^9}, {
   3.88408071152608*^9, 3.884080721236438*^9}, {3.8840815812230053`*^9, 
   3.884081591942626*^9}, 3.884081629270492*^9, {3.884081693604508*^9, 
   3.884081727497581*^9}, {3.884081964241016*^9, 3.884081969918563*^9}, {
   3.884082895222664*^9, 3.884082950941317*^9}, {3.884085524373637*^9, 
   3.884085531269445*^9}, {3.884085724055375*^9, 3.884085756994401*^9}, {
   3.8840875699662247`*^9, 3.884087614299426*^9}, {3.884087644357314*^9, 
   3.8840876805205097`*^9}, {3.884087717598378*^9, 3.884087776000772*^9}, {
   3.884087871807807*^9, 3.884087873804613*^9}, {3.884088001571351*^9, 
   3.884088088454328*^9}, {3.884088232485248*^9, 3.884088241005189*^9}, {
   3.8840891811319113`*^9, 3.884089224868618*^9}, {3.884089286892557*^9, 
   3.884089289308399*^9}, {3.884089334511002*^9, 3.88408933713188*^9}, {
   3.884160916483892*^9, 3.884160917459209*^9}, {3.884348749833353*^9, 
   3.884348753911066*^9}, {3.884422952077368*^9, 3.8844229531288433`*^9}, {
   3.884423840414816*^9, 3.884423939506588*^9}, {3.884423970816545*^9, 
   3.88442397198208*^9}, {3.884428841643631*^9, 3.884428904407659*^9}, {
   3.884429824696764*^9, 3.8844298455987263`*^9}, {3.8844300013308563`*^9, 
   3.884430004951578*^9}, {3.884430574821549*^9, 3.884430580013459*^9}, {
   3.8844308959359493`*^9, 3.884430896855619*^9}, {3.884430959853492*^9, 
   3.884430965259444*^9}, {3.884431070881558*^9, 3.8844310710495358`*^9}, {
   3.8844311077113934`*^9, 3.884431119160844*^9}, {3.88443115181837*^9, 
   3.8844311976174803`*^9}, {3.88443155053904*^9, 3.884431553736405*^9}, {
   3.884833554327814*^9, 3.8848335709686937`*^9}, 3.884835075499333*^9, {
   3.8848352724035683`*^9, 3.8848353103149443`*^9}, {3.884838793875622*^9, 
   3.884838833859228*^9}, {3.884838880976522*^9, 3.884838884676283*^9}, {
   3.884840791694747*^9, 3.884840794571928*^9}, {3.884840880352096*^9, 
   3.884841077964178*^9}, {3.884841346306061*^9, 3.88484134656704*^9}, {
   3.884841573742683*^9, 3.884841574022451*^9}, {3.884841727728051*^9, 
   3.884841729893166*^9}, {3.884843446518113*^9, 3.884843448636511*^9}, {
   3.88492106628533*^9, 3.884921069238624*^9}, {3.884926146239305*^9, 
   3.8849261634953127`*^9}, {3.885619745905614*^9, 3.8856197461531563`*^9}, {
   3.88561988443559*^9, 3.885619884585958*^9}, {3.885636422853058*^9, 
   3.88563642989979*^9}, {3.886153055412478*^9, 3.886153071112694*^9}, 
   3.8862491979175797`*^9, {3.8865201588635674`*^9, 3.886520161648223*^9}, {
   3.886520304024021*^9, 3.886520330396408*^9}, {3.886523163826517*^9, 
   3.886523169137233*^9}, 3.886526114713008*^9, {3.886599812151998*^9, 
   3.886599843710661*^9}, {3.886600164461705*^9, 3.886600166653948*^9}, {
   3.886600230796626*^9, 3.886600259322228*^9}, {3.886600307631618*^9, 
   3.8866003080613213`*^9}, 3.886765527813697*^9, {3.886765560077819*^9, 
   3.886765563056785*^9}, {3.9031718894193583`*^9, 3.903171990291149*^9}, {
   3.903172077888225*^9, 3.9031720780063467`*^9}, {3.9031721121866703`*^9, 
   3.903172112565133*^9}, {3.903172296137204*^9, 3.9031723181331177`*^9}, {
   3.903172375357881*^9, 3.903172377605502*^9}, {3.9031745435160437`*^9, 
   3.9031745441768923`*^9}, {3.903175079547511*^9, 3.9031751004404573`*^9}, {
   3.9031751381739492`*^9, 3.903175139625452*^9}, {3.9031751744367313`*^9, 
   3.9031751766416073`*^9}, {3.906042691349526*^9, 3.906042715501399*^9}, {
   3.906042755765568*^9, 3.9060427561650667`*^9}, 3.90604279897149*^9, {
   3.906042871266066*^9, 3.906042871602268*^9}, {3.9060429129293203`*^9, 
   3.906042939425226*^9}, {3.906042982320031*^9, 3.906042984928071*^9}, {
   3.9060436251291447`*^9, 3.906043646700177*^9}, {3.906043765403675*^9, 
   3.9060437658746567`*^9}, {3.9060453227604*^9, 3.906045323199164*^9}, {
   3.9060461614033413`*^9, 3.906046161859288*^9}, {3.9060883559170427`*^9, 
   3.906088558283448*^9}, {3.9071332738571978`*^9, 3.9071332862839518`*^9}, {
   3.907133481889016*^9, 3.907133614756782*^9}, {3.9071336861260567`*^9, 
   3.907133688210026*^9}, 3.907133747095346*^9, {3.907133976536414*^9, 
   3.907133977868943*^9}, {3.9071340367297363`*^9, 3.9071340371344347`*^9}, {
   3.907134106476326*^9, 3.90713411434096*^9}, {3.9071341724410686`*^9, 
   3.907134181215252*^9}, {3.907134216182311*^9, 3.9071342399172697`*^9}, {
   3.907134311980402*^9, 3.907134312496928*^9}, {3.9097344747560987`*^9, 
   3.909734484053534*^9}, {3.9097387493145323`*^9, 3.909738770303617*^9}, {
   3.909738828964851*^9, 3.909738831562716*^9}, 3.909739554553328*^9, {
   3.909742600957066*^9, 3.909742604815346*^9}, {3.909746379225174*^9, 
   3.9097463882978563`*^9}, {3.915125766106357*^9, 3.9151258068162823`*^9}, {
   3.915125899189559*^9, 3.9151259006458883`*^9}, {3.915125958814712*^9, 
   3.91512600039616*^9}, {3.915126065243472*^9, 3.915126066162901*^9}, {
   3.915126676088879*^9, 3.915126788746358*^9}, {3.915126840549693*^9, 
   3.915126844644372*^9}, {3.915128332541054*^9, 
   3.9151283662056427`*^9}},ExpressionUUID->"072bc278-3806-48b6-acfb-\
1b4644fc6cc6"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
   "ReplaceAll", "reps", 
    "\"\\!\\(\\*FormBox[RowBox[{\\\"{\\\", \\\"unbracket\\\", \\\"}\\\"}], \
TraditionalForm]\\) is neither a list of replacement rules nor a valid \
dispatch table, and so cannot be used for replacing.\"", 2, 14, 1, 
    19393859860379393901, "Local"},
   "MessageTemplate"], TraditionalForm]], "Message", "MSG",
 CellChangeTimes->{3.9151266767026873`*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"f1968c9f-1fd0-4e5d-b7ed-c48ad986ab37"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
   "ReplaceAll", "reps", 
    "\"\\!\\(\\*FormBox[RowBox[{\\\"{\\\", RowBox[{\\\"Einstein\\\", \
\\\"(\\\", \\\"3\\\", \\\")\\\"}], \\\"}\\\"}], TraditionalForm]\\) is \
neither a list of replacement rules nor a valid dispatch table, and so cannot \
be used for replacing.\"", 2, 14, 2, 19393859860379393901, "Local"},
   "MessageTemplate"], TraditionalForm]], "Message", "MSG",
 CellChangeTimes->{3.915126676773759*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"9b02d51f-62ba-4557-be15-68b06d3bfcac"],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.915126676779845*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"2a8ec371-913b-483b-aeff-818f4e563bb9"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
   "ReplaceAll", "reps", 
    "\"\\!\\(\\*FormBox[RowBox[{\\\"{\\\", RowBox[{\\\"listProduct\\\", \\\"(\
\\\", \\\"unbracket\\\", \\\")\\\"}], \\\"}\\\"}], TraditionalForm]\\) is \
neither a list of replacement rules nor a valid dispatch table, and so cannot \
be used for replacing.\"", 2, 17, 3, 19393859860379393901, "Local"},
   "MessageTemplate"], TraditionalForm]], "Message", "MSG",
 CellChangeTimes->{3.91512667679702*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"167559c9-984a-492f-80be-dbfe012fdea1"],

Cell[BoxData[
 FormBox[
  RowBox[{"ExFortFlux", "(", 
   RowBox[{"FortranFile", ",", "EQNnumber", ",", "ModelDescription"}], ")"}], 
  TraditionalForm]], "Output",
 CellChangeTimes->{3.915126676803136*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"09f7c051-9bde-4773-94d2-e57ce728d56f"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
   "ReplaceAll", "reps", 
    "\"\\!\\(\\*FormBox[RowBox[{\\\"{\\\", \\\"unbracket\\\", \\\"}\\\"}], \
TraditionalForm]\\) is neither a list of replacement rules nor a valid \
dispatch table, and so cannot be used for replacing.\"", 2, 19, 4, 
    19393859860379393901, "Local"},
   "MessageTemplate"], TraditionalForm]], "Message", "MSG",
 CellChangeTimes->{3.9151266768052673`*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"8cd36373-c805-4146-a9b8-1f7866799942"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
   "ReplaceAll", "reps", 
    "\"\\!\\(\\*FormBox[RowBox[{\\\"{\\\", \\\"unbracket\\\", \\\"}\\\"}], \
TraditionalForm]\\) is neither a list of replacement rules nor a valid \
dispatch table, and so cannot be used for replacing.\"", 2, 19, 5, 
    19393859860379393901, "Local"},
   "MessageTemplate"], TraditionalForm]], "Message", "MSG",
 CellChangeTimes->{3.9151266768094673`*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"c22ebd9c-865c-43b9-8cfd-6cc975e9ea8a"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
   "ReplaceAll", "reps", 
    "\"\\!\\(\\*FormBox[RowBox[{\\\"{\\\", RowBox[{\\\"Einstein\\\", \
\\\"(\\\", \\\"3\\\", \\\")\\\"}], \\\"}\\\"}], TraditionalForm]\\) is \
neither a list of replacement rules nor a valid dispatch table, and so cannot \
be used for replacing.\"", 2, 19, 6, 19393859860379393901, "Local"},
   "MessageTemplate"], TraditionalForm]], "Message", "MSG",
 CellChangeTimes->{3.915126676813017*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"4ece41c7-e223-4971-8e63-bdc01958b671"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
   "General", "stop", 
    "\"Further output of \
\\!\\(\\*FormBox[StyleBox[RowBox[{\\\"ReplaceAll\\\", \\\"::\\\", \
\\\"reps\\\"}], \\\"MessageName\\\"], TraditionalForm]\\) will be suppressed \
during this calculation.\"", 2, 19, 7, 19393859860379393901, "Local"},
   "MessageTemplate"], TraditionalForm]], "Message", "MSG",
 CellChangeTimes->{3.915126676816629*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"5445e808-a5f1-4c10-b274-799b855cc7ed"],

Cell[BoxData[
 FormBox[
  RowBox[{"p", "(", "\[Rho]", ")"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.915126676820909*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"437a2672-5818-45ad-98c7-c49249463c0b"],

Cell[BoxData[
 FormBox[
  RowBox[{
   FractionBox[
    RowBox[{"C\[Mu]", " ", 
     SuperscriptBox["q", "2"], " ", "\[Rho]", " ", "\[Omega]"}], 
    RowBox[{"T", "(", 
     RowBox[{"\[Rho]", ",", "S"}], ")"}]], "+", 
   RowBox[{"C2\[Omega]", " ", 
    SuperscriptBox["cw", "2"], " ", "\[Rho]", " ", "\[Tau]d", " ", 
    SuperscriptBox["\[Omega]", "2"]}], "+", 
   RowBox[{
    SuperscriptBox["cd", "4"], " ", 
    SuperscriptBox[
     RowBox[{"H", "(", "1", ")"}], "2"]}], "+", 
   RowBox[{
    SuperscriptBox["cd", "4"], " ", 
    SuperscriptBox[
     RowBox[{"H", "(", "2", ")"}], "2"]}], "+", 
   RowBox[{
    SuperscriptBox["cd", "4"], " ", 
    SuperscriptBox[
     RowBox[{"H", "(", "3", ")"}], "2"]}], "+", 
   RowBox[{
    SuperscriptBox["cm", "4"], " ", 
    SuperscriptBox[
     RowBox[{"M", "(", "1", ")"}], "2"]}], "+", 
   RowBox[{
    SuperscriptBox["cm", "4"], " ", 
    SuperscriptBox[
     RowBox[{"M", "(", "2", ")"}], "2"]}], "+", 
   RowBox[{
    SuperscriptBox["cm", "4"], " ", 
    SuperscriptBox[
     RowBox[{"M", "(", "3", ")"}], "2"]}], "+", 
   FractionBox[
    RowBox[{
     SuperscriptBox["\[Kappa]", "4"], " ", 
     SuperscriptBox[
      RowBox[{"J", "(", "1", ")"}], "2"]}], 
    SuperscriptBox["\[Rho]", "2"]], "+", 
   FractionBox[
    RowBox[{
     SuperscriptBox["\[Kappa]", "4"], " ", 
     SuperscriptBox[
      RowBox[{"J", "(", "2", ")"}], "2"]}], 
    SuperscriptBox["\[Rho]", "2"]], "+", 
   FractionBox[
    RowBox[{
     SuperscriptBox["\[Kappa]", "4"], " ", 
     SuperscriptBox[
      RowBox[{"J", "(", "3", ")"}], "2"]}], 
    SuperscriptBox["\[Rho]", "2"]]}], TraditionalForm]], "Output",
 CellChangeTimes->{3.9151266768291683`*^9},
 CellLabel->"Out[42]=",ExpressionUUID->"2d55abb5-a28e-4df3-a620-435ab08dc7e5"]
}, Open  ]]
},
WindowSize->{1110, 600},
WindowMargins->{{Automatic, 0}, {0, Automatic}},
Magnification:>0.75,
FrontEndVersion->"13.0 for Linux x86 (64-bit) (February 4, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"1ddcd40d-6af7-46e8-9a18-5bbb543660a2"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 25181, 654, 1455, "Input",ExpressionUUID->"072bc278-3806-48b6-acfb-1b4644fc6cc6"],
Cell[25764, 678, 527, 12, 22, "Message",ExpressionUUID->"f1968c9f-1fd0-4e5d-b7ed-c48ad986ab37"],
Cell[26294, 692, 564, 12, 22, "Message",ExpressionUUID->"9b02d51f-62ba-4557-be15-68b06d3bfcac"],
Cell[26861, 706, 571, 16, 52, "Output",ExpressionUUID->"2a8ec371-913b-483b-aeff-818f4e563bb9"],
Cell[27435, 724, 574, 12, 22, "Message",ExpressionUUID->"167559c9-984a-492f-80be-dbfe012fdea1"],
Cell[28012, 738, 284, 6, 25, "Output",ExpressionUUID->"09f7c051-9bde-4773-94d2-e57ce728d56f"],
Cell[28299, 746, 527, 12, 22, "Message",ExpressionUUID->"8cd36373-c805-4146-a9b8-1f7866799942"],
Cell[28829, 760, 527, 12, 22, "Message",ExpressionUUID->"c22ebd9c-865c-43b9-8cfd-6cc975e9ea8a"],
Cell[29359, 774, 564, 12, 22, "Message",ExpressionUUID->"4ece41c7-e223-4971-8e63-bdc01958b671"],
Cell[29926, 788, 513, 12, 22, "Message",ExpressionUUID->"5445e808-a5f1-4c10-b274-799b855cc7ed"],
Cell[30442, 802, 210, 4, 25, "Output",ExpressionUUID->"437a2672-5818-45ad-98c7-c49249463c0b"],
Cell[30655, 808, 1759, 54, 45, "Output",ExpressionUUID->"2d55abb5-a28e-4df3-a620-435ab08dc7e5"]
}, Open  ]]
}
]
*)

