(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15614,        406]
NotebookOptionsPosition[     15248,        391]
NotebookOutlinePosition[     15658,        408]
CellTagsIndexPosition[     15615,        405]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"Parameters", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AuxVars", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"DefineAux", ",", "HoldAll"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"DefinePar", ",", "HoldAll"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineAux", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"AppendTo", "[", 
     RowBox[{"AuxVars", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"HoldForm", "[", "a", "]"}], ",", 
        RowBox[{"HoldForm", "[", "b", "]"}]}], "}"}]}], "]"}], ";", " ", 
    RowBox[{"a", "=", "b"}], " ", ";"}], " ", ")"}]}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"DefinePar", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"AppendTo", "[", 
      RowBox[{"Parameters", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"HoldForm", "[", "a", "]"}], ",", 
         RowBox[{"HoldForm", "[", "b", "]"}]}], "}"}]}], "]"}], ";", " ", 
     RowBox[{"a", "=", "b"}], " ", ";"}], " ", ")"}]}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Definitions", " ", "of", " ", "the", " ", "Identity", " ", "matrix", " ", 
    "in", " ", "index", " ", "notation", " ", "and", " ", "with", " ", 
    SubscriptBox["Id", "n"], " ", "shortcut"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Delta]", "[", 
    RowBox[{"m_", ",", "n_"}], "]"}], "=", 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Delta]", 
    RowBox[{"m_", ",", "n_"}]], "=", 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["Id", "n_"], "=", 
    RowBox[{"IdentityMatrix", "[", "n", "]"}]}], ";"}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", " ", 
      RowBox[{"USER", " ", "INPUT"}]}], " ", "===", "===", "===", "===", "===",
      "===", "===", "===", "===", "===", "===", "===", "===", "===", "==="}], 
    "="}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
      "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", 
      RowBox[{"==", 
       RowBox[{"===", 
        RowBox[{"==", 
         RowBox[{
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
           "==="}]}]}]}]}]}], "="}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Spacedimemsion", " ", "and", " ", "Space", " ", "coordinates", " ", 
    "vector"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"spacedim", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], ";"}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"dims", "=", 
    RowBox[{
     RowBox[{"(", GridBox[{
        {"1"},
        {"1"},
        {"1"},
        {"1"},
        {"1"}
       }], ")"}], "/.", "unbracket"}]}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{
   "dimensions", " ", "of", " ", "the", " ", "corresponding", " ", 
    "variables", " ", "in", " ", "V", " ", "or", " ", "Q"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V1", "=", 
   RowBox[{"(", GridBox[{
      {"\[Rho]"},
      {"u"},
      {"\[Eta]"},
      {"w"},
      {"p"}
     }], ")"}]}], ";", " ", 
  RowBox[{"Q1", "=", 
   RowBox[{"(", GridBox[{
      {"\[Rho]"},
      {
       RowBox[{"\[Rho]", " ", "u", " "}]},
      {
       RowBox[{"\[Rho]", " ", "\[Eta]"}]},
      {
       RowBox[{" ", "w"}]},
      {"p"}
     }], ")"}]}], ";", 
  RowBox[{"F1", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"\[Rho]", " ", "u"}]},
      {
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[Rho]", "2"]}], "+", 
        RowBox[{"\[Rho]", " ", 
         SuperscriptBox["u", "2"]}], "+", 
        RowBox[{"\[Eta]", "/", "\[Alpha]"}], " ", "-", " ", 
        FractionBox[
         SuperscriptBox["\[Eta]", "2"], 
         RowBox[{"\[Alpha]", " ", "\[Rho]"}]]}]},
      {
       RowBox[{"\[Rho]", " ", "u", " ", "\[Eta]"}]},
      {
       RowBox[{
        FractionBox["p", 
         RowBox[{"2", " ", "\[Rho]"}]], "+", 
        RowBox[{"w", " ", "u"}]}]},
      {
       RowBox[{
        FractionBox["w", 
         RowBox[{"\[Rho]", " ", "\[Beta]"}]], "+", 
        RowBox[{"p", " ", "u"}]}]}
     }], ")"}]}], ";", 
  RowBox[{"B1", "=", 
   RowBox[{"(", GridBox[{
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"}
     }], ")"}]}], ";", 
  RowBox[{"S1", "=", 
   RowBox[{"(", GridBox[{
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"}
     }], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Vbasis", " ", "=", 
    RowBox[{"{", 
     RowBox[{"\[Rho]", ",", "u", ",", "\[Eta]", ",", "w", ",", "p"}], "}"}]}],
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"===", "===", "===", "===", 
    RowBox[{"==", " ", 
     RowBox[{"DO", " ", "NOT", " ", "TOUCH"}]}], "===", "===", "===", "===", "===",
     "===", "===", "===", "===", "===", "===", "==="}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", "=="}], "==="}], "=", 
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Number", " ", "of", " ", "Conservation", " ", "laws"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Neq", "=", 
    RowBox[{"Length", "[", "dims", "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Total", " ", "Number", " ", "of", " ", "scalar", " ", "equations"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ncl", "=", 
    RowBox[{"Total", "[", 
     RowBox[{"Map", "[", 
      RowBox[{"listProduct", ",", "dims"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ExFortFlux", "[", 
   RowBox[{"FortranFile", ",", "EQNnumber", ",", "ModelDescription"}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Store", " ", "Here", " ", "the", " ", "PDE", " ", "in", " ", "its", " ", 
    "unevaluated", " ", "Form", " ", "for", " ", "a", " ", "more", " ", 
    "compressed", " ", "output", " ", "of", " ", "the", " ", "system"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Vprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"V1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"Qprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"Q1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"Fprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"F1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"Bprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"B1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"ii", ",", "1", ",", 
      RowBox[{
       RowBox[{"Dimensions", "[", "V1", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", 
      RowBox[{"==", "==="}]}]}], "=", 
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", "=="}], "==="}], "=", 
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Define", " ", "Here", " ", "auxiliary", " ", "Parameters"}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"DefineAux", "[", 
    RowBox[{"\[Nu]m", ",", 
     RowBox[{
      FractionBox["1", "6"], 
      SuperscriptBox["cs", "2"], "\[Tau]1"}]}], "]"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "ENERGY", " ", "TERMS", " ", "FOR", " ", "ENERGY", " ", "HESSIAN"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "IF", " ", "NOT", " ", "REQUIRED", " ", "SET", " ", "\[ScriptCapitalE]"}],
     "=", "0"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[ScriptCapitalE]", "=", "0"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "IF", " ", "NOT", " ", "REQUIRED", " ", "SET", " ", "\[ScriptCapitalE]"}],
     "=", "0"}], "*)"}], "\[IndentingNewLine]"}]}], "Input",
 CellChangeTimes->{{3.883309450416586*^9, 3.8833094542303257`*^9}, {
   3.883315862139411*^9, 3.883315863389764*^9}, {3.883386161206704*^9, 
   3.883386162008535*^9}, {3.8833871781798887`*^9, 3.883387178685625*^9}, {
   3.883387394815304*^9, 3.8833873966458797`*^9}, {3.883387480860487*^9, 
   3.883387482969985*^9}, {3.88345425622582*^9, 3.8834542641795387`*^9}, {
   3.883455131991022*^9, 3.883455163561852*^9}, {3.883455201151412*^9, 
   3.883455221429077*^9}, 3.883455912273836*^9, {3.883462469879867*^9, 
   3.883462500240234*^9}, {3.883462541649537*^9, 3.883462587477997*^9}, {
   3.883462672636397*^9, 3.883462741298012*^9}, {3.883462799275103*^9, 
   3.88346282573549*^9}, {3.8834628739797907`*^9, 3.8834628981286497`*^9}, {
   3.8834629938203773`*^9, 3.883462996686228*^9}, {3.883463050194509*^9, 
   3.8834630661753893`*^9}, {3.883463099888364*^9, 3.883463169936715*^9}, {
   3.883476177662264*^9, 3.88347619571194*^9}, {3.883476455583027*^9, 
   3.8834764559476633`*^9}, 3.88347649016092*^9, 3.883537843001994*^9, 
   3.883537897636313*^9, {3.8835512454343452`*^9, 3.88355125775187*^9}, {
   3.883583993255147*^9, 3.8835839939247293`*^9}, 3.883584061304842*^9, {
   3.883584139674806*^9, 3.883584139962237*^9}, {3.883584577193437*^9, 
   3.883584590321558*^9}, {3.8835846435474653`*^9, 3.883584645142524*^9}, {
   3.8835847352325287`*^9, 3.8835847517224092`*^9}, 3.8835848332086983`*^9, 
   3.883585251328164*^9, {3.883585400974671*^9, 3.883585519862219*^9}, {
   3.883585781932383*^9, 3.883585884990089*^9}, {3.883585917517017*^9, 
   3.883585966411292*^9}, {3.88358599812764*^9, 3.8835860065873327`*^9}, {
   3.8835860691646843`*^9, 3.883586094008565*^9}, {3.8835861470603724`*^9, 
   3.883586176494595*^9}, {3.883586239269854*^9, 3.883586243902503*^9}, {
   3.883586282477906*^9, 3.8835863425450172`*^9}, {3.883586798606513*^9, 
   3.883586813546867*^9}, {3.883741501712129*^9, 3.8837415430073643`*^9}, 
   3.883741656721099*^9, 3.884075226224948*^9, {3.884075942802906*^9, 
   3.884075979281261*^9}, {3.884076054193276*^9, 3.8840760566787977`*^9}, {
   3.88408071152608*^9, 3.884080721236438*^9}, {3.8840815812230053`*^9, 
   3.884081591942626*^9}, 3.884081629270492*^9, {3.884081693604508*^9, 
   3.884081727497581*^9}, {3.884081964241016*^9, 3.884081969918563*^9}, {
   3.884082895222664*^9, 3.884082950941317*^9}, {3.884085524373637*^9, 
   3.884085531269445*^9}, {3.884085724055375*^9, 3.884085756994401*^9}, {
   3.8840875699662247`*^9, 3.884087614299426*^9}, {3.884087644357314*^9, 
   3.8840876805205097`*^9}, {3.884087717598378*^9, 3.884087776000772*^9}, {
   3.884087871807807*^9, 3.884087873804613*^9}, {3.884088001571351*^9, 
   3.884088088454328*^9}, {3.884088232485248*^9, 3.884088241005189*^9}, {
   3.8840891811319113`*^9, 3.884089224868618*^9}, {3.884089286892557*^9, 
   3.884089289308399*^9}, {3.884089334511002*^9, 3.88408933713188*^9}, {
   3.884160916483892*^9, 3.884160917459209*^9}, {3.884348749833353*^9, 
   3.884348753911066*^9}, {3.884422952077368*^9, 3.8844229531288433`*^9}, {
   3.884423840414816*^9, 3.884423939506588*^9}, {3.884423970816545*^9, 
   3.88442397198208*^9}, {3.884428841643631*^9, 3.884428904407659*^9}, {
   3.884429824696764*^9, 3.8844298455987263`*^9}, {3.8844300013308563`*^9, 
   3.884430004951578*^9}, {3.884430574821549*^9, 3.884430580013459*^9}, {
   3.8844308959359493`*^9, 3.884430896855619*^9}, {3.884430959853492*^9, 
   3.884430965259444*^9}, {3.884431070881558*^9, 3.8844310710495358`*^9}, {
   3.8844311077113934`*^9, 3.884431119160844*^9}, {3.88443115181837*^9, 
   3.8844311976174803`*^9}, {3.88443155053904*^9, 3.884431553736405*^9}, {
   3.884833554327814*^9, 3.8848335709686937`*^9}, 3.884835075499333*^9, {
   3.8848352724035683`*^9, 3.8848353103149443`*^9}, {3.884838793875622*^9, 
   3.884838833859228*^9}, {3.884838880976522*^9, 3.884838884676283*^9}, {
   3.884840791694747*^9, 3.884840794571928*^9}, {3.884840880352096*^9, 
   3.884841077964178*^9}, {3.884841346306061*^9, 3.88484134656704*^9}, {
   3.884841573742683*^9, 3.884841574022451*^9}, {3.884841727728051*^9, 
   3.884841729893166*^9}, {3.884843446518113*^9, 3.884843448636511*^9}, {
   3.88492106628533*^9, 3.884921069238624*^9}, {3.884926146239305*^9, 
   3.8849261634953127`*^9}, {3.885531014901162*^9, 3.885531247823125*^9}, {
   3.885531279512285*^9, 3.88553130900738*^9}, 
   3.885531641138577*^9},ExpressionUUID->"072bc278-3806-48b6-acfb-\
1b4644fc6cc6"]
},
WindowSize->{2478, 1311},
WindowMargins->{{Automatic, 0}, {0, Automatic}},
Magnification:>1.75,
FrontEndVersion->"12.3 for Linux x86 (64-bit) (July 9, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"1ddcd40d-6af7-46e8-9a18-5bbb543660a2"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 14686, 369, 2334, "Input",ExpressionUUID->"072bc278-3806-48b6-acfb-1b4644fc6cc6"]
}
]
*)

