(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     29323,        758]
NotebookOptionsPosition[     28521,        735]
NotebookOutlinePosition[     28918,        752]
CellTagsIndexPosition[     28875,        749]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"Parameters", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AuxVars", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"DefineAux", ",", "HoldAll"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"DefinePar", ",", "HoldAll"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineAux", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"AppendTo", "[", 
     RowBox[{"AuxVars", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"HoldForm", "[", "a", "]"}], ",", 
        RowBox[{"HoldForm", "[", "b", "]"}]}], "}"}]}], "]"}], ";", " ", 
    RowBox[{"a", "=", "b"}], " ", ";"}], " ", ")"}]}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"DefinePar", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"AppendTo", "[", 
      RowBox[{"Parameters", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"HoldForm", "[", "a", "]"}], ",", 
         RowBox[{"HoldForm", "[", "b", "]"}]}], "}"}]}], "]"}], ";", " ", 
     RowBox[{"a", "=", "b"}], " ", ";"}], " ", ")"}]}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Definitions", " ", "of", " ", "the", " ", "Identity", " ", "matrix", " ", 
    "in", " ", "index", " ", "notation", " ", "and", " ", "with", " ", 
    SubscriptBox["Id", "n"], " ", "shortcut"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Delta]", "[", 
    RowBox[{"m_", ",", "n_"}], "]"}], "=", 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Delta]", 
    RowBox[{"m_", ",", "n_"}]], "=", 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Epsilon]", 
    RowBox[{"m_", ",", "n_", ",", "l_"}]], "=", 
   RowBox[{"Signature", "[", 
    RowBox[{"{", 
     RowBox[{"m", ",", "n", ",", "l"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["Id", "n_"], "=", 
    RowBox[{"IdentityMatrix", "[", "n", "]"}]}], ";"}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", " ", 
      RowBox[{"USER", " ", "INPUT"}]}], " ", "===", "===", "===", "===", "===",
      "===", "===", "===", "===", "===", "===", "===", "===", "===", "==="}], 
    "="}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "===", "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
      "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", 
      RowBox[{"==", 
       RowBox[{"===", 
        RowBox[{"==", 
         RowBox[{
         "===", "===", "===", "===", "===", "===", "===", "===", "===", "===",
           "==="}]}]}]}]}]}], "="}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Spacedimemsion", " ", "and", " ", "Space", " ", "coordinates", " ", 
    "vector"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"spacedim", "=", "d"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dims", "=", 
   RowBox[{
    RowBox[{"(", GridBox[{
       {"1"},
       {"1"},
       {"1"},
       {"d"},
       {"d"},
       {"d"}
      }], ")"}], "/.", "unbracket"}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{
   "dimensions", " ", "of", " ", "the", " ", "corresponding", " ", 
    "variables", " ", "in", " ", "V", " ", "or", " ", "Q"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"V1", "=", 
   RowBox[{"(", GridBox[{
      {"\[Alpha]1"},
      {"\[Rho]1"},
      {"\[Rho]2"},
      {
       SubscriptBox["u1", "i"]},
      {
       SubscriptBox["u2", "i"]},
      {
       SubscriptBox["\[Psi]", "i"]}
     }], ")"}]}], ";", " ", 
  RowBox[{"Q1", "=", 
   RowBox[{"(", GridBox[{
      {"\[Alpha]1"},
      {
       RowBox[{"\[Alpha]1", " ", "\[Rho]1"}]},
      {
       RowBox[{"\[Alpha]2", " ", "\[Rho]2"}]},
      {
       RowBox[{
        RowBox[{"\[Alpha]1", " ", "\[Rho]1", " ", 
         SubscriptBox["u1", "i"]}], " ", "+", " ", 
        RowBox[{"\[Alpha]2", " ", "\[Rho]2", " ", 
         SubscriptBox["u2", "i"]}]}]},
      {
       RowBox[{
        SubscriptBox["u1", "i"], "-", 
        SubscriptBox["u2", "i"]}]},
      {
       SubscriptBox["\[Psi]", "i"]}
     }], ")"}]}], ";", 
  RowBox[{"F1", "=", 
   RowBox[{"(", GridBox[{
      {"0"},
      {
       RowBox[{"\[Alpha]1", " ", "\[Rho]1", " ", 
        SubscriptBox["u1", "k"]}]},
      {
       RowBox[{"\[Alpha]2", " ", "\[Rho]2", " ", 
        SubscriptBox["u2", "k"]}]},
      {
       RowBox[{
        RowBox[{"\[Alpha]1", " ", "\[Rho]1", " ", 
         SubscriptBox["u1", "i"], 
         SubscriptBox["u1", "k"]}], "+", 
        RowBox[{"\[Alpha]2", " ", "\[Rho]2", " ", 
         SubscriptBox["u2", "i"], 
         SubscriptBox["u2", "k"]}], " ", "+", " ", 
        RowBox[{"P", " ", 
         SubscriptBox["\[Delta]", 
          RowBox[{"i", ",", "k"}]]}]}]},
      {
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            FractionBox["1", "2"], 
            SubscriptBox["u1", "l"], " ", 
            SubscriptBox["u1", "l"]}], " ", "-", " ", 
           RowBox[{
            FractionBox["1", "2"], 
            SubscriptBox["u2", "l"], " ", 
            SubscriptBox["u2", "l"]}], "+", 
           RowBox[{
            FractionBox[
             SuperscriptBox["\[Rho]1", 
              RowBox[{"\[Gamma]1", "-", "1"}]], 
             RowBox[{"\[Gamma]1", "-", "1"}]], "k1"}], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["\[Rho]1", "\[Gamma]1"], " ", "k1"}], "\[Rho]1"], 
           " ", "-", " ", 
           RowBox[{
            FractionBox[
             SuperscriptBox["\[Rho]2", 
              RowBox[{"\[Gamma]2", "-", "1"}]], 
             RowBox[{"\[Gamma]2", "-", "1"}]], "k2"}], "-", 
           FractionBox[
            RowBox[{
             SuperscriptBox["\[Rho]2", "\[Gamma]2"], " ", "k2"}], 
            "\[Rho]2"]}], "/.", 
          RowBox[{"Einstein", "[", "d", "]"}]}], ")"}], " ", 
        SubscriptBox["\[Delta]", 
         RowBox[{"i", ",", "k"}]]}]},
      {"0"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B1", "=", 
    RowBox[{"(", GridBox[{
       {
        RowBox[{
         UnderoverscriptBox["\[Sum]", 
          RowBox[{"m", "=", "1"}], 
          RowBox[{"dims", "[", 
           RowBox[{"[", "4", "]"}], "]"}]], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"c1", " ", 
             SubscriptBox["u1", "m"]}], " ", "+", " ", 
            RowBox[{"c2", " ", 
             SubscriptBox["u2", "m"]}]}], ")"}], " ", 
          RowBox[{"pd", "[", 
           RowBox[{"\[Alpha]1", ",", 
            SubscriptBox["x", "m"]}], "]"}]}]}]},
       {"0"},
       {"0"},
       {"0"},
       {
        RowBox[{
         RowBox[{
          UnderoverscriptBox["\[Sum]", 
           RowBox[{"m", "=", "1"}], 
           RowBox[{"dims", "[", 
            RowBox[{"[", "5", "]"}], "]"}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"c1", " ", 
              SubscriptBox["u1", "m"]}], " ", "+", " ", 
             RowBox[{"c2", " ", 
              SubscriptBox["u2", "m"]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"pd", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["u1", "i"], "-", 
                 SubscriptBox["u2", "i"]}], ")"}], ",", 
               SubscriptBox["x", "m"]}], "]"}], "-", 
             RowBox[{"pd", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["u1", "m"], "-", 
                 SubscriptBox["u2", "m"]}], ")"}], ",", 
               SubscriptBox["x", "i"]}], "]"}]}], ")"}]}]}], "+", 
         RowBox[{
          UnderoverscriptBox["\[Sum]", 
           RowBox[{"m", "=", "1"}], "3"], 
          RowBox[{
           UnderoverscriptBox["\[Sum]", 
            RowBox[{"l", "=", "1"}], "3"], 
           RowBox[{"ac", " ", 
            SubscriptBox["\[Epsilon]", 
             RowBox[{"i", ",", "m", ",", "l"}]], 
            RowBox[{"pd", "[", 
             RowBox[{
              SubscriptBox["\[Psi]", "l"], ",", 
              SubscriptBox["x", "m"]}], "]"}]}]}]}]}]},
       {
        RowBox[{
         RowBox[{
          UnderoverscriptBox["\[Sum]", 
           RowBox[{"m", "=", "1"}], "d"], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"c1", " ", 
              SubscriptBox["u1", "m"]}], " ", "+", " ", 
             RowBox[{"c2", " ", 
              SubscriptBox["u2", "m"]}]}], ")"}], " ", 
           RowBox[{"pd", "[", 
            RowBox[{
             SubscriptBox["\[Psi]", "i"], ",", 
             SubscriptBox["x", "m"]}], "]"}]}]}], "-", 
         RowBox[{
          UnderoverscriptBox["\[Sum]", 
           RowBox[{"m", "=", "1"}], "3"], 
          RowBox[{
           UnderoverscriptBox["\[Sum]", 
            RowBox[{"l", "=", "1"}], "3"], 
           RowBox[{"ac", " ", 
            SubscriptBox["\[Epsilon]", 
             RowBox[{"i", ",", "m", ",", "l"}]], 
            RowBox[{"pd", "[", 
             RowBox[{
              RowBox[{
               SubscriptBox["u1", "l"], "-", 
               SubscriptBox["u2", "l"]}], ",", 
              SubscriptBox["x", "m"]}], "]"}]}]}]}]}]}
      }], ")"}]}], ";", 
   RowBox[{"S1", "=", 
    RowBox[{"(", GridBox[{
       {"0"},
       {"0"},
       {"0"},
       {"0"},
       {"0"},
       {"0"}
      }], ")"}]}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"d", "==", "1"}], ",", 
   RowBox[{
    RowBox[{"Vbasis", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]1", ",", " ", "\[Rho]1", ",", " ", "\[Rho]2", ",", " ", 
       SubscriptBox["u1", "1"], ",", " ", 
       SubscriptBox["u2", "1"]}], "}"}]}], ";"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"d", "==", "2"}], ",", 
   RowBox[{
    RowBox[{"Vbasis", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]1", ",", " ", "\[Rho]1", ",", " ", "\[Rho]2", ",", " ", 
       SubscriptBox["u1", "1"], ",", " ", 
       SubscriptBox["u1", "2"], ",", " ", 
       SubscriptBox["u2", "1"], ",", " ", 
       SubscriptBox["u2", "2"]}], "}"}]}], ";"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"d", "==", "3"}], ",", 
    RowBox[{
     RowBox[{"Vbasis", " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{
       "\[Alpha]1", ",", " ", "\[Rho]1", ",", " ", "\[Rho]2", ",", " ", 
        SubscriptBox["u1", "1"], ",", " ", 
        SubscriptBox["u1", "2"], ",", " ", 
        SubscriptBox["u1", "3"], ",", " ", 
        SubscriptBox["u2", "1"], ",", " ", 
        SubscriptBox["u2", "2"], ",", " ", 
        SubscriptBox["u2", "3"]}], "}"}]}], ";"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Vbasis", " ", "=", "  ", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]1", ",", " ", "\[Rho]1", ",", " ", "\[Rho]2", ",", " ", 
     FractionBox[
      RowBox[{
       RowBox[{"\[Alpha]1", " ", "\[Rho]1", " ", 
        SubscriptBox["u1", "1"]}], "+", 
       RowBox[{"\[Alpha]2", " ", "\[Rho]2", " ", 
        SubscriptBox["u2", "1"]}]}], 
      RowBox[{
       RowBox[{"\[Alpha]1", " ", "\[Rho]1"}], " ", "+", " ", 
       RowBox[{"\[Alpha]2", " ", "\[Rho]2", " "}]}]], ",", "  ", 
     FractionBox[
      RowBox[{
       RowBox[{"\[Alpha]1", " ", "\[Rho]1", " ", 
        SubscriptBox["u1", "2"]}], "+", 
       RowBox[{"\[Alpha]2", " ", "\[Rho]2", " ", 
        SubscriptBox["u2", "2"]}]}], 
      RowBox[{
       RowBox[{"\[Alpha]1", " ", "\[Rho]1"}], " ", "+", " ", 
       RowBox[{"\[Alpha]2", " ", "\[Rho]2", " "}]}]], ",", "  ", 
     FractionBox[
      RowBox[{
       RowBox[{"\[Alpha]1", " ", "\[Rho]1", " ", 
        SubscriptBox["u1", "3"]}], "+", 
       RowBox[{"\[Alpha]2", " ", "\[Rho]2", " ", 
        SubscriptBox["u2", "3"]}]}], 
      RowBox[{
       RowBox[{"\[Alpha]1", " ", "\[Rho]1"}], " ", "+", " ", 
       RowBox[{"\[Alpha]2", " ", "\[Rho]2", " "}]}]], ",", " ", 
     RowBox[{
      SubscriptBox["u1", "1"], "-", 
      SubscriptBox["u2", "1"]}], ",", 
     RowBox[{
      SubscriptBox["u1", "2"], "-", " ", 
      SubscriptBox["u2", "2"]}], ",", 
     RowBox[{
      SubscriptBox["u1", "3"], "-", " ", 
      SubscriptBox["u2", "3"]}], ",", 
     SubscriptBox["\[Psi]", "1"], ",", 
     SubscriptBox["\[Psi]", "2"], ",", 
     SubscriptBox["\[Psi]", "3"]}], "}"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"===", "===", "===", "===", 
    RowBox[{"==", " ", 
     RowBox[{"DO", " ", "NOT", " ", "TOUCH"}]}], "===", "===", "===", "===", "===",
     "===", "===", "===", "===", "===", "===", "==="}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", "=="}], "==="}], "=", 
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Number", " ", "of", " ", "Conservation", " ", "laws"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Neq", "=", 
    RowBox[{"Length", "[", "dims", "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Total", " ", "Number", " ", "of", " ", "scalar", " ", "equations"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ncl", "=", 
    RowBox[{"Total", "[", 
     RowBox[{"Map", "[", 
      RowBox[{"listProduct", ",", "dims"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ExFortFlux", "[", 
   RowBox[{"FortranFile", ",", "EQNnumber", ",", "ModelDescription"}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Store", " ", "Here", " ", "the", " ", "PDE", " ", "in", " ", "its", " ", 
    "unevaluated", " ", "Form", " ", "for", " ", "a", " ", "more", " ", 
    "compressed", " ", "output", " ", "of", " ", "the", " ", "system"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Vprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"V1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"Qprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"Q1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"Fprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"F1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}], ";", "\[IndentingNewLine]", "    ", 
     RowBox[{
      RowBox[{"Bprint", "[", "ii", "]"}], "=", 
      RowBox[{
       RowBox[{"HoldForm", "[", 
        RowBox[{"Evaluate", "[", 
         RowBox[{
          RowBox[{"B1", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "//", "Esthetic"}], "]"}], "]"}], 
       "/.", "unbracket"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"ii", ",", "1", ",", 
      RowBox[{
       RowBox[{"Dimensions", "[", "V1", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", 
      RowBox[{"==", "==="}]}]}], "=", 
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "===", "===", "===", 
     RowBox[{"==", "=="}], "==="}], "=", 
    RowBox[{"===", "===", "===", "===", "===", "===", "===", "==="}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Define", " ", "Here", " ", "auxiliary", " ", "Parameters"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EOS", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[Rho]", "\[Gamma]"], "/", 
      RowBox[{"(", 
       RowBox[{"\[Gamma]", "-", "1"}], ")"}]}], ")"}], 
    RowBox[{"Exp", "[", 
     FractionBox["S", "cv"], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]", " ", "=", " ", 
   RowBox[{
    RowBox[{"\[Alpha]1", " ", "\[Rho]1"}], " ", "+", " ", 
    RowBox[{"\[Alpha]2", " ", "\[Rho]2"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"P1", " ", "=", " ", 
   RowBox[{
    SuperscriptBox["\[Rho]1", "\[Gamma]1"], " ", "k1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"P2", " ", "=", " ", 
   RowBox[{
    SuperscriptBox["\[Rho]2", "\[Gamma]2"], " ", "k2"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"P", " ", "=", " ", 
   RowBox[{
    RowBox[{"\[Alpha]1", " ", "P1"}], " ", "+", " ", 
    RowBox[{"\[Alpha]2", " ", "P2"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Alpha]2", " ", "=", " ", 
   RowBox[{"1", "-", "\[Alpha]1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"c1", " ", "=", " ", 
    FractionBox[
     RowBox[{"\[Alpha]1", " ", "\[Rho]1", " "}], "\[Rho]"]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"c2", " ", "=", " ", 
     FractionBox[
      RowBox[{"\[Alpha]2", " ", "\[Rho]2", " "}], "\[Rho]"]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"c2", " ", "=", " ", 
    RowBox[{"1", "-", "c1"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "ENERGY", " ", "TERMS", " ", "FOR", " ", "ENERGY", " ", "HESSIAN"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "IF", " ", "NOT", " ", "REQUIRED", " ", "SET", " ", "\[ScriptCapitalE]"}],
     "=", "0"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[ScriptCapitalE]", "=", "0"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "IF", " ", "NOT", " ", "REQUIRED", " ", "SET", " ", "\[ScriptCapitalE]"}],
     "=", "0"}], "*)"}], "\[IndentingNewLine]"}]}], "Input",
 CellChangeTimes->{{3.883309450416586*^9, 3.8833094542303257`*^9}, {
   3.883315862139411*^9, 3.883315863389764*^9}, {3.883386161206704*^9, 
   3.883386162008535*^9}, {3.8833871781798887`*^9, 3.883387178685625*^9}, {
   3.883387394815304*^9, 3.8833873966458797`*^9}, {3.883387480860487*^9, 
   3.883387482969985*^9}, {3.88345425622582*^9, 3.8834542641795387`*^9}, {
   3.883455131991022*^9, 3.883455163561852*^9}, {3.883455201151412*^9, 
   3.883455221429077*^9}, 3.883455912273836*^9, {3.883462469879867*^9, 
   3.883462500240234*^9}, {3.883462541649537*^9, 3.883462587477997*^9}, {
   3.883462672636397*^9, 3.883462741298012*^9}, {3.883462799275103*^9, 
   3.88346282573549*^9}, {3.8834628739797907`*^9, 3.8834628981286497`*^9}, {
   3.8834629938203773`*^9, 3.883462996686228*^9}, {3.883463050194509*^9, 
   3.8834630661753893`*^9}, {3.883463099888364*^9, 3.883463169936715*^9}, {
   3.883476177662264*^9, 3.88347619571194*^9}, {3.883476455583027*^9, 
   3.8834764559476633`*^9}, 3.88347649016092*^9, 3.883537843001994*^9, 
   3.883537897636313*^9, {3.8835512454343452`*^9, 3.88355125775187*^9}, {
   3.883583993255147*^9, 3.8835839939247293`*^9}, 3.883584061304842*^9, {
   3.883584139674806*^9, 3.883584139962237*^9}, {3.883584577193437*^9, 
   3.883584590321558*^9}, {3.8835846435474653`*^9, 3.883584645142524*^9}, {
   3.8835847352325287`*^9, 3.8835847517224092`*^9}, 3.8835848332086983`*^9, 
   3.883585251328164*^9, {3.883585400974671*^9, 3.883585519862219*^9}, {
   3.883585781932383*^9, 3.883585884990089*^9}, {3.883585917517017*^9, 
   3.883585966411292*^9}, {3.88358599812764*^9, 3.8835860065873327`*^9}, {
   3.8835860691646843`*^9, 3.883586094008565*^9}, {3.8835861470603724`*^9, 
   3.883586176494595*^9}, {3.883586239269854*^9, 3.883586243902503*^9}, {
   3.883586282477906*^9, 3.8835863425450172`*^9}, {3.883586798606513*^9, 
   3.883586813546867*^9}, {3.883741501712129*^9, 3.8837415430073643`*^9}, 
   3.883741656721099*^9, 3.884075226224948*^9, {3.884075942802906*^9, 
   3.884075979281261*^9}, {3.884076054193276*^9, 3.8840760566787977`*^9}, {
   3.88408071152608*^9, 3.884080721236438*^9}, {3.8840815812230053`*^9, 
   3.884081591942626*^9}, 3.884081629270492*^9, {3.884081693604508*^9, 
   3.884081727497581*^9}, {3.884081964241016*^9, 3.884081969918563*^9}, {
   3.884082895222664*^9, 3.884082950941317*^9}, {3.884085524373637*^9, 
   3.884085531269445*^9}, {3.884085724055375*^9, 3.884085756994401*^9}, {
   3.8840875699662247`*^9, 3.884087614299426*^9}, {3.884087644357314*^9, 
   3.8840876805205097`*^9}, {3.884087717598378*^9, 3.884087776000772*^9}, {
   3.884087871807807*^9, 3.884087873804613*^9}, {3.884088001571351*^9, 
   3.884088088454328*^9}, {3.884088232485248*^9, 3.884088241005189*^9}, {
   3.8840891811319113`*^9, 3.884089224868618*^9}, {3.884089286892557*^9, 
   3.884089289308399*^9}, {3.884089334511002*^9, 3.88408933713188*^9}, {
   3.884160916483892*^9, 3.884160917459209*^9}, {3.884348749833353*^9, 
   3.884348753911066*^9}, {3.884422952077368*^9, 3.8844229531288433`*^9}, {
   3.884423840414816*^9, 3.884423939506588*^9}, {3.884423970816545*^9, 
   3.88442397198208*^9}, {3.884428841643631*^9, 3.884428904407659*^9}, {
   3.884429824696764*^9, 3.8844298455987263`*^9}, {3.8844300013308563`*^9, 
   3.884430004951578*^9}, {3.884430574821549*^9, 3.884430580013459*^9}, {
   3.8844308959359493`*^9, 3.884430896855619*^9}, {3.884430959853492*^9, 
   3.884430965259444*^9}, {3.884431070881558*^9, 3.8844310710495358`*^9}, {
   3.8844311077113934`*^9, 3.884431119160844*^9}, {3.88443115181837*^9, 
   3.8844311976174803`*^9}, {3.88443155053904*^9, 3.884431553736405*^9}, {
   3.884833554327814*^9, 3.8848335709686937`*^9}, 3.884835075499333*^9, {
   3.8848352724035683`*^9, 3.8848353103149443`*^9}, {3.884838793875622*^9, 
   3.884838833859228*^9}, {3.884838880976522*^9, 3.884838884676283*^9}, {
   3.884840791694747*^9, 3.884840794571928*^9}, {3.884840880352096*^9, 
   3.884841077964178*^9}, {3.884841346306061*^9, 3.88484134656704*^9}, {
   3.884841573742683*^9, 3.884841574022451*^9}, {3.884841727728051*^9, 
   3.884841729893166*^9}, {3.884843446518113*^9, 3.884843448636511*^9}, {
   3.88492106628533*^9, 3.884921069238624*^9}, {3.884926146239305*^9, 
   3.8849261634953127`*^9}, {3.885619745905614*^9, 3.8856197461531563`*^9}, {
   3.88561988443559*^9, 3.885619884585958*^9}, {3.885636422853058*^9, 
   3.88563642989979*^9}, {3.886153055412478*^9, 3.886153071112694*^9}, 
   3.8862491979175797`*^9, {3.886392751853512*^9, 3.8863928049132357`*^9}, 
   3.8863928560289154`*^9, {3.886392898606963*^9, 3.8863929363173275`*^9}, {
   3.886393133156703*^9, 3.8863931940348053`*^9}, {3.886393383021758*^9, 
   3.886393457008348*^9}, {3.886393578273904*^9, 3.8863938240551376`*^9}, {
   3.8863938724376493`*^9, 3.8863940855376177`*^9}, {3.8863941227242975`*^9, 
   3.8863943220781703`*^9}, 3.886394372714872*^9, {3.8863944634740844`*^9, 
   3.886394466216759*^9}, {3.8863945041400795`*^9, 3.886394581633766*^9}, {
   3.8863948010331707`*^9, 3.8863948276735272`*^9}, {3.8863949212356424`*^9, 
   3.8863951294010773`*^9}, 3.8863954517522664`*^9, {3.886395615909421*^9, 
   3.8863957135486593`*^9}, {3.8863963050230274`*^9, 
   3.8863963632078805`*^9}, {3.8863969789229813`*^9, 
   3.8863969796071177`*^9}, {3.886581028766797*^9, 3.8865810311363854`*^9}, {
   3.886581234299863*^9, 3.8865812824399347`*^9}, {3.8865813477280397`*^9, 
   3.886581496072833*^9}, {3.8865817248220425`*^9, 3.886581750482113*^9}, {
   3.8865821691662273`*^9, 3.8865821710449944`*^9}, {3.8865822039005427`*^9, 
   3.8865822136367006`*^9}, {3.886582397651657*^9, 3.8865824181403065`*^9}, {
   3.8865824876397543`*^9, 3.8865825277467117`*^9}, {3.8865826819142747`*^9, 
   3.8865827477345295`*^9}, {3.886582820715806*^9, 3.8865828524218287`*^9}, {
   3.8865831227599325`*^9, 3.8865831236252923`*^9}, {3.8865831656337485`*^9, 
   3.8865831747382207`*^9}, {3.886583429995308*^9, 3.8865834434119773`*^9}, {
   3.8865834907253914`*^9, 3.8865834991204805`*^9}, {3.8865842442463875`*^9, 
   3.886584389619547*^9}, {3.8865872619135027`*^9, 3.886587263165388*^9}, {
   3.886588491045073*^9, 3.886588492679572*^9}, {3.8865902334368196`*^9, 
   3.8865902409706745`*^9}, {3.886594366733203*^9, 3.8865943747317033`*^9}, {
   3.886595585376345*^9, 3.8865955858242035`*^9}, {3.8865957925468206`*^9, 
   3.8865957944785075`*^9}, 3.886647854818707*^9, {3.886648359695641*^9, 
   3.886648391534176*^9}, {3.886648429328733*^9, 3.8866484646553183`*^9}, {
   3.886648565743535*^9, 3.8866486107942867`*^9}, 3.886648652964768*^9, {
   3.886648780479545*^9, 3.886648846335621*^9}, {3.886648885444901*^9, 
   3.886648984557679*^9}, {3.8866490214372807`*^9, 3.886649059516355*^9}, {
   3.886649214838252*^9, 3.8866492549193563`*^9}, {3.886652974531258*^9, 
   3.8866531373621473`*^9}, {3.88665329633622*^9, 3.886653313171323*^9}, {
   3.886653369273882*^9, 3.88665337842518*^9}, {3.886655642264071*^9, 
   3.886655647323269*^9}, {3.886656022369248*^9, 3.8866560494901133`*^9}, {
   3.886656190288035*^9, 
   3.8866561972331038`*^9}},ExpressionUUID->"072bc278-3806-48b6-acfb-\
1b4644fc6cc6"],

Cell[BoxData[
 FormBox[
  TemplateBox[{
   "Part", "pkspec1", 
    "\"The expression \\!\\(\\*FormBox[\\\"m\\\", TraditionalForm]\\) cannot \
be used as a part specification.\"", 2, 208, 1, 34424332441483432869, "Local"},
   "MessageTemplate"], TraditionalForm]], "Message", "MSG",
 CellChangeTimes->{3.886582698253555*^9, 3.886648467756074*^9},
 CellLabel->
  "During evaluation of \
In[199]:=",ExpressionUUID->"12d03509-58dc-4018-8bb4-42f45bf32e59"],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}], TraditionalForm]], "Output",
 CellChangeTimes->{3.8863943335651493`*^9, 3.886582698283521*^9, 
  3.886648467809865*^9},
 CellLabel->
  "Out[214]=",ExpressionUUID->"19880e49-272c-461d-b21c-4e23875e3912"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 SubscriptBox["\[Epsilon]", 
  RowBox[{"1", ",", "2", ",", "3"}]]], "Input",
 CellChangeTimes->{{3.8866484716816072`*^9, 3.886648478947297*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"97aab8b3-9418-45d2-aca8-22ac3eed08ef"],

Cell[BoxData[
 FormBox["1", TraditionalForm]], "Output",
 CellChangeTimes->{{3.8866484755214443`*^9, 3.886648479342484*^9}},
 CellLabel->
  "Out[232]=",ExpressionUUID->"779b5ae7-d24b-4c3c-b9eb-de372257a025"]
}, Open  ]]
},
WindowSize->{2478, 1311},
WindowMargins->{{82, 0}, {0, 129}},
Magnification:>1.85,
FrontEndVersion->"12.3 for Linux x86 (64-bit) (July 9, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"1ddcd40d-6af7-46e8-9a18-5bbb543660a2"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 26336, 661, 3276, "Input",ExpressionUUID->"072bc278-3806-48b6-acfb-1b4644fc6cc6"],
Cell[26919, 685, 451, 10, 49, "Message",ExpressionUUID->"12d03509-58dc-4018-8bb4-42f45bf32e59"],
Cell[27373, 697, 648, 20, 194, "Output",ExpressionUUID->"19880e49-272c-461d-b21c-4e23875e3912"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28058, 722, 237, 4, 58, "Input",ExpressionUUID->"97aab8b3-9418-45d2-aca8-22ac3eed08ef"],
Cell[28298, 728, 207, 4, 59, "Output",ExpressionUUID->"779b5ae7-d24b-4c3c-b9eb-de372257a025"]
}, Open  ]]
}
]
*)

